(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[0],{

/***/ "./node_modules/format-number/index.js":
/*!*********************************************!*\
  !*** ./node_modules/format-number/index.js ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {


module.exports = formatter;
module.exports.default = formatter;

function formatter(options) {
  options = options || {};


  // *********************************************************************************************
  // Set defaults for negatives
  // options.negative, options.negativeOut, options.separator retained for backward compatibility
  // *********************************************************************************************

  // type of negative; default left
  options.negativeType = options.negativeType || (options.negative === 'R' ? 'right' : 'left')

  // negative symbols '-' or '()'
  if (typeof options.negativeLeftSymbol !== 'string') {
    switch (options.negativeType) {
      case 'left':
        options.negativeLeftSymbol = '-';
        break;
      case 'brackets':
        options.negativeLeftSymbol = '(';
        break;
      default:
        options.negativeLeftSymbol = '';
    }
  }
  if (typeof options.negativeRightSymbol !== 'string') {
    switch (options.negativeType) {
      case 'right':
        options.negativeRightSymbol = '-';
        break;
      case 'brackets':
        options.negativeRightSymbol = ')';
        break;
      default:
        options.negativeRightSymbol = '';
    }
  }

  // whether negative symbol should be inside/outside prefix and suffix

  if (typeof options.negativeLeftOut !== "boolean") {
    options.negativeLeftOut = (options.negativeOut === false ? false : true);
  }
  if (typeof options.negativeRightOut !== "boolean") {
    options.negativeRightOut = (options.negativeOut === false ? false : true);
  }

  //prefix and suffix
  options.prefix = options.prefix || '';
  options.suffix = options.suffix || '';

  //separators
  if (typeof options.integerSeparator !== 'string') {
    options.integerSeparator = (typeof options.separator === 'string' ? options.separator : ',');
  }
  options.decimalsSeparator = typeof options.decimalsSeparator === 'string' ? options.decimalsSeparator : '';
  options.decimal = options.decimal || '.';

  //padders
  options.padLeft = options.padLeft || -1 //default no padding
  options.padRight = options.padRight || -1 //default no padding

  function format(number, overrideOptions) {
    overrideOptions = overrideOptions || {};

    if (number || number === 0) {
      number = '' + number;//convert number to string if it isn't already
    } else {
      return '';
    }

    //identify a negative number and make it absolute
    var output = [];
    var negative = number.charAt(0) === '-';
    number = number.replace(/^\-/g, '');

    //Prepare output with left hand negative and/or prefix
    if (!options.negativeLeftOut && !overrideOptions.noUnits) {
      output.push(options.prefix);
    }
    if (negative) {
      output.push(options.negativeLeftSymbol);
    }
    if (options.negativeLeftOut && !overrideOptions.noUnits) {
      output.push(options.prefix);
    }

    //Format core number
    number = number.split('.');
    if (options.round != null) round(number, options.round);
    if (options.truncate != null) number[1] = truncate(number[1], options.truncate);
    if (options.padLeft > 0) number[0] = padLeft(number[0], options.padLeft);
    if (options.padRight > 0) number[1] = padRight(number[1], options.padRight);
    if (!overrideOptions.noSeparator && number[1]) number[1] = addDecimalSeparators(number[1], options.decimalsSeparator);
    if (!overrideOptions.noSeparator && number[0]) number[0] = addIntegerSeparators(number[0], options.integerSeparator);
    output.push(number[0]);
    if (number[1]) {
      output.push(options.decimal);
      output.push(number[1]);
    }

    //Prepare output with right hand negative and/or prefix
    if (options.negativeRightOut && !overrideOptions.noUnits) {
      output.push(options.suffix);
    }
    if (negative) {
      output.push(options.negativeRightSymbol);
    }
    if (!options.negativeRightOut && !overrideOptions.noUnits) {
      output.push(options.suffix);
    }

    //join output and return
    return output.join('');
  }

  format.negative = options.negative;
  format.negativeOut = options.negativeOut;
  format.negativeType = options.negativeType;
  format.negativeLeftOut = options.negativeLeftOut;
  format.negativeLeftSymbol = options.negativeLeftSymbol;
  format.negativeRightOut = options.negativeRightOut;
  format.negativeRightSymbol = options.negativeRightSymbol;
  format.prefix = options.prefix;
  format.suffix = options.suffix;
  format.separate = options.separate;
  format.integerSeparator = options.integerSeparator;
  format.decimalsSeparator = options.decimalsSeparator;
  format.decimal = options.decimal;
  format.padLeft = options.padLeft;
  format.padRight = options.padRight;
  format.truncate = options.truncate;
  format.round = options.round;

  function unformat(number, allowedSeparators) {
    allowedSeparators = allowedSeparators || [];
    if (options.allowedSeparators) {
      options.allowedSeparators.forEach(function (s) { allowedSeparators.push (s); });
    }
    allowedSeparators.push(options.integerSeparator);
    allowedSeparators.push(options.decimalsSeparator);
    number = number.replace(options.prefix, '');
    number = number.replace(options.suffix, '');
    var newNumber = number;
    do {
      number = newNumber;
      for (var i = 0; i < allowedSeparators.length; i++) {
        newNumber = newNumber.replace(allowedSeparators[i], '');
      }
    } while (newNumber != number);
    return number;
  }
  format.unformat = unformat;

  function validate(number, allowedSeparators) {
    number = unformat(number, allowedSeparators);
    number = number.split(options.decimal);
    if (number.length > 2) {
      return false;
    } else if (options.truncate != null && number[1] && number[1].length > options.truncate) {
      return false;
    }  else if (options.round != null && number[1] && number[1].length > options.round) {
      return false;
    } else {
      return /^-?\d+\.?\d*$/.test(number);
    }
  }
  return format;
}

//where x is already the integer part of the number
function addIntegerSeparators(x, separator) {
  x += '';
  if (!separator) return x;
  var rgx = /(\d+)(\d{3})/;
  while (rgx.test(x)) {
    x = x.replace(rgx, '$1' + separator + '$2');
  }
  return x;
}

//where x is already the decimal part of the number
function addDecimalSeparators(x, separator) {
  x += '';
  if (!separator) return x;
  var rgx = /(\d{3})(\d+)/;
  while (rgx.test(x)) {
    x = x.replace(rgx, '$1' + separator + '$2');
  }
  return x;
}

//where x is the integer part of the number
function padLeft(x, padding) {
  x = x + '';
  var buf = [];
  while (buf.length + x.length < padding) {
    buf.push('0');
  }
  return buf.join('') + x;
}

//where x is the decimals part of the number
function padRight(x, padding) {
  if (x) {
    x += '';
  } else {
    x = '';
  }
  var buf = [];
  while (buf.length + x.length < padding) {
    buf.push('0');
  }
  return x + buf.join('');
}
function truncate(x, length) {
  if (x) {
    x += '';
  }
  if (x && x.length > length) {
    return x.substr(0, length);
  } else {
    return x;
  }
}

//where number is an array with 0th item as integer string and 1st item as decimal string (no negatives)
function round(number, places) {
  if (number[1] && places >= 0 && number[1].length > places) {
    //truncate to correct number of decimal places
    var decim = number[1].slice(0, places);
    //if next digit was >= 5 we need to round up
    if (+(number[1].substr(places, 1)) >= 5) {
      //But first count leading zeros as converting to a number will loose them
      var leadingzeros = "";
      while (decim.charAt(0)==="0") {
        leadingzeros = leadingzeros + "0";
        decim = decim.substr(1);
      }
      //Then we can change decim to a number and add 1 before replacing leading zeros
      decim = (+decim + 1) + '';
      decim = leadingzeros + decim;
      if (decim.length > places) {
        //adding one has made it longer
        number[0] = (+number[0]+ +decim.charAt(0)) + ''; //add value of firstchar to the integer part
        decim = decim.substring(1);   //ignore the 1st char at the beginning which is the carry to the integer part
      }
    }
    number[1] = decim;
  }
  return number;
}


/***/ }),

/***/ "./node_modules/raw-loader/index.js!./libs/sortabletable.js":
/*!*********************************************************!*\
  !*** ./node_modules/raw-loader!./libs/sortabletable.js ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "/*----------------------------------------------------------------------------\\\r\n|                            Sortable Table 1.12                              |\r\n|-----------------------------------------------------------------------------|\r\n|                         Created by Erik Arvidsson                           |\r\n|                  (http://webfx.eae.net/contact.html#erik)                   |\r\n|                      For WebFX (http://webfx.eae.net/)                      |\r\n|-----------------------------------------------------------------------------|\r\n| A DOM 1 based script that allows an ordinary HTML table to be sortable.     |\r\n|-----------------------------------------------------------------------------|\r\n|                  Copyright (c) 1998 - 2006 Erik Arvidsson                   |\r\n|-----------------------------------------------------------------------------|\r\n| Licensed under the Apache License, Version 2.0 (the \"License\"); you may not |\r\n| use this file except in compliance with the License.  You may obtain a copy |\r\n| of the License at http://www.apache.org/licenses/LICENSE-2.0                |\r\n| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |\r\n| Unless  required  by  applicable law or  agreed  to  in  writing,  software |\r\n| distributed under the License is distributed on an  \"AS IS\" BASIS,  WITHOUT |\r\n| WARRANTIES OR  CONDITIONS OF ANY KIND,  either express or implied.  See the |\r\n| License  for the  specific language  governing permissions  and limitations |\r\n| under the License.                                                          |\r\n|-----------------------------------------------------------------------------|\r\n| 2003-01-10 | First version                                                  |\r\n| 2003-01-19 | Minor changes to the date parsing                              |\r\n| 2003-01-28 | JScript 5.0 fixes (no support for 'in' operator)               |\r\n| 2003-02-01 | Sloppy typo like error fixed in getInnerText                   |\r\n| 2003-07-04 | Added workaround for IE cellIndex bug.                         |\r\n| 2003-11-09 | The bDescending argument to sort was not correctly working     |\r\n|            | Using onclick DOM0 event if no support for addEventListener    |\r\n|            | or attachEvent                                                 |\r\n| 2004-01-13 | Adding addSortType and removeSortType which makes it a lot     |\r\n|            | easier to add new, custom sort types.                          |\r\n| 2004-01-27 | Switch to use descending = false as the default sort order.    |\r\n|            | Change defaultDescending to suit your needs.                   |\r\n| 2004-03-14 | Improved sort type None look and feel a bit                    |\r\n| 2004-08-26 | Made the handling of tBody and tHead more flexible. Now you    |\r\n|            | can use another tHead or no tHead, and you can chose some      |\r\n|            | other tBody.                                                   |\r\n| 2006-04-25 | Changed license to Apache Software License 2.0                 |\r\n|-----------------------------------------------------------------------------|\r\n| Created 2003-01-10 | All changes are in the log above. | Updated 2006-04-25 |\r\n\\----------------------------------------------------------------------------*/\r\n\r\n\r\nfunction SortableTable(oTable, oSortTypes) {\r\n\r\n\tthis.sortTypes = oSortTypes || [];\r\n\r\n\tthis.sortColumn = null;\r\n\tthis.descending = null;\r\n\r\n\tvar oThis = this;\r\n\tthis._headerOnclick = function (e) {\r\n\t\toThis.headerOnclick(e);\r\n\t};\r\n\r\n\tif (oTable) {\r\n\t\tthis.setTable( oTable );\r\n\t\tthis.document = oTable.ownerDocument || oTable.document;\r\n\t}\r\n\telse {\r\n\t\tthis.document = document;\r\n\t}\r\n\r\n\r\n\t// only IE needs this\r\n\tvar win = this.document.defaultView || this.document.parentWindow;\r\n\tthis._onunload = function () {\r\n\t\toThis.destroy();\r\n\t};\r\n\tif (win && typeof win.attachEvent != \"undefined\") {\r\n\t\twin.attachEvent(\"onunload\", this._onunload);\r\n\t}\r\n}\r\n\r\nSortableTable.gecko = navigator.product == \"Gecko\";\r\nSortableTable.msie = /msie/i.test(navigator.userAgent);\r\n// Mozilla is faster when doing the DOM manipulations on\r\n// an orphaned element. MSIE is not\r\nSortableTable.removeBeforeSort = SortableTable.gecko;\r\n\r\nSortableTable.prototype.onsort = function () {};\r\n\r\n// default sort order. true -> descending, false -> ascending\r\nSortableTable.prototype.defaultDescending = false;\r\n\r\n// shared between all instances. This is intentional to allow external files\r\n// to modify the prototype\r\nSortableTable.prototype._sortTypeInfo = {};\r\n\r\nSortableTable.prototype.setTable = function (oTable) {\r\n\tif ( this.tHead )\r\n\t\tthis.uninitHeader();\r\n\tthis.element = oTable;\r\n\tthis.setTHead( oTable.tHead );\r\n\tthis.setTBody( oTable.tBodies[0] );\r\n};\r\n\r\nSortableTable.prototype.setTHead = function (oTHead) {\r\n\tif (this.tHead && this.tHead != oTHead )\r\n\t\tthis.uninitHeader();\r\n\tthis.tHead = oTHead;\r\n\tthis.initHeader( this.sortTypes );\r\n};\r\n\r\nSortableTable.prototype.setTBody = function (oTBody) {\r\n\tthis.tBody = oTBody;\r\n};\r\n\r\nSortableTable.prototype.setSortTypes = function ( oSortTypes ) {\r\n\tif ( this.tHead )\r\n\t\tthis.uninitHeader();\r\n\tthis.sortTypes = oSortTypes || [];\r\n\tif ( this.tHead )\r\n\t\tthis.initHeader( this.sortTypes );\r\n};\r\n\r\n// adds arrow containers and events\r\n// also binds sort type to the header cells so that reordering columns does\r\n// not break the sort types\r\nSortableTable.prototype.initHeader = function (oSortTypes) {\r\n\tif (!this.tHead) return;\r\n\tvar cells = this.tHead.rows[0].cells;\r\n\tvar doc = this.tHead.ownerDocument || this.tHead.document;\r\n\tthis.sortTypes = oSortTypes || [];\r\n\tvar l = cells.length;\r\n\tvar img, c;\r\n\tfor (var i = 0; i < l; i++) {\r\n\t\tc = cells[i];\r\n\t\tif (this.sortTypes[i] != null && this.sortTypes[i] != \"None\") {\r\n\t\t\timg = doc.createElement(\"IMG\");\r\n\t\t\timg.src = \"images/blank.png\";\r\n\t\t\tc.appendChild(img);\r\n\t\t\tif (this.sortTypes[i] != null)\r\n\t\t\t\tc._sortType = this.sortTypes[i];\r\n\t\t\tif (typeof c.addEventListener != \"undefined\")\r\n\t\t\t\tc.addEventListener(\"click\", this._headerOnclick, false);\r\n\t\t\telse if (typeof c.attachEvent != \"undefined\")\r\n\t\t\t\tc.attachEvent(\"onclick\", this._headerOnclick);\r\n\t\t\telse\r\n\t\t\t\tc.onclick = this._headerOnclick;\r\n\t\t}\r\n\t\telse\r\n\t\t{\r\n\t\t\tc.setAttribute( \"_sortType\", oSortTypes[i] );\r\n\t\t\tc._sortType = \"None\";\r\n\t\t}\r\n\t}\r\n\tthis.updateHeaderArrows();\r\n};\r\n\r\n// remove arrows and events\r\nSortableTable.prototype.uninitHeader = function () {\r\n\tif (!this.tHead) return;\r\n\tvar cells = this.tHead.rows[0].cells;\r\n\tvar l = cells.length;\r\n\tvar c;\r\n\tfor (var i = 0; i < l; i++) {\r\n\t\tc = cells[i];\r\n\t\tif (c._sortType != null && c._sortType != \"None\") {\r\n\t\t\tc.removeChild(c.lastChild);\r\n\t\t\tif (typeof c.removeEventListener != \"undefined\")\r\n\t\t\t\tc.removeEventListener(\"click\", this._headerOnclick, false);\r\n\t\t\telse if (typeof c.detachEvent != \"undefined\")\r\n\t\t\t\tc.detachEvent(\"onclick\", this._headerOnclick);\r\n\t\t\tc._sortType = null;\r\n\t\t\tc.removeAttribute( \"_sortType\" );\r\n\t\t}\r\n\t}\r\n};\r\n\r\nSortableTable.prototype.updateHeaderArrows = function () {\r\n\tif (!this.tHead) return;\r\n\tvar cells = this.tHead.rows[0].cells;\r\n\tvar l = cells.length;\r\n\tvar img;\r\n\tfor (var i = 0; i < l; i++) {\r\n\t\tif (cells[i]._sortType != null && cells[i]._sortType != \"None\") {\r\n\t\t\timg = cells[i].lastChild;\r\n\t\t\tif (i == this.sortColumn)\r\n\t\t\t\timg.className = \"sort-arrow \" + (this.descending ? \"descending\" : \"ascending\");\r\n\t\t\telse\r\n\t\t\t\timg.className = \"sort-arrow\";\r\n\t\t}\r\n\t}\r\n};\r\n\r\nSortableTable.prototype.headerOnclick = function (e) {\r\n\t// find TD element\r\n\tvar el = e.target || e.srcElement;\r\n\twhile (el.tagName != \"TD\")\r\n\t\tel = el.parentNode;\r\n\r\n\tthis.sort(SortableTable.msie ? SortableTable.getCellIndex(el) : el.cellIndex);\r\n};\r\n\r\n// IE returns wrong cellIndex when columns are hidden\r\nSortableTable.getCellIndex = function (oTd) {\r\n\tvar cells = oTd.parentNode.childNodes\r\n\tvar l = cells.length;\r\n\tvar i;\r\n\tfor (i = 0; cells[i] != oTd && i < l; i++)\r\n\t\t;\r\n\treturn i;\r\n};\r\n\r\nSortableTable.prototype.getSortType = function (nColumn) {\r\n\treturn this.sortTypes[nColumn] || \"String\";\r\n};\r\n\r\n// only nColumn is required\r\n// if bDescending is left out the old value is taken into account\r\n// if sSortType is left out the sort type is found from the sortTypes array\r\n\r\nSortableTable.prototype.sort = function (nColumn, bDescending, sSortType) {\r\n\tif (!this.tBody) return;\r\n\tif (sSortType == null)\r\n\t\tsSortType = this.getSortType(nColumn);\r\n\r\n\t// exit if None\r\n\tif (sSortType == \"None\")\r\n\t\treturn;\r\n\r\n\tif (bDescending == null) {\r\n\t\tif (this.sortColumn != nColumn)\r\n\t\t\tthis.descending = this.defaultDescending;\r\n\t\telse\r\n\t\t\tthis.descending = !this.descending;\r\n\t}\r\n\telse\r\n\t\tthis.descending = bDescending;\r\n\r\n\tthis.sortColumn = nColumn;\r\n\r\n\tif (typeof this.onbeforesort == \"function\")\r\n\t\tthis.onbeforesort();\r\n\r\n\tvar f = this.getSortFunction(sSortType, nColumn);\r\n\tvar a = this.getCache(sSortType, nColumn);\r\n\tvar tBody = this.tBody;\r\n\r\n\ta.sort(f);\r\n\r\n\tif (this.descending)\r\n\t\ta.reverse();\r\n\r\n\tif (SortableTable.removeBeforeSort) {\r\n\t\t// remove from doc\r\n\t\tvar nextSibling = tBody.nextSibling;\r\n\t\tvar p = tBody.parentNode;\r\n\t\tp.removeChild(tBody);\r\n\t}\r\n\r\n\t// insert in the new order\r\n\tvar l = a.length;\r\n\tfor (var i = 0; i < l; i++)\r\n\t\ttBody.appendChild(a[i].element);\r\n\r\n\tif (SortableTable.removeBeforeSort) {\r\n\t\t// insert into doc\r\n\t\tp.insertBefore(tBody, nextSibling);\r\n\t}\r\n\r\n\tthis.updateHeaderArrows();\r\n\r\n\tthis.destroyCache(a);\r\n\r\n\tif (typeof this.onsort == \"function\")\r\n\t\tthis.onsort();\r\n};\r\n\r\nSortableTable.prototype.asyncSort = function (nColumn, bDescending, sSortType) {\r\n\tvar oThis = this;\r\n\tthis._asyncsort = function () {\r\n\t\toThis.sort(nColumn, bDescending, sSortType);\r\n\t};\r\n\twindow.setTimeout(this._asyncsort, 1);\r\n};\r\n\r\nSortableTable.prototype.getCache = function (sType, nColumn) {\r\n\tif (!this.tBody) return [];\r\n\tvar rows = this.tBody.rows;\r\n\tvar l = rows.length;\r\n\tvar a = new Array(l);\r\n\tvar r;\r\n\tfor (var i = 0; i < l; i++) {\r\n\t\tr = rows[i];\r\n\t\ta[i] = {\r\n\t\t\tvalue:\t\tthis.getRowValue(r, sType, nColumn),\r\n\t\t\telement:\tr\r\n\t\t};\r\n\t};\r\n\treturn a;\r\n};\r\n\r\nSortableTable.prototype.destroyCache = function (oArray) {\r\n\tvar l = oArray.length;\r\n\tfor (var i = 0; i < l; i++) {\r\n\t\toArray[i].value = null;\r\n\t\toArray[i].element = null;\r\n\t\toArray[i] = null;\r\n\t}\r\n};\r\n\r\nSortableTable.prototype.getRowValue = function (oRow, sType, nColumn) {\r\n\t// if we have defined a custom getRowValue use that\r\n\tif (this._sortTypeInfo[sType] && this._sortTypeInfo[sType].getRowValue)\r\n\t\treturn this._sortTypeInfo[sType].getRowValue(oRow, nColumn);\r\n\r\n\tvar s;\r\n\tvar c = oRow.cells[nColumn];\r\n\tif (typeof c.innerText != \"undefined\")\r\n\t\ts = c.innerText;\r\n\telse\r\n\t\ts = SortableTable.getInnerText(c);\r\n\treturn this.getValueFromString(s, sType);\r\n};\r\n\r\nSortableTable.getInnerText = function (oNode) {\r\n\tvar s = \"\";\r\n\tvar cs = oNode.childNodes;\r\n\tvar l = cs.length;\r\n\tfor (var i = 0; i < l; i++) {\r\n\t\tswitch (cs[i].nodeType) {\r\n\t\t\tcase 1: //ELEMENT_NODE\r\n\t\t\t\ts += SortableTable.getInnerText(cs[i]);\r\n\t\t\t\tbreak;\r\n\t\t\tcase 3:\t//TEXT_NODE\r\n\t\t\t\ts += cs[i].nodeValue;\r\n\t\t\t\tbreak;\r\n\t\t}\r\n\t}\r\n\treturn s;\r\n};\r\n\r\nSortableTable.prototype.getValueFromString = function (sText, sType) {\r\n\tif (this._sortTypeInfo[sType])\r\n\t\treturn this._sortTypeInfo[sType].getValueFromString( sText );\r\n\treturn sText;\r\n\t/*\r\n\tswitch (sType) {\r\n\t\tcase \"Number\":\r\n\t\t\treturn Number(sText);\r\n\t\tcase \"CaseInsensitiveString\":\r\n\t\t\treturn sText.toUpperCase();\r\n\t\tcase \"Date\":\r\n\t\t\tvar parts = sText.split(\"-\");\r\n\t\t\tvar d = new Date(0);\r\n\t\t\td.setFullYear(parts[0]);\r\n\t\t\td.setDate(parts[2]);\r\n\t\t\td.setMonth(parts[1] - 1);\r\n\t\t\treturn d.valueOf();\r\n\t}\r\n\treturn sText;\r\n\t*/\r\n\t};\r\n\r\nSortableTable.prototype.getSortFunction = function (sType, nColumn) {\r\n\tif (this._sortTypeInfo[sType])\r\n\t\treturn this._sortTypeInfo[sType].compare;\r\n\treturn SortableTable.basicCompare;\r\n};\r\n\r\nSortableTable.prototype.destroy = function () {\r\n\tthis.uninitHeader();\r\n\tvar win = this.document.parentWindow;\r\n\tif (win && typeof win.detachEvent != \"undefined\") {\t// only IE needs this\r\n\t\twin.detachEvent(\"onunload\", this._onunload);\r\n\t}\r\n\tthis._onunload = null;\r\n\tthis.element = null;\r\n\tthis.tHead = null;\r\n\tthis.tBody = null;\r\n\tthis.document = null;\r\n\tthis._headerOnclick = null;\r\n\tthis.sortTypes = null;\r\n\tthis._asyncsort = null;\r\n\tthis.onsort = null;\r\n};\r\n\r\n// Adds a sort type to all instance of SortableTable\r\n// sType : String - the identifier of the sort type\r\n// fGetValueFromString : function ( s : string ) : T - A function that takes a\r\n//    string and casts it to a desired format. If left out the string is just\r\n//    returned\r\n// fCompareFunction : function ( n1 : T, n2 : T ) : Number - A normal JS sort\r\n//    compare function. Takes two values and compares them. If left out less than,\r\n//    <, compare is used\r\n// fGetRowValue : function( oRow : HTMLTRElement, nColumn : int ) : T - A function\r\n//    that takes the row and the column index and returns the value used to compare.\r\n//    If left out then the innerText is first taken for the cell and then the\r\n//    fGetValueFromString is used to convert that string the desired value and type\r\n\r\nSortableTable.prototype.addSortType = function (sType, fGetValueFromString, fCompareFunction, fGetRowValue) {\r\n\tthis._sortTypeInfo[sType] = {\r\n\t\ttype:\t\t\t\tsType,\r\n\t\tgetValueFromString:\tfGetValueFromString || SortableTable.idFunction,\r\n\t\tcompare:\t\t\tfCompareFunction || SortableTable.basicCompare,\r\n\t\tgetRowValue:\t\tfGetRowValue\r\n\t};\r\n};\r\n\r\n// this removes the sort type from all instances of SortableTable\r\nSortableTable.prototype.removeSortType = function (sType) {\r\n\tdelete this._sortTypeInfo[sType];\r\n};\r\n\r\nSortableTable.basicCompare = function compare(n1, n2) {\r\n\tif (n1.value < n2.value)\r\n\t\treturn -1;\r\n\tif (n2.value < n1.value)\r\n\t\treturn 1;\r\n\treturn 0;\r\n};\r\n\r\nSortableTable.idFunction = function (x) {\r\n\treturn x;\r\n};\r\n\r\nSortableTable.toUpperCase = function (s) {\r\n\treturn s.toUpperCase();\r\n};\r\n\r\nSortableTable.toDate = function (s) {\r\n\tvar parts = s.split(\"-\");\r\n\tvar d = new Date(0);\r\n\td.setFullYear(parts[0]);\r\n\td.setDate(parts[2]);\r\n\td.setMonth(parts[1] - 1);\r\n\treturn d.valueOf();\r\n};\r\n\r\n\r\n// add sort types\r\nSortableTable.prototype.addSortType(\"Number\", Number);\r\nSortableTable.prototype.addSortType(\"CaseInsensitiveString\", SortableTable.toUpperCase);\r\nSortableTable.prototype.addSortType(\"Date\", SortableTable.toDate);\r\nSortableTable.prototype.addSortType(\"String\");\r\n// None is a special case\r\n"

/***/ }),

/***/ "./node_modules/script-loader/addScript.js":
/*!*************************************************!*\
  !*** ./node_modules/script-loader/addScript.js ***!
  \*************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
module.exports = function(src) {
	function log(error) {
		(typeof console !== "undefined")
		&& (console.error || console.log)("[Script Loader]", error);
	}

	// Check for IE =< 8
	function isIE() {
		return typeof attachEvent !== "undefined" && typeof addEventListener === "undefined";
	}

	try {
		if (typeof execScript !== "undefined" && isIE()) {
			execScript(src);
		} else if (typeof eval !== "undefined") {
			eval.call(null, src);
		} else {
			log("EvalError: No eval function available");
		}
	} catch (error) {
		log(error);
	}
}


/***/ }),

/***/ "./node_modules/script-loader/index.js!./libs/sortabletable.js":
/*!************************************************************!*\
  !*** ./node_modules/script-loader!./libs/sortabletable.js ***!
  \************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(/*! !./node_modules/script-loader/addScript.js */ "./node_modules/script-loader/addScript.js")(__webpack_require__(/*! !./node_modules/raw-loader!./libs/sortabletable.js */ "./node_modules/raw-loader/index.js!./libs/sortabletable.js")+"\n\n// SCRIPT-LOADER FOOTER\n//# sourceURL=script:///C:/projects/dev/github/TableFilter/libs/sortabletable.js")

/***/ }),

/***/ "./src sync recursive ^\\.\\/.*$":
/*!***************************!*\
  !*** ./src sync ^\.\/.*$ ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./array": "./src/array.js",
	"./array.js": "./src/array.js",
	"./const": "./src/const.js",
	"./const.js": "./src/const.js",
	"./cookie": "./src/cookie.js",
	"./cookie.js": "./src/cookie.js",
	"./dom": "./src/dom.js",
	"./dom.js": "./src/dom.js",
	"./emitter": "./src/emitter.js",
	"./emitter.js": "./src/emitter.js",
	"./event": "./src/event.js",
	"./event.js": "./src/event.js",
	"./extensions/advancedGrid/adapterEzEditTable": "./src/extensions/advancedGrid/adapterEzEditTable.js",
	"./extensions/advancedGrid/adapterEzEditTable.js": "./src/extensions/advancedGrid/adapterEzEditTable.js",
	"./extensions/advancedGrid/advancedGrid": "./src/extensions/advancedGrid/advancedGrid.js",
	"./extensions/advancedGrid/advancedGrid.js": "./src/extensions/advancedGrid/advancedGrid.js",
	"./extensions/colOps/colOps": "./src/extensions/colOps/colOps.js",
	"./extensions/colOps/colOps.js": "./src/extensions/colOps/colOps.js",
	"./extensions/colsVisibility/colsVisibility": "./src/extensions/colsVisibility/colsVisibility.js",
	"./extensions/colsVisibility/colsVisibility.js": "./src/extensions/colsVisibility/colsVisibility.js",
	"./extensions/filtersVisibility/filtersVisibility": "./src/extensions/filtersVisibility/filtersVisibility.js",
	"./extensions/filtersVisibility/filtersVisibility.js": "./src/extensions/filtersVisibility/filtersVisibility.js",
	"./extensions/sort/adapterSortabletable": "./src/extensions/sort/adapterSortabletable.js",
	"./extensions/sort/adapterSortabletable.js": "./src/extensions/sort/adapterSortabletable.js",
	"./extensions/sort/sort": "./src/extensions/sort/sort.js",
	"./extensions/sort/sort.js": "./src/extensions/sort/sort.js",
	"./feature": "./src/feature.js",
	"./feature.js": "./src/feature.js",
	"./modules/alternateRows": "./src/modules/alternateRows.js",
	"./modules/alternateRows.js": "./src/modules/alternateRows.js",
	"./modules/baseDropdown": "./src/modules/baseDropdown.js",
	"./modules/baseDropdown.js": "./src/modules/baseDropdown.js",
	"./modules/checkList": "./src/modules/checkList.js",
	"./modules/checkList.js": "./src/modules/checkList.js",
	"./modules/clearButton": "./src/modules/clearButton.js",
	"./modules/clearButton.js": "./src/modules/clearButton.js",
	"./modules/dateType": "./src/modules/dateType.js",
	"./modules/dateType.js": "./src/modules/dateType.js",
	"./modules/dropdown": "./src/modules/dropdown.js",
	"./modules/dropdown.js": "./src/modules/dropdown.js",
	"./modules/gridLayout": "./src/modules/gridLayout.js",
	"./modules/gridLayout.js": "./src/modules/gridLayout.js",
	"./modules/hash": "./src/modules/hash.js",
	"./modules/hash.js": "./src/modules/hash.js",
	"./modules/help": "./src/modules/help.js",
	"./modules/help.js": "./src/modules/help.js",
	"./modules/highlightKeywords": "./src/modules/highlightKeywords.js",
	"./modules/highlightKeywords.js": "./src/modules/highlightKeywords.js",
	"./modules/loader": "./src/modules/loader.js",
	"./modules/loader.js": "./src/modules/loader.js",
	"./modules/markActiveColumns": "./src/modules/markActiveColumns.js",
	"./modules/markActiveColumns.js": "./src/modules/markActiveColumns.js",
	"./modules/noResults": "./src/modules/noResults.js",
	"./modules/noResults.js": "./src/modules/noResults.js",
	"./modules/paging": "./src/modules/paging.js",
	"./modules/paging.js": "./src/modules/paging.js",
	"./modules/popupFilter": "./src/modules/popupFilter.js",
	"./modules/popupFilter.js": "./src/modules/popupFilter.js",
	"./modules/rowsCounter": "./src/modules/rowsCounter.js",
	"./modules/rowsCounter.js": "./src/modules/rowsCounter.js",
	"./modules/state": "./src/modules/state.js",
	"./modules/state.js": "./src/modules/state.js",
	"./modules/statusBar": "./src/modules/statusBar.js",
	"./modules/statusBar.js": "./src/modules/statusBar.js",
	"./modules/storage": "./src/modules/storage.js",
	"./modules/storage.js": "./src/modules/storage.js",
	"./modules/toolbar": "./src/modules/toolbar.js",
	"./modules/toolbar.js": "./src/modules/toolbar.js",
	"./number": "./src/number.js",
	"./number.js": "./src/number.js",
	"./root": "./src/root.js",
	"./root.js": "./src/root.js",
	"./settings": "./src/settings.js",
	"./settings.js": "./src/settings.js",
	"./sort": "./src/sort.js",
	"./sort.js": "./src/sort.js",
	"./string": "./src/string.js",
	"./string.js": "./src/string.js",
	"./tablefilter": "./src/tablefilter.js",
	"./tablefilter.js": "./src/tablefilter.js",
	"./types": "./src/types.js",
	"./types.js": "./src/types.js"
};


function webpackContext(req) {
	var id = webpackContextResolve(req);
	return __webpack_require__(id);
}
function webpackContextResolve(req) {
	if(!__webpack_require__.o(map, req)) {
		var e = new Error("Cannot find module '" + req + "'");
		e.code = 'MODULE_NOT_FOUND';
		throw e;
	}
	return map[req];
}
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = "./src sync recursive ^\\.\\/.*$";

/***/ }),

/***/ "./src/extensions/advancedGrid/adapterEzEditTable.js":
/*!***********************************************************!*\
  !*** ./src/extensions/advancedGrid/adapterEzEditTable.js ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __cov_8CdxqQjta0kgBZMP6kX7FA = (Function('return this'))();
if (!__cov_8CdxqQjta0kgBZMP6kX7FA.__coverage__) { __cov_8CdxqQjta0kgBZMP6kX7FA.__coverage__ = {}; }
__cov_8CdxqQjta0kgBZMP6kX7FA = __cov_8CdxqQjta0kgBZMP6kX7FA.__coverage__;
if (!(__cov_8CdxqQjta0kgBZMP6kX7FA['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\advancedGrid\\adapterEzEditTable.js'])) {
   __cov_8CdxqQjta0kgBZMP6kX7FA['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\advancedGrid\\adapterEzEditTable.js'] = {"path":"C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\advancedGrid\\adapterEzEditTable.js","s":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":1,"8":0,"9":0,"10":1,"11":0,"12":0,"13":0,"14":1,"15":0,"16":0,"17":0,"18":0,"19":0,"20":0,"21":0,"22":0,"23":1,"24":0,"25":0,"26":0,"27":0,"28":0,"29":0,"30":0,"31":0,"32":0,"33":0,"34":0,"35":0,"36":0,"37":0,"38":0,"39":0,"40":0,"41":0,"42":0,"43":0,"44":0,"45":0,"46":0,"47":0,"48":0,"49":0,"50":0,"51":0,"52":0,"53":0,"54":0,"55":0,"56":0,"57":0,"58":0,"59":0,"60":0,"61":0,"62":0,"63":0,"64":0,"65":0,"66":0,"67":0,"68":0,"69":0,"70":0,"71":0,"72":0,"73":0,"74":0,"75":0,"76":0,"77":0,"78":0,"79":0,"80":0,"81":0,"82":0,"83":0,"84":0,"85":0,"86":0,"87":0,"88":0,"89":0,"90":0,"91":0,"92":0,"93":0,"94":0,"95":0,"96":0,"97":0,"98":0,"99":0,"100":0,"101":0,"102":0,"103":0,"104":0,"105":0,"106":0,"107":0,"108":0,"109":0,"110":0,"111":0,"112":0,"113":0,"114":0,"115":0,"116":0,"117":0,"118":0,"119":0,"120":0,"121":0,"122":0,"123":0,"124":0,"125":0,"126":0,"127":0,"128":0,"129":0,"130":0,"131":0,"132":0,"133":0,"134":0,"135":0,"136":0,"137":0,"138":0,"139":0,"140":0,"141":0,"142":0,"143":0,"144":0,"145":0,"146":0,"147":0,"148":0,"149":0,"150":0,"151":0,"152":0,"153":0,"154":0,"155":0,"156":0,"157":0,"158":0,"159":0,"160":0,"161":0,"162":0,"163":0,"164":0,"165":0,"166":0,"167":0,"168":0,"169":0,"170":0,"171":0,"172":0,"173":0,"174":0,"175":0,"176":0,"177":0,"178":0,"179":0,"180":0,"181":0,"182":0,"183":0,"184":0,"185":0,"186":0,"187":0,"188":0,"189":0,"190":0,"191":0,"192":0,"193":0,"194":0,"195":0,"196":0,"197":0,"198":0,"199":0,"200":0,"201":0,"202":0,"203":0,"204":0,"205":0,"206":0,"207":0,"208":0,"209":0,"210":0,"211":0,"212":0,"213":0,"214":0,"215":0,"216":0,"217":0,"218":0,"219":0,"220":0,"221":0,"222":0,"223":0,"224":0,"225":0,"226":0,"227":0,"228":0,"229":0,"230":0,"231":0,"232":0,"233":0,"234":0,"235":0,"236":0,"237":0,"238":0,"239":0,"240":0,"241":0,"242":0,"243":0,"244":0},"b":{"1":[0,0],"2":[0,0],"3":[0,0],"4":[0,0,0],"5":[0,0],"6":[0,0],"7":[0,0],"8":[0,0],"9":[0,0],"10":[0,0],"11":[0,0],"12":[0,0],"13":[0,0],"14":[0,0],"15":[0,0],"16":[0,0],"17":[0,0],"18":[0,0],"19":[0,0],"20":[0,0],"21":[0,0],"22":[0,0],"23":[0,0],"24":[0,0],"25":[0,0],"26":[0,0],"27":[0,0],"28":[0,0],"29":[0,0],"30":[0,0],"31":[0,0],"32":[0,0],"33":[0,0],"34":[0,0],"35":[0,0],"36":[0,0],"37":[0,0],"38":[0,0],"39":[0,0,0],"40":[0,0],"41":[0,0],"42":[0,0],"43":[0,0],"44":[0,0],"45":[0,0],"46":[0,0],"47":[0,0],"48":[0,0],"49":[0,0],"50":[0,0],"51":[0,0],"52":[0,0],"53":[0,0],"54":[0,0],"55":[0,0],"56":[0,0],"57":[0,0],"58":[0,0],"59":[0,0],"60":[0,0],"61":[0,0],"62":[0,0],"63":[0,0],"64":[0,0],"65":[0,0],"66":[0,0],"67":[0,0],"68":[0,0],"69":[0,0],"70":[0,0],"71":[0,0],"72":[0,0],"73":[0,0],"74":[0,0],"75":[0,0],"76":[0,0],"77":[0,0],"78":[0,0],"79":[0,0],"80":[0,0],"81":[0,0],"82":[0,0],"83":[0,0],"84":[0,0],"85":[0,0],"86":[0,0],"87":[0,0],"88":[0,0],"89":[0,0]},"f":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":0,"8":0,"9":0,"10":0,"11":0,"12":0,"13":0,"14":0,"15":0,"16":0,"17":0,"18":0,"19":0,"20":0,"21":0,"22":0,"23":0,"24":0},"fnMap":{"1":{"name":"_classCallCheck","line":17,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"2":{"name":"_possibleConstructorReturn","line":19,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"3":{"name":"_inherits","line":21,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"4":{"name":"(anonymous_4)","line":31,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"5":{"name":"AdapterEzEditTable","line":40,"loc":{"start":{"line":23,"column":4},"end":{"line":23,"column":25}}},"6":{"name":"init","line":106,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"7":{"name":"(anonymous_7)","line":117,"loc":{"start":{"line":96,"column":43},"end":{"line":96,"column":43}}},"8":{"name":"(anonymous_8)","line":127,"loc":{"start":{"line":105,"column":12},"end":{"line":105,"column":12}}},"9":{"name":"_setAdvancedGrid","line":143,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"10":{"name":"onAfterSelection","line":177,"loc":{"start":{"line":151,"column":35},"end":{"line":151,"column":65}}},"11":{"name":"doSelect","line":180,"loc":{"start":{"line":154,"column":31},"end":{"line":154,"column":55}}},"12":{"name":"onBeforeSelection","line":302,"loc":{"start":{"line":277,"column":36},"end":{"line":277,"column":63}}},"13":{"name":"(anonymous_13)","line":329,"loc":{"start":{"line":314,"column":57},"end":{"line":314,"column":75}}},"14":{"name":"(anonymous_14)","line":352,"loc":{"start":{"line":337,"column":45},"end":{"line":337,"column":57}}},"15":{"name":"(anonymous_15)","line":360,"loc":{"start":{"line":345,"column":44},"end":{"line":345,"column":56}}},"16":{"name":"(anonymous_16)","line":369,"loc":{"start":{"line":354,"column":46},"end":{"line":354,"column":58}}},"17":{"name":"(anonymous_17)","line":377,"loc":{"start":{"line":362,"column":45},"end":{"line":362,"column":57}}},"18":{"name":"(anonymous_18)","line":389,"loc":{"start":{"line":374,"column":35},"end":{"line":374,"column":47}}},"19":{"name":"(anonymous_19)","line":409,"loc":{"start":{"line":394,"column":56},"end":{"line":394,"column":68}}},"20":{"name":"reset","line":447,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"21":{"name":"toggle","line":468,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"22":{"name":"_toggleForInputFilter","line":490,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"23":{"name":"destroy","line":507,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"24":{"name":"(anonymous_24)","line":528,"loc":{"start":{"line":504,"column":12},"end":{"line":504,"column":12}}}},"statementMap":{"1":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"2":{"start":{"line":1,"column":0},"end":{"line":1,"column":0}},"3":{"start":{"line":2,"column":0},"end":{"line":2,"column":0}},"4":{"start":{"line":3,"column":0},"end":{"line":3,"column":0}},"5":{"start":{"line":4,"column":0},"end":{"line":4,"column":0}},"6":{"start":{"line":5,"column":0},"end":{"line":5,"column":0}},"7":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"8":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"9":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"10":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"11":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"12":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"13":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"14":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"15":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"16":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"17":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"18":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"19":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"20":{"start":{"line":7,"column":0},"end":{"line":7,"column":0}},"21":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"22":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"23":{"start":{"line":23,"column":4},"end":{"line":82,"column":5}},"24":{"start":{"line":23,"column":25},"end":{"line":23,"column":25}},"25":{"start":{"line":23,"column":25},"end":{"line":23,"column":25}},"26":{"start":{"line":30,"column":8},"end":{"line":30,"column":8}},"27":{"start":{"line":36,"column":8},"end":{"line":36,"column":8}},"28":{"start":{"line":42,"column":8},"end":{"line":42,"column":8}},"29":{"start":{"line":48,"column":8},"end":{"line":48,"column":8}},"30":{"start":{"line":54,"column":8},"end":{"line":54,"column":8}},"31":{"start":{"line":61,"column":8},"end":{"line":61,"column":8}},"32":{"start":{"line":65,"column":8},"end":{"line":65,"column":8}},"33":{"start":{"line":73,"column":8},"end":{"line":73,"column":8}},"34":{"start":{"line":79,"column":8},"end":{"line":79,"column":8}},"35":{"start":{"line":81,"column":8},"end":{"line":81,"column":8}},"36":{"start":{"line":23,"column":25},"end":{"line":23,"column":25}},"37":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"38":{"start":{"line":87,"column":11},"end":{"line":87,"column":11}},"39":{"start":{"line":88,"column":8},"end":{"line":90,"column":9}},"40":{"start":{"line":89,"column":12},"end":{"line":89,"column":12}},"41":{"start":{"line":91,"column":8},"end":{"line":91,"column":8}},"42":{"start":{"line":92,"column":8},"end":{"line":97,"column":9}},"43":{"start":{"line":93,"column":12},"end":{"line":93,"column":12}},"44":{"start":{"line":95,"column":12},"end":{"line":95,"column":12}},"45":{"start":{"line":96,"column":12},"end":{"line":96,"column":12}},"46":{"start":{"line":96,"column":43},"end":{"line":96,"column":43}},"47":{"start":{"line":98,"column":8},"end":{"line":100,"column":9}},"48":{"start":{"line":99,"column":12},"end":{"line":99,"column":12}},"49":{"start":{"line":104,"column":8},"end":{"line":104,"column":8}},"50":{"start":{"line":105,"column":12},"end":{"line":105,"column":12}},"51":{"start":{"line":110,"column":8},"end":{"line":110,"column":8}},"52":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"53":{"start":{"line":118,"column":8},"end":{"line":118,"column":8}},"54":{"start":{"line":121,"column":8},"end":{"line":121,"column":8}},"55":{"start":{"line":127,"column":8},"end":{"line":133,"column":9}},"56":{"start":{"line":128,"column":12},"end":{"line":128,"column":12}},"57":{"start":{"line":132,"column":12},"end":{"line":132,"column":12}},"58":{"start":{"line":135,"column":8},"end":{"line":135,"column":8}},"59":{"start":{"line":136,"column":8},"end":{"line":136,"column":8}},"60":{"start":{"line":137,"column":8},"end":{"line":137,"column":8}},"61":{"start":{"line":139,"column":8},"end":{"line":141,"column":9}},"62":{"start":{"line":140,"column":12},"end":{"line":140,"column":12}},"63":{"start":{"line":143,"column":8},"end":{"line":143,"column":8}},"64":{"start":{"line":145,"column":8},"end":{"line":145,"column":8}},"65":{"start":{"line":146,"column":8},"end":{"line":146,"column":8}},"66":{"start":{"line":148,"column":8},"end":{"line":370,"column":9}},"67":{"start":{"line":151,"column":12},"end":{"line":151,"column":12}},"68":{"start":{"line":152,"column":16},"end":{"line":152,"column":16}},"69":{"start":{"line":154,"column":16},"end":{"line":154,"column":16}},"70":{"start":{"line":155,"column":20},"end":{"line":175,"column":21}},"71":{"start":{"line":157,"column":24},"end":{"line":157,"column":24}},"72":{"start":{"line":161,"column":24},"end":{"line":161,"column":24}},"73":{"start":{"line":163,"column":24},"end":{"line":163,"column":24}},"74":{"start":{"line":165,"column":24},"end":{"line":169,"column":25}},"75":{"start":{"line":167,"column":28},"end":{"line":167,"column":28}},"76":{"start":{"line":170,"column":24},"end":{"line":174,"column":25}},"77":{"start":{"line":172,"column":28},"end":{"line":172,"column":28}},"78":{"start":{"line":177,"column":20},"end":{"line":193,"column":21}},"79":{"start":{"line":178,"column":24},"end":{"line":178,"column":24}},"80":{"start":{"line":179,"column":24},"end":{"line":181,"column":25}},"81":{"start":{"line":180,"column":28},"end":{"line":180,"column":28}},"82":{"start":{"line":182,"column":24},"end":{"line":192,"column":25}},"83":{"start":{"line":183,"column":28},"end":{"line":191,"column":29}},"84":{"start":{"line":185,"column":32},"end":{"line":185,"column":32}},"85":{"start":{"line":187,"column":33},"end":{"line":191,"column":29}},"86":{"start":{"line":188,"column":32},"end":{"line":188,"column":32}},"87":{"start":{"line":190,"column":32},"end":{"line":190,"column":32}},"88":{"start":{"line":197,"column":16},"end":{"line":199,"column":17}},"89":{"start":{"line":198,"column":20},"end":{"line":198,"column":20}},"90":{"start":{"line":200,"column":16},"end":{"line":200,"column":16}},"91":{"start":{"line":219,"column":16},"end":{"line":272,"column":17}},"92":{"start":{"line":221,"column":20},"end":{"line":241,"column":21}},"93":{"start":{"line":223,"column":24},"end":{"line":232,"column":25}},"94":{"start":{"line":224,"column":28},"end":{"line":224,"column":28}},"95":{"start":{"line":226,"column":28},"end":{"line":226,"column":28}},"96":{"start":{"line":227,"column":28},"end":{"line":231,"column":29}},"97":{"start":{"line":228,"column":32},"end":{"line":228,"column":32}},"98":{"start":{"line":230,"column":32},"end":{"line":230,"column":32}},"99":{"start":{"line":235,"column":24},"end":{"line":240,"column":25}},"100":{"start":{"line":236,"column":28},"end":{"line":236,"column":28}},"101":{"start":{"line":238,"column":28},"end":{"line":238,"column":28}},"102":{"start":{"line":239,"column":28},"end":{"line":239,"column":28}},"103":{"start":{"line":242,"column":20},"end":{"line":242,"column":20}},"104":{"start":{"line":243,"column":20},"end":{"line":243,"column":20}},"105":{"start":{"line":247,"column":20},"end":{"line":271,"column":21}},"106":{"start":{"line":248,"column":24},"end":{"line":248,"column":24}},"107":{"start":{"line":249,"column":24},"end":{"line":249,"column":24}},"108":{"start":{"line":251,"column":24},"end":{"line":267,"column":25}},"109":{"start":{"line":253,"column":28},"end":{"line":258,"column":29}},"110":{"start":{"line":254,"column":32},"end":{"line":254,"column":32}},"111":{"start":{"line":257,"column":32},"end":{"line":257,"column":32}},"112":{"start":{"line":261,"column":28},"end":{"line":266,"column":29}},"113":{"start":{"line":262,"column":32},"end":{"line":262,"column":32}},"114":{"start":{"line":264,"column":32},"end":{"line":264,"column":32}},"115":{"start":{"line":268,"column":24},"end":{"line":268,"column":24}},"116":{"start":{"line":269,"column":24},"end":{"line":269,"column":24}},"117":{"start":{"line":270,"column":24},"end":{"line":270,"column":24}},"118":{"start":{"line":277,"column":12},"end":{"line":277,"column":12}},"119":{"start":{"line":278,"column":16},"end":{"line":278,"column":16}},"120":{"start":{"line":280,"column":16},"end":{"line":309,"column":17}},"121":{"start":{"line":281,"column":20},"end":{"line":308,"column":21}},"122":{"start":{"line":282,"column":24},"end":{"line":282,"column":24}},"123":{"start":{"line":284,"column":24},"end":{"line":284,"column":24}},"124":{"start":{"line":285,"column":24},"end":{"line":285,"column":24}},"125":{"start":{"line":289,"column":24},"end":{"line":289,"column":24}},"126":{"start":{"line":291,"column":24},"end":{"line":307,"column":25}},"127":{"start":{"line":293,"column":28},"end":{"line":293,"column":28}},"128":{"start":{"line":295,"column":29},"end":{"line":307,"column":25}},"129":{"start":{"line":297,"column":28},"end":{"line":297,"column":28}},"130":{"start":{"line":299,"column":29},"end":{"line":307,"column":25}},"131":{"start":{"line":301,"column":28},"end":{"line":301,"column":28}},"132":{"start":{"line":303,"column":29},"end":{"line":307,"column":25}},"133":{"start":{"line":306,"column":28},"end":{"line":306,"column":28}},"134":{"start":{"line":313,"column":12},"end":{"line":331,"column":13}},"135":{"start":{"line":314,"column":16},"end":{"line":314,"column":16}},"136":{"start":{"line":315,"column":20},"end":{"line":315,"column":20}},"137":{"start":{"line":316,"column":20},"end":{"line":316,"column":20}},"138":{"start":{"line":317,"column":20},"end":{"line":317,"column":20}},"139":{"start":{"line":319,"column":20},"end":{"line":319,"column":20}},"140":{"start":{"line":321,"column":20},"end":{"line":323,"column":21}},"141":{"start":{"line":322,"column":24},"end":{"line":322,"column":24}},"142":{"start":{"line":325,"column":20},"end":{"line":325,"column":20}},"143":{"start":{"line":327,"column":20},"end":{"line":329,"column":21}},"144":{"start":{"line":328,"column":24},"end":{"line":328,"column":24}},"145":{"start":{"line":335,"column":12},"end":{"line":369,"column":13}},"146":{"start":{"line":336,"column":16},"end":{"line":336,"column":16}},"147":{"start":{"line":337,"column":16},"end":{"line":337,"column":16}},"148":{"start":{"line":338,"column":20},"end":{"line":338,"column":20}},"149":{"start":{"line":339,"column":20},"end":{"line":339,"column":20}},"150":{"start":{"line":340,"column":20},"end":{"line":342,"column":21}},"151":{"start":{"line":341,"column":24},"end":{"line":341,"column":24}},"152":{"start":{"line":344,"column":16},"end":{"line":344,"column":16}},"153":{"start":{"line":345,"column":16},"end":{"line":345,"column":16}},"154":{"start":{"line":346,"column":20},"end":{"line":346,"column":20}},"155":{"start":{"line":347,"column":20},"end":{"line":347,"column":20}},"156":{"start":{"line":348,"column":20},"end":{"line":350,"column":21}},"157":{"start":{"line":349,"column":24},"end":{"line":349,"column":24}},"158":{"start":{"line":353,"column":16},"end":{"line":353,"column":16}},"159":{"start":{"line":354,"column":16},"end":{"line":354,"column":16}},"160":{"start":{"line":355,"column":20},"end":{"line":355,"column":20}},"161":{"start":{"line":356,"column":20},"end":{"line":356,"column":20}},"162":{"start":{"line":357,"column":20},"end":{"line":359,"column":21}},"163":{"start":{"line":358,"column":24},"end":{"line":358,"column":24}},"164":{"start":{"line":361,"column":16},"end":{"line":361,"column":16}},"165":{"start":{"line":362,"column":16},"end":{"line":362,"column":16}},"166":{"start":{"line":363,"column":20},"end":{"line":363,"column":20}},"167":{"start":{"line":364,"column":20},"end":{"line":364,"column":20}},"168":{"start":{"line":365,"column":20},"end":{"line":367,"column":21}},"169":{"start":{"line":366,"column":24},"end":{"line":366,"column":24}},"170":{"start":{"line":371,"column":8},"end":{"line":413,"column":9}},"171":{"start":{"line":373,"column":12},"end":{"line":373,"column":12}},"172":{"start":{"line":374,"column":12},"end":{"line":374,"column":12}},"173":{"start":{"line":375,"column":16},"end":{"line":375,"column":16}},"174":{"start":{"line":376,"column":16},"end":{"line":376,"column":16}},"175":{"start":{"line":377,"column":16},"end":{"line":384,"column":17}},"176":{"start":{"line":378,"column":20},"end":{"line":378,"column":20}},"177":{"start":{"line":380,"column":20},"end":{"line":380,"column":20}},"178":{"start":{"line":381,"column":20},"end":{"line":381,"column":20}},"179":{"start":{"line":382,"column":20},"end":{"line":382,"column":20}},"180":{"start":{"line":383,"column":20},"end":{"line":383,"column":20}},"181":{"start":{"line":385,"column":16},"end":{"line":387,"column":17}},"182":{"start":{"line":386,"column":20},"end":{"line":386,"column":20}},"183":{"start":{"line":388,"column":16},"end":{"line":390,"column":17}},"184":{"start":{"line":389,"column":20},"end":{"line":389,"column":20}},"185":{"start":{"line":392,"column":12},"end":{"line":412,"column":13}},"186":{"start":{"line":393,"column":16},"end":{"line":393,"column":16}},"187":{"start":{"line":394,"column":16},"end":{"line":394,"column":16}},"188":{"start":{"line":395,"column":20},"end":{"line":395,"column":20}},"189":{"start":{"line":396,"column":20},"end":{"line":396,"column":20}},"190":{"start":{"line":397,"column":20},"end":{"line":404,"column":21}},"191":{"start":{"line":398,"column":24},"end":{"line":398,"column":24}},"192":{"start":{"line":400,"column":24},"end":{"line":400,"column":24}},"193":{"start":{"line":401,"column":24},"end":{"line":401,"column":24}},"194":{"start":{"line":402,"column":24},"end":{"line":402,"column":24}},"195":{"start":{"line":403,"column":24},"end":{"line":403,"column":24}},"196":{"start":{"line":405,"column":20},"end":{"line":407,"column":21}},"197":{"start":{"line":406,"column":24},"end":{"line":406,"column":24}},"198":{"start":{"line":408,"column":20},"end":{"line":410,"column":21}},"199":{"start":{"line":409,"column":24},"end":{"line":409,"column":24}},"200":{"start":{"line":415,"column":8},"end":{"line":420,"column":61}},"201":{"start":{"line":417,"column":12},"end":{"line":417,"column":12}},"202":{"start":{"line":418,"column":12},"end":{"line":418,"column":12}},"203":{"start":{"line":420,"column":22},"end":{"line":420,"column":22}},"204":{"start":{"line":422,"column":8},"end":{"line":422,"column":8}},"205":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"206":{"start":{"line":429,"column":8},"end":{"line":429,"column":8}},"207":{"start":{"line":430,"column":8},"end":{"line":441,"column":9}},"208":{"start":{"line":431,"column":12},"end":{"line":435,"column":13}},"209":{"start":{"line":433,"column":16},"end":{"line":433,"column":16}},"210":{"start":{"line":436,"column":12},"end":{"line":440,"column":13}},"211":{"start":{"line":438,"column":16},"end":{"line":438,"column":16}},"212":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"213":{"start":{"line":448,"column":8},"end":{"line":448,"column":8}},"214":{"start":{"line":449,"column":8},"end":{"line":457,"column":9}},"215":{"start":{"line":451,"column":12},"end":{"line":451,"column":12}},"216":{"start":{"line":455,"column":12},"end":{"line":455,"column":12}},"217":{"start":{"line":458,"column":8},"end":{"line":466,"column":9}},"218":{"start":{"line":460,"column":12},"end":{"line":460,"column":12}},"219":{"start":{"line":464,"column":12},"end":{"line":464,"column":12}},"220":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"221":{"start":{"line":470,"column":8},"end":{"line":470,"column":8}},"222":{"start":{"line":471,"column":8},"end":{"line":473,"column":9}},"223":{"start":{"line":472,"column":12},"end":{"line":472,"column":12}},"224":{"start":{"line":474,"column":8},"end":{"line":474,"column":8}},"225":{"start":{"line":475,"column":8},"end":{"line":475,"column":8}},"226":{"start":{"line":476,"column":8},"end":{"line":478,"column":9}},"227":{"start":{"line":477,"column":12},"end":{"line":477,"column":12}},"228":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"229":{"start":{"line":484,"column":14},"end":{"line":484,"column":14}},"230":{"start":{"line":485,"column":8},"end":{"line":487,"column":9}},"231":{"start":{"line":486,"column":12},"end":{"line":486,"column":12}},"232":{"start":{"line":488,"column":8},"end":{"line":488,"column":8}},"233":{"start":{"line":489,"column":8},"end":{"line":501,"column":9}},"234":{"start":{"line":490,"column":12},"end":{"line":495,"column":13}},"235":{"start":{"line":492,"column":16},"end":{"line":492,"column":16}},"236":{"start":{"line":493,"column":16},"end":{"line":493,"column":16}},"237":{"start":{"line":496,"column":12},"end":{"line":500,"column":13}},"238":{"start":{"line":498,"column":16},"end":{"line":498,"column":16}},"239":{"start":{"line":503,"column":8},"end":{"line":503,"column":8}},"240":{"start":{"line":504,"column":12},"end":{"line":504,"column":12}},"241":{"start":{"line":505,"column":8},"end":{"line":505,"column":8}},"242":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"243":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"244":{"start":{"line":509,"column":0},"end":{"line":509,"column":0}}},"branchMap":{"1":{"line":17,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"2":{"line":19,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"3":{"line":19,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"4":{"line":19,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"5":{"line":21,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"6":{"line":21,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"7":{"line":21,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"8":{"line":21,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"9":{"line":21,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"10":{"line":82,"type":"cond-expr","locations":[{"start":{"line":66,"column":12},"end":{"line":65,"column":31}},{"start":{"line":66,"column":20},"end":{"line":65,"column":8}}]},"11":{"line":109,"type":"if","locations":[{"start":{"line":88,"column":8},"end":{"line":88,"column":8}},{"start":{"line":88,"column":8},"end":{"line":88,"column":8}}]},"12":{"line":113,"type":"if","locations":[{"start":{"line":92,"column":8},"end":{"line":92,"column":8}},{"start":{"line":92,"column":8},"end":{"line":92,"column":8}}]},"13":{"line":121,"type":"if","locations":[{"start":{"line":98,"column":8},"end":{"line":98,"column":8}},{"start":{"line":98,"column":8},"end":{"line":98,"column":8}}]},"14":{"line":121,"type":"binary-expr","locations":[{"start":{"line":98,"column":12},"end":{"line":98,"column":12}},{"start":{"line":98,"column":35},"end":{"line":98,"column":8}}]},"15":{"line":153,"type":"if","locations":[{"start":{"line":127,"column":8},"end":{"line":127,"column":8}},{"start":{"line":127,"column":8},"end":{"line":127,"column":8}}]},"16":{"line":153,"type":"binary-expr","locations":[{"start":{"line":127,"column":12},"end":{"line":127,"column":12}},{"start":{"line":127,"column":32},"end":{"line":127,"column":8}}]},"17":{"line":158,"type":"binary-expr","locations":[{"start":{"line":132,"column":23},"end":{"line":132,"column":23}},{"start":{"line":132,"column":39},"end":{"line":132,"column":12}}]},"18":{"line":161,"type":"binary-expr","locations":[{"start":{"line":135,"column":24},"end":{"line":135,"column":24}},{"start":{"line":135,"column":41},"end":{"line":135,"column":8}}]},"19":{"line":165,"type":"if","locations":[{"start":{"line":139,"column":8},"end":{"line":139,"column":8}},{"start":{"line":139,"column":8},"end":{"line":139,"column":8}}]},"20":{"line":166,"type":"binary-expr","locations":[{"start":{"line":140,"column":36},"end":{"line":140,"column":36}},{"start":{"line":140,"column":61},"end":{"line":140,"column":12}}]},"21":{"line":169,"type":"binary-expr","locations":[{"start":{"line":143,"column":30},"end":{"line":143,"column":30}},{"start":{"line":143,"column":53},"end":{"line":143,"column":8}}]},"22":{"line":174,"type":"if","locations":[{"start":{"line":148,"column":8},"end":{"line":148,"column":8}},{"start":{"line":148,"column":8},"end":{"line":148,"column":8}}]},"23":{"line":181,"type":"if","locations":[{"start":{"line":155,"column":20},"end":{"line":155,"column":20}},{"start":{"line":155,"column":20},"end":{"line":155,"column":20}}]},"24":{"line":191,"type":"if","locations":[{"start":{"line":165,"column":24},"end":{"line":165,"column":24}},{"start":{"line":165,"column":24},"end":{"line":165,"column":24}}]},"25":{"line":196,"type":"if","locations":[{"start":{"line":170,"column":24},"end":{"line":170,"column":24}},{"start":{"line":170,"column":24},"end":{"line":170,"column":24}}]},"26":{"line":203,"type":"if","locations":[{"start":{"line":177,"column":20},"end":{"line":177,"column":20}},{"start":{"line":177,"column":20},"end":{"line":177,"column":20}}]},"27":{"line":205,"type":"if","locations":[{"start":{"line":179,"column":24},"end":{"line":179,"column":24}},{"start":{"line":179,"column":24},"end":{"line":179,"column":24}}]},"28":{"line":208,"type":"if","locations":[{"start":{"line":182,"column":24},"end":{"line":182,"column":24}},{"start":{"line":182,"column":24},"end":{"line":182,"column":24}}]},"29":{"line":209,"type":"if","locations":[{"start":{"line":183,"column":28},"end":{"line":183,"column":28}},{"start":{"line":183,"column":28},"end":{"line":183,"column":28}}]},"30":{"line":209,"type":"binary-expr","locations":[{"start":{"line":183,"column":32},"end":{"line":183,"column":32}},{"start":{"line":184,"column":32},"end":{"line":183,"column":28}}]},"31":{"line":211,"type":"if","locations":[{"start":{"line":187,"column":33},"end":{"line":187,"column":33}},{"start":{"line":187,"column":33},"end":{"line":187,"column":33}}]},"32":{"line":211,"type":"binary-expr","locations":[{"start":{"line":187,"column":37},"end":{"line":187,"column":37}},{"start":{"line":187,"column":61},"end":{"line":187,"column":33}}]},"33":{"line":221,"type":"if","locations":[{"start":{"line":197,"column":16},"end":{"line":197,"column":16}},{"start":{"line":197,"column":16},"end":{"line":197,"column":16}}]},"34":{"line":226,"type":"cond-expr","locations":[{"start":{"line":203,"column":24},"end":{"line":202,"column":26}},{"start":{"line":203,"column":49},"end":{"line":200,"column":16}}]},"35":{"line":229,"type":"cond-expr","locations":[{"start":{"line":205,"column":59},"end":{"line":205,"column":27}},{"start":{"line":205,"column":73},"end":{"line":200,"column":16}}]},"36":{"line":232,"type":"cond-expr","locations":[{"start":{"line":207,"column":48},"end":{"line":207,"column":30}},{"start":{"line":207,"column":69},"end":{"line":200,"column":16}}]},"37":{"line":240,"type":"cond-expr","locations":[{"start":{"line":214,"column":25},"end":{"line":213,"column":24}},{"start":{"line":215,"column":24},"end":{"line":200,"column":16}}]},"38":{"line":240,"type":"binary-expr","locations":[{"start":{"line":213,"column":24},"end":{"line":213,"column":24}},{"start":{"line":213,"column":42},"end":{"line":213,"column":24}}]},"39":{"line":240,"type":"binary-expr","locations":[{"start":{"line":214,"column":25},"end":{"line":214,"column":25}},{"start":{"line":214,"column":35},"end":{"line":214,"column":25}},{"start":{"line":214,"column":56},"end":{"line":213,"column":24}}]},"40":{"line":244,"type":"if","locations":[{"start":{"line":219,"column":16},"end":{"line":219,"column":16}},{"start":{"line":219,"column":16},"end":{"line":219,"column":16}}]},"41":{"line":246,"type":"if","locations":[{"start":{"line":221,"column":20},"end":{"line":221,"column":20}},{"start":{"line":221,"column":20},"end":{"line":221,"column":20}}]},"42":{"line":248,"type":"if","locations":[{"start":{"line":223,"column":24},"end":{"line":223,"column":24}},{"start":{"line":223,"column":24},"end":{"line":223,"column":24}}]},"43":{"line":252,"type":"if","locations":[{"start":{"line":227,"column":28},"end":{"line":227,"column":28}},{"start":{"line":227,"column":28},"end":{"line":227,"column":28}}]},"44":{"line":260,"type":"if","locations":[{"start":{"line":235,"column":24},"end":{"line":235,"column":24}},{"start":{"line":235,"column":24},"end":{"line":235,"column":24}}]},"45":{"line":264,"type":"cond-expr","locations":[{"start":{"line":239,"column":47},"end":{"line":239,"column":43}},{"start":{"line":239,"column":51},"end":{"line":239,"column":28}}]},"46":{"line":272,"type":"if","locations":[{"start":{"line":247,"column":20},"end":{"line":247,"column":20}},{"start":{"line":247,"column":20},"end":{"line":247,"column":20}}]},"47":{"line":272,"type":"binary-expr","locations":[{"start":{"line":247,"column":24},"end":{"line":247,"column":24}},{"start":{"line":247,"column":42},"end":{"line":247,"column":20}}]},"48":{"line":276,"type":"if","locations":[{"start":{"line":251,"column":24},"end":{"line":251,"column":24}},{"start":{"line":251,"column":24},"end":{"line":251,"column":24}}]},"49":{"line":279,"type":"if","locations":[{"start":{"line":253,"column":28},"end":{"line":253,"column":28}},{"start":{"line":253,"column":28},"end":{"line":253,"column":28}}]},"50":{"line":287,"type":"if","locations":[{"start":{"line":261,"column":28},"end":{"line":261,"column":28}},{"start":{"line":261,"column":28},"end":{"line":261,"column":28}}]},"51":{"line":303,"type":"cond-expr","locations":[{"start":{"line":279,"column":20},"end":{"line":278,"column":26}},{"start":{"line":279,"column":45},"end":{"line":278,"column":16}}]},"52":{"line":304,"type":"if","locations":[{"start":{"line":280,"column":16},"end":{"line":280,"column":16}},{"start":{"line":280,"column":16},"end":{"line":280,"column":16}}]},"53":{"line":305,"type":"if","locations":[{"start":{"line":281,"column":20},"end":{"line":281,"column":20}},{"start":{"line":281,"column":20},"end":{"line":281,"column":20}}]},"54":{"line":314,"type":"if","locations":[{"start":{"line":291,"column":24},"end":{"line":291,"column":24}},{"start":{"line":291,"column":24},"end":{"line":291,"column":24}}]},"55":{"line":314,"type":"binary-expr","locations":[{"start":{"line":291,"column":29},"end":{"line":291,"column":28}},{"start":{"line":292,"column":28},"end":{"line":291,"column":24}}]},"56":{"line":316,"type":"if","locations":[{"start":{"line":295,"column":29},"end":{"line":295,"column":29}},{"start":{"line":295,"column":29},"end":{"line":295,"column":29}}]},"57":{"line":316,"type":"binary-expr","locations":[{"start":{"line":295,"column":34},"end":{"line":295,"column":33}},{"start":{"line":296,"column":28},"end":{"line":295,"column":29}}]},"58":{"line":318,"type":"if","locations":[{"start":{"line":299,"column":29},"end":{"line":299,"column":29}},{"start":{"line":299,"column":29},"end":{"line":299,"column":29}}]},"59":{"line":318,"type":"binary-expr","locations":[{"start":{"line":299,"column":33},"end":{"line":299,"column":33}},{"start":{"line":300,"column":28},"end":{"line":299,"column":29}}]},"60":{"line":320,"type":"if","locations":[{"start":{"line":303,"column":29},"end":{"line":303,"column":29}},{"start":{"line":303,"column":29},"end":{"line":303,"column":29}}]},"61":{"line":320,"type":"binary-expr","locations":[{"start":{"line":304,"column":28},"end":{"line":304,"column":28}},{"start":{"line":305,"column":28},"end":{"line":303,"column":29}}]},"62":{"line":328,"type":"if","locations":[{"start":{"line":313,"column":12},"end":{"line":313,"column":12}},{"start":{"line":313,"column":12},"end":{"line":313,"column":12}}]},"63":{"line":336,"type":"if","locations":[{"start":{"line":321,"column":20},"end":{"line":321,"column":20}},{"start":{"line":321,"column":20},"end":{"line":321,"column":20}}]},"64":{"line":342,"type":"if","locations":[{"start":{"line":327,"column":20},"end":{"line":327,"column":20}},{"start":{"line":327,"column":20},"end":{"line":327,"column":20}}]},"65":{"line":350,"type":"if","locations":[{"start":{"line":335,"column":12},"end":{"line":335,"column":12}},{"start":{"line":335,"column":12},"end":{"line":335,"column":12}}]},"66":{"line":355,"type":"if","locations":[{"start":{"line":340,"column":20},"end":{"line":340,"column":20}},{"start":{"line":340,"column":20},"end":{"line":340,"column":20}}]},"67":{"line":363,"type":"if","locations":[{"start":{"line":348,"column":20},"end":{"line":348,"column":20}},{"start":{"line":348,"column":20},"end":{"line":348,"column":20}}]},"68":{"line":372,"type":"if","locations":[{"start":{"line":357,"column":20},"end":{"line":357,"column":20}},{"start":{"line":357,"column":20},"end":{"line":357,"column":20}}]},"69":{"line":380,"type":"if","locations":[{"start":{"line":365,"column":20},"end":{"line":365,"column":20}},{"start":{"line":365,"column":20},"end":{"line":365,"column":20}}]},"70":{"line":386,"type":"if","locations":[{"start":{"line":371,"column":8},"end":{"line":371,"column":8}},{"start":{"line":371,"column":8},"end":{"line":371,"column":8}}]},"71":{"line":392,"type":"if","locations":[{"start":{"line":377,"column":16},"end":{"line":377,"column":16}},{"start":{"line":377,"column":16},"end":{"line":377,"column":16}}]},"72":{"line":400,"type":"if","locations":[{"start":{"line":385,"column":16},"end":{"line":385,"column":16}},{"start":{"line":385,"column":16},"end":{"line":385,"column":16}}]},"73":{"line":403,"type":"if","locations":[{"start":{"line":388,"column":16},"end":{"line":388,"column":16}},{"start":{"line":388,"column":16},"end":{"line":388,"column":16}}]},"74":{"line":407,"type":"if","locations":[{"start":{"line":392,"column":12},"end":{"line":392,"column":12}},{"start":{"line":392,"column":12},"end":{"line":392,"column":12}}]},"75":{"line":407,"type":"binary-expr","locations":[{"start":{"line":392,"column":16},"end":{"line":392,"column":16}},{"start":{"line":392,"column":31},"end":{"line":392,"column":12}}]},"76":{"line":412,"type":"if","locations":[{"start":{"line":397,"column":20},"end":{"line":397,"column":20}},{"start":{"line":397,"column":20},"end":{"line":397,"column":20}}]},"77":{"line":420,"type":"if","locations":[{"start":{"line":405,"column":20},"end":{"line":405,"column":20}},{"start":{"line":405,"column":20},"end":{"line":405,"column":20}}]},"78":{"line":423,"type":"if","locations":[{"start":{"line":408,"column":20},"end":{"line":408,"column":20}},{"start":{"line":408,"column":20},"end":{"line":408,"column":20}}]},"79":{"line":449,"type":"if","locations":[{"start":{"line":430,"column":8},"end":{"line":430,"column":8}},{"start":{"line":430,"column":8},"end":{"line":430,"column":8}}]},"80":{"line":450,"type":"if","locations":[{"start":{"line":431,"column":12},"end":{"line":431,"column":12}},{"start":{"line":431,"column":12},"end":{"line":431,"column":12}}]},"81":{"line":455,"type":"if","locations":[{"start":{"line":436,"column":12},"end":{"line":436,"column":12}},{"start":{"line":436,"column":12},"end":{"line":436,"column":12}}]},"82":{"line":470,"type":"if","locations":[{"start":{"line":449,"column":8},"end":{"line":449,"column":8}},{"start":{"line":449,"column":8},"end":{"line":449,"column":8}}]},"83":{"line":479,"type":"if","locations":[{"start":{"line":458,"column":8},"end":{"line":458,"column":8}},{"start":{"line":458,"column":8},"end":{"line":458,"column":8}}]},"84":{"line":492,"type":"if","locations":[{"start":{"line":471,"column":8},"end":{"line":471,"column":8}},{"start":{"line":471,"column":8},"end":{"line":471,"column":8}}]},"85":{"line":497,"type":"if","locations":[{"start":{"line":476,"column":8},"end":{"line":476,"column":8}},{"start":{"line":476,"column":8},"end":{"line":476,"column":8}}]},"86":{"line":510,"type":"if","locations":[{"start":{"line":485,"column":8},"end":{"line":485,"column":8}},{"start":{"line":485,"column":8},"end":{"line":485,"column":8}}]},"87":{"line":514,"type":"if","locations":[{"start":{"line":489,"column":8},"end":{"line":489,"column":8}},{"start":{"line":489,"column":8},"end":{"line":489,"column":8}}]},"88":{"line":515,"type":"if","locations":[{"start":{"line":490,"column":12},"end":{"line":490,"column":12}},{"start":{"line":490,"column":12},"end":{"line":490,"column":12}}]},"89":{"line":521,"type":"if","locations":[{"start":{"line":496,"column":12},"end":{"line":496,"column":12}},{"start":{"line":496,"column":12},"end":{"line":496,"column":12}}]}},"code":["import {Feature} from '../../feature';","import {tag} from '../../dom';","import {INPUT} from '../../const';","import {defaultsStr} from '../../settings';","import {root} from '../../root';","","const INSTANTIATION_ERROR = `Failed to instantiate EditTable object.","    \\n\"ezEditTable\" dependency not found.`;","","/**"," * Adapter module for ezEditTable, an external library providing advanced"," * grid features (selection and edition):"," * http://codecanyon.net/item/ezedittable-enhance-html-tables/2425123?ref=koalyptus"," */","export default class AdapterEzEditTable extends Feature {","","    /**","     * Creates an instance of AdapterEzEditTable","     *","     * @param {TableFilter} tf TableFilter instance","     * @param {Object} cfg Configuration options for ezEditTable library","     */","    constructor(tf, cfg) {","        super(tf, AdapterEzEditTable);","","        /**","         * Module description","         * @type {String}","         */","        this.desc = defaultsStr(cfg.description, 'ezEditTable adapter');","","        /**","         * Filename of ezEditTable library","         * @type {String}","         */","        this.filename = defaultsStr(cfg.filename, 'ezEditTable.js');","","        /**","         * Path to ezEditTable library","         * @type {String}","         */","        this.vendorPath = cfg.vendor_path;","","        /**","         * Load ezEditTable stylesheet","         * @type {Boolean}","         */","        this.loadStylesheet = Boolean(cfg.load_stylesheet);","","        /**","         * Path to ezEditTable stylesheet","         * @type {String}","         */","        this.stylesheet = defaultsStr(cfg.stylesheet,","            this.vendorPath + 'ezEditTable.css');","","        /**","         * Name of ezEditTable stylesheet","         * @type {String}","         */","        this.stylesheetName = defaultsStr(cfg.stylesheet_name,","            'ezEditTableCss');","","        // Enable the ezEditTable's scroll into view behaviour if grid layout on","        cfg.scroll_into_view = cfg.scroll_into_view === false ?","            false : tf.gridLayout;","","        /**","         * ezEditTable instance","         * @type {EditTable}","         * @private","         */","        this._ezEditTable = null;","","        /**","         * ezEditTable configuration","         * @private","         */","        this.cfg = cfg;","","        this.enable();","    }","","    /**","     * Conditionally load ezEditTable library and set advanced grid","     */","    init() {","        if (this.initialized) {","            return;","        }","        let tf = this.tf;","        if (root.EditTable) {","            this._setAdvancedGrid();","        } else {","            let path = this.vendorPath + this.filename;","            tf.import(this.filename, path, () => this._setAdvancedGrid());","        }","        if (this.loadStylesheet && !tf.isImported(this.stylesheet, 'link')) {","            tf.import(this.stylesheetName, this.stylesheet, null, 'link');","        }","","        // TODO: hack to prevent ezEditTable enter key event hijaking.","        // Needs to be fixed in the vendor's library","        this.emitter.on(['filter-focus', 'filter-blur'],","            () => this._toggleForInputFilter());","","        /**","         * @inherited","         */","        this.initialized = true;","    }","","    /**","     * Instantiate ezEditTable component for advanced grid features","     * @private","     */","    _setAdvancedGrid() {","        let tf = this.tf;","","        //start row for EditTable constructor needs to be calculated","        let startRow,","            cfg = this.cfg,","            thead = tag(tf.dom(), 'thead');","","        //if thead exists and startRow not specified, startRow is calculated","        //automatically by EditTable","        if (thead.length > 0 && !cfg.startRow) {","            startRow = undefined;","        }","        //otherwise startRow config property if any or TableFilter refRow","        else {","            startRow = cfg.startRow || tf.refRow;","        }","","        cfg.base_path = cfg.base_path || tf.basePath + 'ezEditTable/';","        let editable = cfg.editable;","        let selectable = cfg.selection;","","        if (selectable) {","            cfg.default_selection = cfg.default_selection || 'row';","        }","        //CSS Styles","        cfg.active_cell_css = cfg.active_cell_css || 'ezETSelectedCell';","","        let _lastValidRowIndex = 0;","        let _lastRowIndex = 0;","","        if (selectable) {","            //Row navigation needs to be calculated according to TableFilter's","            //validRowsIndex array","            let onAfterSelection = function (et, selectedElm, e) {","                let slc = et.Selection;","                //Next valid filtered row needs to be selected","                let doSelect = function (nextRowIndex) {","                    if (et.defaultSelection === 'row') {","                        /* eslint-disable */","                        slc.SelectRowByIndex(nextRowIndex);","                        /* eslint-enable */","                    } else {","                        /* eslint-disable */","                        et.ClearSelections();","                        /* eslint-enable */","                        let cellIndex = selectedElm.cellIndex,","                            row = tf.dom().rows[nextRowIndex];","                        if (et.defaultSelection === 'both') {","                            /* eslint-disable */","                            slc.SelectRowByIndex(nextRowIndex);","                            /* eslint-enable */","                        }","                        if (row) {","                            /* eslint-disable */","                            slc.SelectCell(row.cells[cellIndex]);","                            /* eslint-enable */","                        }","                    }","                    //Table is filtered","                    if (tf.validRowsIndex.length !== tf.getRowsNb()) {","                        let r = tf.dom().rows[nextRowIndex];","                        if (r) {","                            r.scrollIntoView(false);","                        }","                        if (cell) {","                            if (cell.cellIndex === (tf.getCellsNb() - 1) &&","                                tf.gridLayout) {","                                tf.tblCont.scrollLeft = 100000000;","                            }","                            else if (cell.cellIndex === 0 && tf.gridLayout) {","                                tf.tblCont.scrollLeft = 0;","                            } else {","                                cell.scrollIntoView(false);","                            }","                        }","                    }","                };","","                //table is not filtered","                if (!tf.validRowsIndex) {","                    return;","                }","                let validIndexes = tf.validRowsIndex,","                    validIdxLen = validIndexes.length,","                    row = et.defaultSelection !== 'row' ?","                        selectedElm.parentNode : selectedElm,","                    //cell for default_selection = 'both' or 'cell'","                    cell = selectedElm.nodeName === 'TD' ? selectedElm : null,","                    /* eslint-disable */","                    keyCode = e !== undefined ? et.Event.GetKey(e) : 0,","                    /* eslint-enable */","                    isRowValid = validIndexes.indexOf(row.rowIndex) !== -1,","                    nextRowIndex,","                    paging = tf.feature('paging'),","                    //pgup/pgdown keys","                    d = keyCode === 34 || keyCode === 33 ?","                        (paging && paging.pageLength || et.nbRowsPerPage) :","                        1;","","                //If next row is not valid, next valid filtered row needs to be","                //calculated","                if (!isRowValid) {","                    //Selection direction up/down","                    if (row.rowIndex > _lastRowIndex) {","                        //last row","                        if (row.rowIndex >= validIndexes[validIdxLen - 1]) {","                            nextRowIndex = validIndexes[validIdxLen - 1];","                        } else {","                            let calcRowIndex = (_lastValidRowIndex + d);","                            if (calcRowIndex > (validIdxLen - 1)) {","                                nextRowIndex = validIndexes[validIdxLen - 1];","                            } else {","                                nextRowIndex = validIndexes[calcRowIndex];","                            }","                        }","                    } else {","                        //first row","                        if (row.rowIndex <= validIndexes[0]) {","                            nextRowIndex = validIndexes[0];","                        } else {","                            let v = validIndexes[_lastValidRowIndex - d];","                            nextRowIndex = v ? v : validIndexes[0];","                        }","                    }","                    _lastRowIndex = row.rowIndex;","                    doSelect(nextRowIndex);","                } else {","                    //If filtered row is valid, special calculation for","                    //pgup/pgdown keys","                    if (keyCode !== 34 && keyCode !== 33) {","                        _lastValidRowIndex = validIndexes.indexOf(row.rowIndex);","                        _lastRowIndex = row.rowIndex;","                    } else {","                        if (keyCode === 34) { //pgdown","                            //last row","                            if ((_lastValidRowIndex + d) <= (validIdxLen - 1)) {","                                nextRowIndex = validIndexes[","                                    _lastValidRowIndex + d];","                            } else {","                                nextRowIndex = [validIdxLen - 1];","                            }","                        } else { //pgup","                            //first row","                            if ((_lastValidRowIndex - d) <= validIndexes[0]) {","                                nextRowIndex = validIndexes[0];","                            } else {","                                nextRowIndex = validIndexes[","                                    _lastValidRowIndex - d];","                            }","                        }","                        _lastRowIndex = nextRowIndex;","                        _lastValidRowIndex = validIndexes.indexOf(nextRowIndex);","                        doSelect(nextRowIndex);","                    }","                }","            };","","            //Page navigation has to be enforced whenever selected row is out of","            //the current page range","            let onBeforeSelection = function (et, selectedElm) {","                let row = et.defaultSelection !== 'row' ?","                    selectedElm.parentNode : selectedElm;","                if (tf.paging) {","                    if (tf.feature('paging').nbPages > 1) {","                        let paging = tf.feature('paging');","                        //page length is re-assigned in case it has changed","                        et.nbRowsPerPage = paging.pageLength;","                        let validIndexes = tf.validRowsIndex,","                            validIdxLen = validIndexes.length,","                            pagingEndRow = parseInt(paging.startPagingRow, 10) +","                                parseInt(paging.pageLength, 10);","                        let rowIndex = row.rowIndex;","","                        if ((rowIndex === validIndexes[validIdxLen - 1]) &&","                            paging.currentPageNb !== paging.nbPages) {","                            paging.setPage('last');","                        }","                        else if ((rowIndex === validIndexes[0]) &&","                            paging.currentPageNb !== 1) {","                            paging.setPage('first');","                        }","                        else if (rowIndex > validIndexes[pagingEndRow - 1] &&","                            rowIndex < validIndexes[validIdxLen - 1]) {","                            paging.setPage('next');","                        }","                        else if (","                            rowIndex < validIndexes[paging.startPagingRow] &&","                            rowIndex > validIndexes[0]) {","                            paging.setPage('previous');","                        }","                    }","                }","            };","","            //Selected row needs to be visible when paging is activated","            if (tf.paging) {","                tf.feature('paging').onAfterChangePage = function (paging) {","                    let advGrid = paging.tf.extension('advancedGrid');","                    let et = advGrid._ezEditTable;","                    let slc = et.Selection;","                    /* eslint-disable */","                    let row = slc.GetActiveRow();","                    /* eslint-enable */","                    if (row) {","                        row.scrollIntoView(false);","                    }","                    /* eslint-disable */","                    let cell = slc.GetActiveCell();","                    /* eslint-enable */","                    if (cell) {","                        cell.scrollIntoView(false);","                    }","                };","            }","","            //Rows navigation when rows are filtered is performed with the","            //EditTable row selection callback events","            if (cfg.default_selection === 'row') {","                let fnB = cfg.on_before_selected_row;","                cfg.on_before_selected_row = function () {","                    var args = arguments;","                    onBeforeSelection(args[0], args[1], args[2]);","                    if (fnB) {","                        fnB.call(null, args[0], args[1], args[2]);","                    }","                };","                let fnA = cfg.on_after_selected_row;","                cfg.on_after_selected_row = function () {","                    var args = arguments;","                    onAfterSelection(args[0], args[1], args[2]);","                    if (fnA) {","                        fnA.call(null, args[0], args[1], args[2]);","                    }","                };","            } else {","                let fnD = cfg.on_before_selected_cell;","                cfg.on_before_selected_cell = function () {","                    var args = arguments;","                    onBeforeSelection(args[0], args[1], args[2]);","                    if (fnD) {","                        fnD.call(null, args[0], args[1], args[2]);","                    }","                };","                let fnC = cfg.on_after_selected_cell;","                cfg.on_after_selected_cell = function () {","                    var args = arguments;","                    onAfterSelection(args[0], args[1], args[2]);","                    if (fnC) {","                        fnC.call(null, args[0], args[1], args[2]);","                    }","                };","            }","        }","        if (editable) {","            //Added or removed rows, TF rows number needs to be re-calculated","            let fnE = cfg.on_added_dom_row;","            cfg.on_added_dom_row = function () {","                var args = arguments;","                tf.nbFilterableRows++;","                if (!tf.paging) {","                    tf.emitter.emit('rows-changed', tf, this);","                } else {","                    tf.nbFilterableRows++;","                    tf.paging = false;","                    tf.feature('paging').destroy();","                    tf.feature('paging').reset();","                }","                if (tf.alternateRows) {","                    tf.feature('alternateRows').init();","                }","                if (fnE) {","                    fnE.call(null, args[0], args[1], args[2]);","                }","            };","            if (cfg.actions && cfg.actions['delete']) {","                let fnF = cfg.actions['delete'].on_after_submit;","                cfg.actions['delete'].on_after_submit = function () {","                    var args = arguments;","                    tf.nbFilterableRows--;","                    if (!tf.paging) {","                        tf.emitter.emit('rows-changed', tf, this);","                    } else {","                        tf.nbFilterableRows--;","                        tf.paging = false;","                        tf.feature('paging').destroy();","                        tf.feature('paging').reset(false);","                    }","                    if (tf.alternateRows) {","                        tf.feature('alternateRows').init();","                    }","                    if (fnF) {","                        fnF.call(null, args[0], args[1]);","                    }","                };","            }","        }","","        try {","            /* eslint-disable */","            this._ezEditTable = new EditTable(tf.id, cfg, startRow);","            this._ezEditTable.Init();","            /* eslint-enable */","        } catch (e) { throw new Error(INSTANTIATION_ERROR); }","","        this.initialized = true;","    }","","    /**","     * Reset advanced grid when previously removed","     */","    reset() {","        let ezEditTable = this._ezEditTable;","        if (ezEditTable) {","            if (this.cfg.selection) {","                /* eslint-disable */","                ezEditTable.Selection.Set();","                /* eslint-enable */","            }","            if (this.cfg.editable) {","                /* eslint-disable */","                ezEditTable.Editable.Set();","                /* eslint-enable */","            }","        }","    }","","    /**","     * Toggle behaviour","     */","    toggle() {","        let ezEditTable = this._ezEditTable;","        if (ezEditTable.editable) {","            /* eslint-disable */","            ezEditTable.Editable.Remove();","            /* eslint-enable */","        } else {","            /* eslint-disable */","            ezEditTable.Editable.Set();","            /* eslint-enable */","        }","        if (ezEditTable.selection) {","            /* eslint-disable */","            ezEditTable.Selection.Remove();","            /* eslint-enable */","        } else {","            /* eslint-disable */","            ezEditTable.Selection.Set();","            /* eslint-enable */","        }","    }","","    _toggleForInputFilter() {","        let tf = this.tf;","        if (!tf.getActiveFilterId()) {","            return;","        }","        let colIndex = tf.getColumnIndexFromFilterId(tf.getActiveFilterId());","        let filterType = tf.getFilterType(colIndex);","        if (filterType === INPUT) {","            this.toggle();","        }","    }","","    /**","     * Remove advanced grid","     */","    destroy() {","        if (!this.initialized) {","            return;","        }","        let ezEditTable = this._ezEditTable;","        if (ezEditTable) {","            if (this.cfg.selection) {","                /* eslint-disable */","                ezEditTable.Selection.ClearSelections();","                ezEditTable.Selection.Remove();","                /* eslint-enable */","            }","            if (this.cfg.editable) {","                /* eslint-disable */","                ezEditTable.Editable.Remove();","                /* eslint-enable */","            }","        }","","        this.emitter.off(['filter-focus', 'filter-blur'],","            () => this._toggleForInputFilter());","        this.initialized = false;","    }","}","","AdapterEzEditTable.meta = {altName: 'advancedGrid'};",""]};
}
__cov_8CdxqQjta0kgBZMP6kX7FA = __cov_8CdxqQjta0kgBZMP6kX7FA['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\advancedGrid\\adapterEzEditTable.js'];
__cov_8CdxqQjta0kgBZMP6kX7FA.s['1']++;Object.defineProperty(exports,'__esModule',{value:true});__cov_8CdxqQjta0kgBZMP6kX7FA.s['2']++;var _feature=__webpack_require__(/*! ../../feature */ "./src/feature.js");__cov_8CdxqQjta0kgBZMP6kX7FA.s['3']++;var _dom=__webpack_require__(/*! ../../dom */ "./src/dom.js");__cov_8CdxqQjta0kgBZMP6kX7FA.s['4']++;var _const=__webpack_require__(/*! ../../const */ "./src/const.js");__cov_8CdxqQjta0kgBZMP6kX7FA.s['5']++;var _settings=__webpack_require__(/*! ../../settings */ "./src/settings.js");__cov_8CdxqQjta0kgBZMP6kX7FA.s['6']++;var _root=__webpack_require__(/*! ../../root */ "./src/root.js");function _classCallCheck(instance,Constructor){__cov_8CdxqQjta0kgBZMP6kX7FA.f['1']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['8']++;if(!(instance instanceof Constructor)){__cov_8CdxqQjta0kgBZMP6kX7FA.b['1'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['9']++;throw new TypeError('Cannot call a class as a function');}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['1'][1]++;}}function _possibleConstructorReturn(self,call){__cov_8CdxqQjta0kgBZMP6kX7FA.f['2']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['11']++;if(!self){__cov_8CdxqQjta0kgBZMP6kX7FA.b['2'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['12']++;throw new ReferenceError('this hasn\'t been initialised - super() hasn\'t been called');}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['2'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['13']++;return(__cov_8CdxqQjta0kgBZMP6kX7FA.b['4'][0]++,call)&&((__cov_8CdxqQjta0kgBZMP6kX7FA.b['4'][1]++,typeof call==='object')||(__cov_8CdxqQjta0kgBZMP6kX7FA.b['4'][2]++,typeof call==='function'))?(__cov_8CdxqQjta0kgBZMP6kX7FA.b['3'][0]++,call):(__cov_8CdxqQjta0kgBZMP6kX7FA.b['3'][1]++,self);}function _inherits(subClass,superClass){__cov_8CdxqQjta0kgBZMP6kX7FA.f['3']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['15']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['6'][0]++,typeof superClass!=='function')&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['6'][1]++,superClass!==null)){__cov_8CdxqQjta0kgBZMP6kX7FA.b['5'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['16']++;throw new TypeError('Super expression must either be null or a function, not '+typeof superClass);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['5'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['17']++;subClass.prototype=Object.create((__cov_8CdxqQjta0kgBZMP6kX7FA.b['7'][0]++,superClass)&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['7'][1]++,superClass.prototype),{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});__cov_8CdxqQjta0kgBZMP6kX7FA.s['18']++;if(superClass){__cov_8CdxqQjta0kgBZMP6kX7FA.b['8'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['19']++;Object.setPrototypeOf?(__cov_8CdxqQjta0kgBZMP6kX7FA.b['9'][0]++,Object.setPrototypeOf(subClass,superClass)):(__cov_8CdxqQjta0kgBZMP6kX7FA.b['9'][1]++,subClass.__proto__=superClass);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['8'][1]++;}}__cov_8CdxqQjta0kgBZMP6kX7FA.s['20']++;var INSTANTIATION_ERROR='Failed to instantiate EditTable object.\n    \n"ezEditTable" dependency not found.';__cov_8CdxqQjta0kgBZMP6kX7FA.s['21']++;var AdapterEzEditTable=function(_Feature){__cov_8CdxqQjta0kgBZMP6kX7FA.f['4']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['22']++;_inherits(AdapterEzEditTable,_Feature);function AdapterEzEditTable(tf,cfg){__cov_8CdxqQjta0kgBZMP6kX7FA.f['5']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['24']++;_classCallCheck(this,AdapterEzEditTable);__cov_8CdxqQjta0kgBZMP6kX7FA.s['25']++;var _this=_possibleConstructorReturn(this,_Feature.call(this,tf,AdapterEzEditTable));__cov_8CdxqQjta0kgBZMP6kX7FA.s['26']++;_this.desc=(0,_settings.defaultsStr)(cfg.description,'ezEditTable adapter');__cov_8CdxqQjta0kgBZMP6kX7FA.s['27']++;_this.filename=(0,_settings.defaultsStr)(cfg.filename,'ezEditTable.js');__cov_8CdxqQjta0kgBZMP6kX7FA.s['28']++;_this.vendorPath=cfg.vendor_path;__cov_8CdxqQjta0kgBZMP6kX7FA.s['29']++;_this.loadStylesheet=Boolean(cfg.load_stylesheet);__cov_8CdxqQjta0kgBZMP6kX7FA.s['30']++;_this.stylesheet=(0,_settings.defaultsStr)(cfg.stylesheet,_this.vendorPath+'ezEditTable.css');__cov_8CdxqQjta0kgBZMP6kX7FA.s['31']++;_this.stylesheetName=(0,_settings.defaultsStr)(cfg.stylesheet_name,'ezEditTableCss');__cov_8CdxqQjta0kgBZMP6kX7FA.s['32']++;cfg.scroll_into_view=cfg.scroll_into_view===false?(__cov_8CdxqQjta0kgBZMP6kX7FA.b['10'][0]++,false):(__cov_8CdxqQjta0kgBZMP6kX7FA.b['10'][1]++,tf.gridLayout);__cov_8CdxqQjta0kgBZMP6kX7FA.s['33']++;_this._ezEditTable=null;__cov_8CdxqQjta0kgBZMP6kX7FA.s['34']++;_this.cfg=cfg;__cov_8CdxqQjta0kgBZMP6kX7FA.s['35']++;_this.enable();__cov_8CdxqQjta0kgBZMP6kX7FA.s['36']++;return _this;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['37']++;AdapterEzEditTable.prototype.init=function init(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['6']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['38']++;var _this2=this;__cov_8CdxqQjta0kgBZMP6kX7FA.s['39']++;if(this.initialized){__cov_8CdxqQjta0kgBZMP6kX7FA.b['11'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['40']++;return;}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['11'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['41']++;var tf=this.tf;__cov_8CdxqQjta0kgBZMP6kX7FA.s['42']++;if(_root.root.EditTable){__cov_8CdxqQjta0kgBZMP6kX7FA.b['12'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['43']++;this._setAdvancedGrid();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['12'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['44']++;var path=this.vendorPath+this.filename;__cov_8CdxqQjta0kgBZMP6kX7FA.s['45']++;tf.import(this.filename,path,function(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['7']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['46']++;return _this2._setAdvancedGrid();});}__cov_8CdxqQjta0kgBZMP6kX7FA.s['47']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['14'][0]++,this.loadStylesheet)&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['14'][1]++,!tf.isImported(this.stylesheet,'link'))){__cov_8CdxqQjta0kgBZMP6kX7FA.b['13'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['48']++;tf.import(this.stylesheetName,this.stylesheet,null,'link');}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['13'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['49']++;this.emitter.on(['filter-focus','filter-blur'],function(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['8']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['50']++;return _this2._toggleForInputFilter();});__cov_8CdxqQjta0kgBZMP6kX7FA.s['51']++;this.initialized=true;};__cov_8CdxqQjta0kgBZMP6kX7FA.s['52']++;AdapterEzEditTable.prototype._setAdvancedGrid=function _setAdvancedGrid(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['9']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['53']++;var tf=this.tf;__cov_8CdxqQjta0kgBZMP6kX7FA.s['54']++;var startRow=void 0,cfg=this.cfg,thead=(0,_dom.tag)(tf.dom(),'thead');__cov_8CdxqQjta0kgBZMP6kX7FA.s['55']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['16'][0]++,thead.length>0)&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['16'][1]++,!cfg.startRow)){__cov_8CdxqQjta0kgBZMP6kX7FA.b['15'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['56']++;startRow=undefined;}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['15'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['57']++;startRow=(__cov_8CdxqQjta0kgBZMP6kX7FA.b['17'][0]++,cfg.startRow)||(__cov_8CdxqQjta0kgBZMP6kX7FA.b['17'][1]++,tf.refRow);}__cov_8CdxqQjta0kgBZMP6kX7FA.s['58']++;cfg.base_path=(__cov_8CdxqQjta0kgBZMP6kX7FA.b['18'][0]++,cfg.base_path)||(__cov_8CdxqQjta0kgBZMP6kX7FA.b['18'][1]++,tf.basePath+'ezEditTable/');__cov_8CdxqQjta0kgBZMP6kX7FA.s['59']++;var editable=cfg.editable;__cov_8CdxqQjta0kgBZMP6kX7FA.s['60']++;var selectable=cfg.selection;__cov_8CdxqQjta0kgBZMP6kX7FA.s['61']++;if(selectable){__cov_8CdxqQjta0kgBZMP6kX7FA.b['19'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['62']++;cfg.default_selection=(__cov_8CdxqQjta0kgBZMP6kX7FA.b['20'][0]++,cfg.default_selection)||(__cov_8CdxqQjta0kgBZMP6kX7FA.b['20'][1]++,'row');}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['19'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['63']++;cfg.active_cell_css=(__cov_8CdxqQjta0kgBZMP6kX7FA.b['21'][0]++,cfg.active_cell_css)||(__cov_8CdxqQjta0kgBZMP6kX7FA.b['21'][1]++,'ezETSelectedCell');__cov_8CdxqQjta0kgBZMP6kX7FA.s['64']++;var _lastValidRowIndex=0;__cov_8CdxqQjta0kgBZMP6kX7FA.s['65']++;var _lastRowIndex=0;__cov_8CdxqQjta0kgBZMP6kX7FA.s['66']++;if(selectable){__cov_8CdxqQjta0kgBZMP6kX7FA.b['22'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['67']++;var onAfterSelection=function onAfterSelection(et,selectedElm,e){__cov_8CdxqQjta0kgBZMP6kX7FA.f['10']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['68']++;var slc=et.Selection;__cov_8CdxqQjta0kgBZMP6kX7FA.s['69']++;var doSelect=function doSelect(nextRowIndex){__cov_8CdxqQjta0kgBZMP6kX7FA.f['11']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['70']++;if(et.defaultSelection==='row'){__cov_8CdxqQjta0kgBZMP6kX7FA.b['23'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['71']++;slc.SelectRowByIndex(nextRowIndex);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['23'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['72']++;et.ClearSelections();__cov_8CdxqQjta0kgBZMP6kX7FA.s['73']++;var cellIndex=selectedElm.cellIndex,_row=tf.dom().rows[nextRowIndex];__cov_8CdxqQjta0kgBZMP6kX7FA.s['74']++;if(et.defaultSelection==='both'){__cov_8CdxqQjta0kgBZMP6kX7FA.b['24'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['75']++;slc.SelectRowByIndex(nextRowIndex);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['24'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['76']++;if(_row){__cov_8CdxqQjta0kgBZMP6kX7FA.b['25'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['77']++;slc.SelectCell(_row.cells[cellIndex]);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['25'][1]++;}}__cov_8CdxqQjta0kgBZMP6kX7FA.s['78']++;if(tf.validRowsIndex.length!==tf.getRowsNb()){__cov_8CdxqQjta0kgBZMP6kX7FA.b['26'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['79']++;var r=tf.dom().rows[nextRowIndex];__cov_8CdxqQjta0kgBZMP6kX7FA.s['80']++;if(r){__cov_8CdxqQjta0kgBZMP6kX7FA.b['27'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['81']++;r.scrollIntoView(false);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['27'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['82']++;if(cell){__cov_8CdxqQjta0kgBZMP6kX7FA.b['28'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['83']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['30'][0]++,cell.cellIndex===tf.getCellsNb()-1)&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['30'][1]++,tf.gridLayout)){__cov_8CdxqQjta0kgBZMP6kX7FA.b['29'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['84']++;tf.tblCont.scrollLeft=100000000;}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['29'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['85']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['32'][0]++,cell.cellIndex===0)&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['32'][1]++,tf.gridLayout)){__cov_8CdxqQjta0kgBZMP6kX7FA.b['31'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['86']++;tf.tblCont.scrollLeft=0;}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['31'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['87']++;cell.scrollIntoView(false);}}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['28'][1]++;}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['26'][1]++;}};__cov_8CdxqQjta0kgBZMP6kX7FA.s['88']++;if(!tf.validRowsIndex){__cov_8CdxqQjta0kgBZMP6kX7FA.b['33'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['89']++;return;}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['33'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['90']++;var validIndexes=tf.validRowsIndex,validIdxLen=validIndexes.length,row=et.defaultSelection!=='row'?(__cov_8CdxqQjta0kgBZMP6kX7FA.b['34'][0]++,selectedElm.parentNode):(__cov_8CdxqQjta0kgBZMP6kX7FA.b['34'][1]++,selectedElm),cell=selectedElm.nodeName==='TD'?(__cov_8CdxqQjta0kgBZMP6kX7FA.b['35'][0]++,selectedElm):(__cov_8CdxqQjta0kgBZMP6kX7FA.b['35'][1]++,null),keyCode=e!==undefined?(__cov_8CdxqQjta0kgBZMP6kX7FA.b['36'][0]++,et.Event.GetKey(e)):(__cov_8CdxqQjta0kgBZMP6kX7FA.b['36'][1]++,0),isRowValid=validIndexes.indexOf(row.rowIndex)!==-1,nextRowIndex=void 0,paging=tf.feature('paging'),d=(__cov_8CdxqQjta0kgBZMP6kX7FA.b['38'][0]++,keyCode===34)||(__cov_8CdxqQjta0kgBZMP6kX7FA.b['38'][1]++,keyCode===33)?(__cov_8CdxqQjta0kgBZMP6kX7FA.b['37'][0]++,(__cov_8CdxqQjta0kgBZMP6kX7FA.b['39'][0]++,paging)&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['39'][1]++,paging.pageLength)||(__cov_8CdxqQjta0kgBZMP6kX7FA.b['39'][2]++,et.nbRowsPerPage)):(__cov_8CdxqQjta0kgBZMP6kX7FA.b['37'][1]++,1);__cov_8CdxqQjta0kgBZMP6kX7FA.s['91']++;if(!isRowValid){__cov_8CdxqQjta0kgBZMP6kX7FA.b['40'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['92']++;if(row.rowIndex>_lastRowIndex){__cov_8CdxqQjta0kgBZMP6kX7FA.b['41'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['93']++;if(row.rowIndex>=validIndexes[validIdxLen-1]){__cov_8CdxqQjta0kgBZMP6kX7FA.b['42'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['94']++;nextRowIndex=validIndexes[validIdxLen-1];}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['42'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['95']++;var calcRowIndex=_lastValidRowIndex+d;__cov_8CdxqQjta0kgBZMP6kX7FA.s['96']++;if(calcRowIndex>validIdxLen-1){__cov_8CdxqQjta0kgBZMP6kX7FA.b['43'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['97']++;nextRowIndex=validIndexes[validIdxLen-1];}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['43'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['98']++;nextRowIndex=validIndexes[calcRowIndex];}}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['41'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['99']++;if(row.rowIndex<=validIndexes[0]){__cov_8CdxqQjta0kgBZMP6kX7FA.b['44'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['100']++;nextRowIndex=validIndexes[0];}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['44'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['101']++;var v=validIndexes[_lastValidRowIndex-d];__cov_8CdxqQjta0kgBZMP6kX7FA.s['102']++;nextRowIndex=v?(__cov_8CdxqQjta0kgBZMP6kX7FA.b['45'][0]++,v):(__cov_8CdxqQjta0kgBZMP6kX7FA.b['45'][1]++,validIndexes[0]);}}__cov_8CdxqQjta0kgBZMP6kX7FA.s['103']++;_lastRowIndex=row.rowIndex;__cov_8CdxqQjta0kgBZMP6kX7FA.s['104']++;doSelect(nextRowIndex);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['40'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['105']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['47'][0]++,keyCode!==34)&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['47'][1]++,keyCode!==33)){__cov_8CdxqQjta0kgBZMP6kX7FA.b['46'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['106']++;_lastValidRowIndex=validIndexes.indexOf(row.rowIndex);__cov_8CdxqQjta0kgBZMP6kX7FA.s['107']++;_lastRowIndex=row.rowIndex;}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['46'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['108']++;if(keyCode===34){__cov_8CdxqQjta0kgBZMP6kX7FA.b['48'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['109']++;if(_lastValidRowIndex+d<=validIdxLen-1){__cov_8CdxqQjta0kgBZMP6kX7FA.b['49'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['110']++;nextRowIndex=validIndexes[_lastValidRowIndex+d];}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['49'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['111']++;nextRowIndex=[validIdxLen-1];}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['48'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['112']++;if(_lastValidRowIndex-d<=validIndexes[0]){__cov_8CdxqQjta0kgBZMP6kX7FA.b['50'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['113']++;nextRowIndex=validIndexes[0];}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['50'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['114']++;nextRowIndex=validIndexes[_lastValidRowIndex-d];}}__cov_8CdxqQjta0kgBZMP6kX7FA.s['115']++;_lastRowIndex=nextRowIndex;__cov_8CdxqQjta0kgBZMP6kX7FA.s['116']++;_lastValidRowIndex=validIndexes.indexOf(nextRowIndex);__cov_8CdxqQjta0kgBZMP6kX7FA.s['117']++;doSelect(nextRowIndex);}}};__cov_8CdxqQjta0kgBZMP6kX7FA.s['118']++;var onBeforeSelection=function onBeforeSelection(et,selectedElm){__cov_8CdxqQjta0kgBZMP6kX7FA.f['12']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['119']++;var row=et.defaultSelection!=='row'?(__cov_8CdxqQjta0kgBZMP6kX7FA.b['51'][0]++,selectedElm.parentNode):(__cov_8CdxqQjta0kgBZMP6kX7FA.b['51'][1]++,selectedElm);__cov_8CdxqQjta0kgBZMP6kX7FA.s['120']++;if(tf.paging){__cov_8CdxqQjta0kgBZMP6kX7FA.b['52'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['121']++;if(tf.feature('paging').nbPages>1){__cov_8CdxqQjta0kgBZMP6kX7FA.b['53'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['122']++;var paging=tf.feature('paging');__cov_8CdxqQjta0kgBZMP6kX7FA.s['123']++;et.nbRowsPerPage=paging.pageLength;__cov_8CdxqQjta0kgBZMP6kX7FA.s['124']++;var validIndexes=tf.validRowsIndex,validIdxLen=validIndexes.length,pagingEndRow=parseInt(paging.startPagingRow,10)+parseInt(paging.pageLength,10);__cov_8CdxqQjta0kgBZMP6kX7FA.s['125']++;var rowIndex=row.rowIndex;__cov_8CdxqQjta0kgBZMP6kX7FA.s['126']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['55'][0]++,rowIndex===validIndexes[validIdxLen-1])&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['55'][1]++,paging.currentPageNb!==paging.nbPages)){__cov_8CdxqQjta0kgBZMP6kX7FA.b['54'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['127']++;paging.setPage('last');}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['54'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['128']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['57'][0]++,rowIndex===validIndexes[0])&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['57'][1]++,paging.currentPageNb!==1)){__cov_8CdxqQjta0kgBZMP6kX7FA.b['56'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['129']++;paging.setPage('first');}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['56'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['130']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['59'][0]++,rowIndex>validIndexes[pagingEndRow-1])&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['59'][1]++,rowIndex<validIndexes[validIdxLen-1])){__cov_8CdxqQjta0kgBZMP6kX7FA.b['58'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['131']++;paging.setPage('next');}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['58'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['132']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['61'][0]++,rowIndex<validIndexes[paging.startPagingRow])&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['61'][1]++,rowIndex>validIndexes[0])){__cov_8CdxqQjta0kgBZMP6kX7FA.b['60'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['133']++;paging.setPage('previous');}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['60'][1]++;}}}}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['53'][1]++;}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['52'][1]++;}};__cov_8CdxqQjta0kgBZMP6kX7FA.s['134']++;if(tf.paging){__cov_8CdxqQjta0kgBZMP6kX7FA.b['62'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['135']++;tf.feature('paging').onAfterChangePage=function(paging){__cov_8CdxqQjta0kgBZMP6kX7FA.f['13']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['136']++;var advGrid=paging.tf.extension('advancedGrid');__cov_8CdxqQjta0kgBZMP6kX7FA.s['137']++;var et=advGrid._ezEditTable;__cov_8CdxqQjta0kgBZMP6kX7FA.s['138']++;var slc=et.Selection;__cov_8CdxqQjta0kgBZMP6kX7FA.s['139']++;var row=slc.GetActiveRow();__cov_8CdxqQjta0kgBZMP6kX7FA.s['140']++;if(row){__cov_8CdxqQjta0kgBZMP6kX7FA.b['63'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['141']++;row.scrollIntoView(false);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['63'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['142']++;var cell=slc.GetActiveCell();__cov_8CdxqQjta0kgBZMP6kX7FA.s['143']++;if(cell){__cov_8CdxqQjta0kgBZMP6kX7FA.b['64'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['144']++;cell.scrollIntoView(false);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['64'][1]++;}};}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['62'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['145']++;if(cfg.default_selection==='row'){__cov_8CdxqQjta0kgBZMP6kX7FA.b['65'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['146']++;var fnB=cfg.on_before_selected_row;__cov_8CdxqQjta0kgBZMP6kX7FA.s['147']++;cfg.on_before_selected_row=function(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['14']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['148']++;var args=arguments;__cov_8CdxqQjta0kgBZMP6kX7FA.s['149']++;onBeforeSelection(args[0],args[1],args[2]);__cov_8CdxqQjta0kgBZMP6kX7FA.s['150']++;if(fnB){__cov_8CdxqQjta0kgBZMP6kX7FA.b['66'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['151']++;fnB.call(null,args[0],args[1],args[2]);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['66'][1]++;}};__cov_8CdxqQjta0kgBZMP6kX7FA.s['152']++;var fnA=cfg.on_after_selected_row;__cov_8CdxqQjta0kgBZMP6kX7FA.s['153']++;cfg.on_after_selected_row=function(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['15']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['154']++;var args=arguments;__cov_8CdxqQjta0kgBZMP6kX7FA.s['155']++;onAfterSelection(args[0],args[1],args[2]);__cov_8CdxqQjta0kgBZMP6kX7FA.s['156']++;if(fnA){__cov_8CdxqQjta0kgBZMP6kX7FA.b['67'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['157']++;fnA.call(null,args[0],args[1],args[2]);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['67'][1]++;}};}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['65'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['158']++;var fnD=cfg.on_before_selected_cell;__cov_8CdxqQjta0kgBZMP6kX7FA.s['159']++;cfg.on_before_selected_cell=function(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['16']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['160']++;var args=arguments;__cov_8CdxqQjta0kgBZMP6kX7FA.s['161']++;onBeforeSelection(args[0],args[1],args[2]);__cov_8CdxqQjta0kgBZMP6kX7FA.s['162']++;if(fnD){__cov_8CdxqQjta0kgBZMP6kX7FA.b['68'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['163']++;fnD.call(null,args[0],args[1],args[2]);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['68'][1]++;}};__cov_8CdxqQjta0kgBZMP6kX7FA.s['164']++;var fnC=cfg.on_after_selected_cell;__cov_8CdxqQjta0kgBZMP6kX7FA.s['165']++;cfg.on_after_selected_cell=function(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['17']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['166']++;var args=arguments;__cov_8CdxqQjta0kgBZMP6kX7FA.s['167']++;onAfterSelection(args[0],args[1],args[2]);__cov_8CdxqQjta0kgBZMP6kX7FA.s['168']++;if(fnC){__cov_8CdxqQjta0kgBZMP6kX7FA.b['69'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['169']++;fnC.call(null,args[0],args[1],args[2]);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['69'][1]++;}};}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['22'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['170']++;if(editable){__cov_8CdxqQjta0kgBZMP6kX7FA.b['70'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['171']++;var fnE=cfg.on_added_dom_row;__cov_8CdxqQjta0kgBZMP6kX7FA.s['172']++;cfg.on_added_dom_row=function(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['18']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['173']++;var args=arguments;__cov_8CdxqQjta0kgBZMP6kX7FA.s['174']++;tf.nbFilterableRows++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['175']++;if(!tf.paging){__cov_8CdxqQjta0kgBZMP6kX7FA.b['71'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['176']++;tf.emitter.emit('rows-changed',tf,this);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['71'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['177']++;tf.nbFilterableRows++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['178']++;tf.paging=false;__cov_8CdxqQjta0kgBZMP6kX7FA.s['179']++;tf.feature('paging').destroy();__cov_8CdxqQjta0kgBZMP6kX7FA.s['180']++;tf.feature('paging').reset();}__cov_8CdxqQjta0kgBZMP6kX7FA.s['181']++;if(tf.alternateRows){__cov_8CdxqQjta0kgBZMP6kX7FA.b['72'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['182']++;tf.feature('alternateRows').init();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['72'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['183']++;if(fnE){__cov_8CdxqQjta0kgBZMP6kX7FA.b['73'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['184']++;fnE.call(null,args[0],args[1],args[2]);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['73'][1]++;}};__cov_8CdxqQjta0kgBZMP6kX7FA.s['185']++;if((__cov_8CdxqQjta0kgBZMP6kX7FA.b['75'][0]++,cfg.actions)&&(__cov_8CdxqQjta0kgBZMP6kX7FA.b['75'][1]++,cfg.actions['delete'])){__cov_8CdxqQjta0kgBZMP6kX7FA.b['74'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['186']++;var fnF=cfg.actions['delete'].on_after_submit;__cov_8CdxqQjta0kgBZMP6kX7FA.s['187']++;cfg.actions['delete'].on_after_submit=function(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['19']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['188']++;var args=arguments;__cov_8CdxqQjta0kgBZMP6kX7FA.s['189']++;tf.nbFilterableRows--;__cov_8CdxqQjta0kgBZMP6kX7FA.s['190']++;if(!tf.paging){__cov_8CdxqQjta0kgBZMP6kX7FA.b['76'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['191']++;tf.emitter.emit('rows-changed',tf,this);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['76'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['192']++;tf.nbFilterableRows--;__cov_8CdxqQjta0kgBZMP6kX7FA.s['193']++;tf.paging=false;__cov_8CdxqQjta0kgBZMP6kX7FA.s['194']++;tf.feature('paging').destroy();__cov_8CdxqQjta0kgBZMP6kX7FA.s['195']++;tf.feature('paging').reset(false);}__cov_8CdxqQjta0kgBZMP6kX7FA.s['196']++;if(tf.alternateRows){__cov_8CdxqQjta0kgBZMP6kX7FA.b['77'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['197']++;tf.feature('alternateRows').init();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['77'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['198']++;if(fnF){__cov_8CdxqQjta0kgBZMP6kX7FA.b['78'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['199']++;fnF.call(null,args[0],args[1]);}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['78'][1]++;}};}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['74'][1]++;}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['70'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['200']++;try{__cov_8CdxqQjta0kgBZMP6kX7FA.s['201']++;this._ezEditTable=new EditTable(tf.id,cfg,startRow);__cov_8CdxqQjta0kgBZMP6kX7FA.s['202']++;this._ezEditTable.Init();}catch(e){__cov_8CdxqQjta0kgBZMP6kX7FA.s['203']++;throw new Error(INSTANTIATION_ERROR);}__cov_8CdxqQjta0kgBZMP6kX7FA.s['204']++;this.initialized=true;};__cov_8CdxqQjta0kgBZMP6kX7FA.s['205']++;AdapterEzEditTable.prototype.reset=function reset(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['20']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['206']++;var ezEditTable=this._ezEditTable;__cov_8CdxqQjta0kgBZMP6kX7FA.s['207']++;if(ezEditTable){__cov_8CdxqQjta0kgBZMP6kX7FA.b['79'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['208']++;if(this.cfg.selection){__cov_8CdxqQjta0kgBZMP6kX7FA.b['80'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['209']++;ezEditTable.Selection.Set();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['80'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['210']++;if(this.cfg.editable){__cov_8CdxqQjta0kgBZMP6kX7FA.b['81'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['211']++;ezEditTable.Editable.Set();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['81'][1]++;}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['79'][1]++;}};__cov_8CdxqQjta0kgBZMP6kX7FA.s['212']++;AdapterEzEditTable.prototype.toggle=function toggle(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['21']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['213']++;var ezEditTable=this._ezEditTable;__cov_8CdxqQjta0kgBZMP6kX7FA.s['214']++;if(ezEditTable.editable){__cov_8CdxqQjta0kgBZMP6kX7FA.b['82'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['215']++;ezEditTable.Editable.Remove();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['82'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['216']++;ezEditTable.Editable.Set();}__cov_8CdxqQjta0kgBZMP6kX7FA.s['217']++;if(ezEditTable.selection){__cov_8CdxqQjta0kgBZMP6kX7FA.b['83'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['218']++;ezEditTable.Selection.Remove();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['83'][1]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['219']++;ezEditTable.Selection.Set();}};__cov_8CdxqQjta0kgBZMP6kX7FA.s['220']++;AdapterEzEditTable.prototype._toggleForInputFilter=function _toggleForInputFilter(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['22']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['221']++;var tf=this.tf;__cov_8CdxqQjta0kgBZMP6kX7FA.s['222']++;if(!tf.getActiveFilterId()){__cov_8CdxqQjta0kgBZMP6kX7FA.b['84'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['223']++;return;}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['84'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['224']++;var colIndex=tf.getColumnIndexFromFilterId(tf.getActiveFilterId());__cov_8CdxqQjta0kgBZMP6kX7FA.s['225']++;var filterType=tf.getFilterType(colIndex);__cov_8CdxqQjta0kgBZMP6kX7FA.s['226']++;if(filterType===_const.INPUT){__cov_8CdxqQjta0kgBZMP6kX7FA.b['85'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['227']++;this.toggle();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['85'][1]++;}};__cov_8CdxqQjta0kgBZMP6kX7FA.s['228']++;AdapterEzEditTable.prototype.destroy=function destroy(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['23']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['229']++;var _this3=this;__cov_8CdxqQjta0kgBZMP6kX7FA.s['230']++;if(!this.initialized){__cov_8CdxqQjta0kgBZMP6kX7FA.b['86'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['231']++;return;}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['86'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['232']++;var ezEditTable=this._ezEditTable;__cov_8CdxqQjta0kgBZMP6kX7FA.s['233']++;if(ezEditTable){__cov_8CdxqQjta0kgBZMP6kX7FA.b['87'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['234']++;if(this.cfg.selection){__cov_8CdxqQjta0kgBZMP6kX7FA.b['88'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['235']++;ezEditTable.Selection.ClearSelections();__cov_8CdxqQjta0kgBZMP6kX7FA.s['236']++;ezEditTable.Selection.Remove();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['88'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['237']++;if(this.cfg.editable){__cov_8CdxqQjta0kgBZMP6kX7FA.b['89'][0]++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['238']++;ezEditTable.Editable.Remove();}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['89'][1]++;}}else{__cov_8CdxqQjta0kgBZMP6kX7FA.b['87'][1]++;}__cov_8CdxqQjta0kgBZMP6kX7FA.s['239']++;this.emitter.off(['filter-focus','filter-blur'],function(){__cov_8CdxqQjta0kgBZMP6kX7FA.f['24']++;__cov_8CdxqQjta0kgBZMP6kX7FA.s['240']++;return _this3._toggleForInputFilter();});__cov_8CdxqQjta0kgBZMP6kX7FA.s['241']++;this.initialized=false;};__cov_8CdxqQjta0kgBZMP6kX7FA.s['242']++;return AdapterEzEditTable;}(_feature.Feature);__cov_8CdxqQjta0kgBZMP6kX7FA.s['243']++;exports.default=AdapterEzEditTable;__cov_8CdxqQjta0kgBZMP6kX7FA.s['244']++;AdapterEzEditTable.meta={altName:'advancedGrid'};


/***/ }),

/***/ "./src/extensions/advancedGrid/advancedGrid.js":
/*!*****************************************************!*\
  !*** ./src/extensions/advancedGrid/advancedGrid.js ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __cov_TIWaus0bGExaN5YYA4MvJQ = (Function('return this'))();
if (!__cov_TIWaus0bGExaN5YYA4MvJQ.__coverage__) { __cov_TIWaus0bGExaN5YYA4MvJQ.__coverage__ = {}; }
__cov_TIWaus0bGExaN5YYA4MvJQ = __cov_TIWaus0bGExaN5YYA4MvJQ.__coverage__;
if (!(__cov_TIWaus0bGExaN5YYA4MvJQ['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\advancedGrid\\advancedGrid.js'])) {
   __cov_TIWaus0bGExaN5YYA4MvJQ['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\advancedGrid\\advancedGrid.js'] = {"path":"C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\advancedGrid\\advancedGrid.js","s":{"1":0,"2":0,"3":0,"4":1,"5":0,"6":0},"b":{"1":[0,0],"2":[0,0]},"f":{"1":0},"fnMap":{"1":{"name":"_interopRequireDefault","line":11,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true}},"statementMap":{"1":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"2":{"start":{"line":1,"column":0},"end":{"line":1,"column":0}},"3":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"4":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"5":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"6":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}},"branchMap":{"1":{"line":11,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"2":{"line":11,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]}},"code":["import AdapterEzEditTable from './adapterEzEditTable';","","export default AdapterEzEditTable;"]};
}
__cov_TIWaus0bGExaN5YYA4MvJQ = __cov_TIWaus0bGExaN5YYA4MvJQ['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\advancedGrid\\advancedGrid.js'];
__cov_TIWaus0bGExaN5YYA4MvJQ.s['1']++;Object.defineProperty(exports,'__esModule',{value:true});__cov_TIWaus0bGExaN5YYA4MvJQ.s['2']++;var _adapterEzEditTable=__webpack_require__(/*! ./adapterEzEditTable */ "./src/extensions/advancedGrid/adapterEzEditTable.js");__cov_TIWaus0bGExaN5YYA4MvJQ.s['3']++;var _adapterEzEditTable2=_interopRequireDefault(_adapterEzEditTable);function _interopRequireDefault(obj){__cov_TIWaus0bGExaN5YYA4MvJQ.f['1']++;__cov_TIWaus0bGExaN5YYA4MvJQ.s['5']++;return(__cov_TIWaus0bGExaN5YYA4MvJQ.b['2'][0]++,obj)&&(__cov_TIWaus0bGExaN5YYA4MvJQ.b['2'][1]++,obj.__esModule)?(__cov_TIWaus0bGExaN5YYA4MvJQ.b['1'][0]++,obj):(__cov_TIWaus0bGExaN5YYA4MvJQ.b['1'][1]++,{default:obj});}__cov_TIWaus0bGExaN5YYA4MvJQ.s['6']++;exports.default=_adapterEzEditTable2.default;


/***/ }),

/***/ "./src/extensions/colOps/colOps.js":
/*!*****************************************!*\
  !*** ./src/extensions/colOps/colOps.js ***!
  \*****************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __cov_yYTFAbucsFeHB$3J0Zdw0A = (Function('return this'))();
if (!__cov_yYTFAbucsFeHB$3J0Zdw0A.__coverage__) { __cov_yYTFAbucsFeHB$3J0Zdw0A.__coverage__ = {}; }
__cov_yYTFAbucsFeHB$3J0Zdw0A = __cov_yYTFAbucsFeHB$3J0Zdw0A.__coverage__;
if (!(__cov_yYTFAbucsFeHB$3J0Zdw0A['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\colOps\\colOps.js'])) {
   __cov_yYTFAbucsFeHB$3J0Zdw0A['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\colOps\\colOps.js'] = {"path":"C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\colOps\\colOps.js","s":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":0,"8":0,"9":0,"10":0,"11":1,"12":0,"13":1,"14":0,"15":0,"16":1,"17":0,"18":0,"19":0,"20":1,"21":0,"22":0,"23":0,"24":0,"25":0,"26":0,"27":0,"28":0,"29":0,"30":0,"31":0,"32":0,"33":0,"34":0,"35":0,"36":1,"37":0,"38":0,"39":0,"40":0,"41":0,"42":0,"43":0,"44":0,"45":0,"46":0,"47":0,"48":0,"49":0,"50":0,"51":0,"52":0,"53":0,"54":0,"55":0,"56":0,"57":0,"58":0,"59":0,"60":0,"61":0,"62":0,"63":0,"64":0,"65":0,"66":0,"67":0,"68":0,"69":0,"70":0,"71":0,"72":0,"73":0,"74":0,"75":0,"76":0,"77":0,"78":0,"79":0,"80":0,"81":0,"82":0,"83":0,"84":0,"85":0,"86":0,"87":0,"88":0,"89":0,"90":0,"91":0,"92":0,"93":0,"94":0,"95":0,"96":0,"97":0,"98":0,"99":0,"100":0,"101":0,"102":0,"103":0,"104":0,"105":0,"106":0,"107":0,"108":0,"109":0,"110":0,"111":0,"112":0,"113":0,"114":0,"115":0,"116":0,"117":0,"118":0,"119":0,"120":0,"121":0,"122":0,"123":0,"124":0,"125":0,"126":0,"127":0,"128":0,"129":0,"130":0,"131":0,"132":0,"133":0,"134":0,"135":0,"136":0,"137":0,"138":0,"139":0,"140":0,"141":0,"142":0,"143":0,"144":0,"145":0,"146":0,"147":0,"148":0,"149":0,"150":0,"151":0,"152":0,"153":0,"154":0,"155":0,"156":0,"157":0,"158":0,"159":0,"160":0,"161":0,"162":0,"163":0,"164":0,"165":0,"166":0,"167":0,"168":0,"169":0,"170":0,"171":0,"172":0,"173":0,"174":0,"175":0,"176":0,"177":0,"178":0,"179":0,"180":0,"181":0,"182":0,"183":0,"184":0,"185":0,"186":0,"187":0,"188":0,"189":0,"190":0,"191":0,"192":0,"193":0,"194":0,"195":0,"196":0,"197":0,"198":0,"199":0,"200":0,"201":0,"202":0,"203":0,"204":0,"205":0,"206":0,"207":0,"208":0},"b":{"1":[0,0],"2":[0,0],"3":[0,0],"4":[0,0],"5":[0,0],"6":[0,0,0],"7":[0,0],"8":[0,0],"9":[0,0],"10":[0,0],"11":[0,0],"12":[0,0],"13":[0,0],"14":[0,0],"15":[0,0],"16":[0,0],"17":[0,0],"18":[0,0],"19":[0,0],"20":[0,0],"21":[0,0],"22":[0,0],"23":[0,0],"24":[0,0],"25":[0,0],"26":[0,0],"27":[0,0,0],"28":[0,0,0,0,0,0,0],"29":[0,0],"30":[0,0],"31":[0,0],"32":[0,0],"33":[0,0],"34":[0,0],"35":[0,0],"36":[0,0],"37":[0,0],"38":[0,0],"39":[0,0],"40":[0,0],"41":[0,0],"42":[0,0],"43":[0,0],"44":[0,0],"45":[0,0],"46":[0,0],"47":[0,0],"48":[0,0],"49":[0,0],"50":[0,0],"51":[0,0],"52":[0,0],"53":[0,0],"54":[0,0],"55":[0,0],"56":[0,0],"57":[0,0],"58":[0,0],"59":[0,0],"60":[0,0],"61":[0,0,0],"62":[0,0],"63":[0,0],"64":[0,0],"65":[0,0],"66":[0,0],"67":[0,0],"68":[0,0],"69":[0,0],"70":[0,0],"71":[0,0]},"f":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":0,"8":0,"9":0,"10":0,"11":0,"12":0,"13":0,"14":0,"15":0,"16":0,"17":0,"18":0,"19":0,"20":0,"21":0,"22":0,"23":0},"fnMap":{"1":{"name":"_interopRequireDefault","line":25,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"2":{"name":"_classCallCheck","line":27,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"3":{"name":"_possibleConstructorReturn","line":29,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"4":{"name":"_inherits","line":31,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"5":{"name":"(anonymous_5)","line":47,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"6":{"name":"ColOps","line":56,"loc":{"start":{"line":35,"column":4},"end":{"line":35,"column":26}}},"7":{"name":"init","line":140,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"8":{"name":"calcAll","line":171,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"9":{"name":"(anonymous_9)","line":191,"loc":{"start":{"line":158,"column":27},"end":{"line":158,"column":36}}},"10":{"name":"columnCalc","line":263,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"11":{"name":"calc","line":283,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"12":{"name":"calcSum","line":327,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"13":{"name":"(anonymous_13)","line":333,"loc":{"start":{"line":313,"column":35},"end":{"line":313,"column":35}}},"14":{"name":"calcMean","line":346,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"15":{"name":"calcMax","line":360,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"16":{"name":"calcMin","line":373,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"17":{"name":"calcMedian","line":386,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"18":{"name":"calcQ1","line":405,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"19":{"name":"calcQ3","line":424,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"20":{"name":"sortColumnValues","line":446,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"21":{"name":"writeResult","line":464,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"22":{"name":"configureFormat","line":509,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"23":{"name":"destroy","line":531,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true}},"statementMap":{"1":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"2":{"start":{"line":1,"column":0},"end":{"line":1,"column":0}},"3":{"start":{"line":2,"column":0},"end":{"line":2,"column":0}},"4":{"start":{"line":3,"column":0},"end":{"line":3,"column":0}},"5":{"start":{"line":4,"column":0},"end":{"line":4,"column":0}},"6":{"start":{"line":5,"column":0},"end":{"line":5,"column":0}},"7":{"start":{"line":6,"column":0},"end":{"line":6,"column":0}},"8":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"9":{"start":{"line":7,"column":0},"end":{"line":7,"column":0}},"10":{"start":{"line":8,"column":0},"end":{"line":8,"column":0}},"11":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"12":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"13":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"14":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"15":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"16":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"17":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"18":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"19":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"20":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"21":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"22":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"23":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"24":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"25":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"26":{"start":{"line":10,"column":0},"end":{"line":10,"column":0}},"27":{"start":{"line":16,"column":0},"end":{"line":16,"column":0}},"28":{"start":{"line":17,"column":0},"end":{"line":17,"column":0}},"29":{"start":{"line":18,"column":0},"end":{"line":18,"column":0}},"30":{"start":{"line":19,"column":0},"end":{"line":19,"column":0}},"31":{"start":{"line":20,"column":0},"end":{"line":20,"column":0}},"32":{"start":{"line":21,"column":0},"end":{"line":21,"column":0}},"33":{"start":{"line":22,"column":0},"end":{"line":22,"column":0}},"34":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"35":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"36":{"start":{"line":35,"column":4},"end":{"line":109,"column":5}},"37":{"start":{"line":35,"column":26},"end":{"line":35,"column":26}},"38":{"start":{"line":35,"column":26},"end":{"line":35,"column":26}},"39":{"start":{"line":42,"column":8},"end":{"line":42,"column":8}},"40":{"start":{"line":48,"column":8},"end":{"line":48,"column":8}},"41":{"start":{"line":54,"column":8},"end":{"line":54,"column":8}},"42":{"start":{"line":60,"column":8},"end":{"line":60,"column":8}},"43":{"start":{"line":66,"column":8},"end":{"line":66,"column":8}},"44":{"start":{"line":73,"column":8},"end":{"line":73,"column":8}},"45":{"start":{"line":80,"column":8},"end":{"line":80,"column":8}},"46":{"start":{"line":88,"column":8},"end":{"line":88,"column":8}},"47":{"start":{"line":94,"column":8},"end":{"line":94,"column":8}},"48":{"start":{"line":100,"column":8},"end":{"line":100,"column":8}},"49":{"start":{"line":106,"column":8},"end":{"line":106,"column":8}},"50":{"start":{"line":108,"column":8},"end":{"line":108,"column":8}},"51":{"start":{"line":35,"column":26},"end":{"line":35,"column":26}},"52":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"53":{"start":{"line":115,"column":8},"end":{"line":117,"column":9}},"54":{"start":{"line":116,"column":12},"end":{"line":116,"column":12}},"55":{"start":{"line":119,"column":8},"end":{"line":119,"column":8}},"56":{"start":{"line":121,"column":8},"end":{"line":121,"column":8}},"57":{"start":{"line":124,"column":8},"end":{"line":124,"column":8}},"58":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"59":{"start":{"line":144,"column":8},"end":{"line":144,"column":8}},"60":{"start":{"line":145,"column":8},"end":{"line":147,"column":9}},"61":{"start":{"line":146,"column":12},"end":{"line":146,"column":12}},"62":{"start":{"line":149,"column":8},"end":{"line":149,"column":8}},"63":{"start":{"line":150,"column":8},"end":{"line":150,"column":8}},"64":{"start":{"line":143,"column":14},"end":{"line":143,"column":14}},"65":{"start":{"line":157,"column":8},"end":{"line":157,"column":8}},"66":{"start":{"line":158,"column":8},"end":{"line":158,"column":8}},"67":{"start":{"line":159,"column":12},"end":{"line":161,"column":13}},"68":{"start":{"line":160,"column":16},"end":{"line":160,"column":16}},"69":{"start":{"line":164,"column":8},"end":{"line":164,"column":8}},"70":{"start":{"line":168,"column":8},"end":{"line":143,"column":14}},"71":{"start":{"line":172,"column":12},"end":{"line":172,"column":12}},"72":{"start":{"line":176,"column":12},"end":{"line":176,"column":12}},"73":{"start":{"line":179,"column":12},"end":{"line":179,"column":12}},"74":{"start":{"line":187,"column":12},"end":{"line":198,"column":13}},"75":{"start":{"line":188,"column":16},"end":{"line":190,"column":17}},"76":{"start":{"line":189,"column":20},"end":{"line":189,"column":20}},"77":{"start":{"line":191,"column":16},"end":{"line":191,"column":16}},"78":{"start":{"line":192,"column":16},"end":{"line":192,"column":16}},"79":{"start":{"line":193,"column":16},"end":{"line":193,"column":16}},"80":{"start":{"line":194,"column":16},"end":{"line":194,"column":16}},"81":{"start":{"line":195,"column":16},"end":{"line":195,"column":16}},"82":{"start":{"line":197,"column":16},"end":{"line":197,"column":16}},"83":{"start":{"line":200,"column":12},"end":{"line":168,"column":41}},"84":{"start":{"line":202,"column":16},"end":{"line":202,"column":16}},"85":{"start":{"line":212,"column":16},"end":{"line":212,"column":16}},"86":{"start":{"line":215,"column":16},"end":{"line":215,"column":16}},"87":{"start":{"line":226,"column":16},"end":{"line":226,"column":16}},"88":{"start":{"line":237,"column":12},"end":{"line":237,"column":12}},"89":{"start":{"line":239,"column":12},"end":{"line":241,"column":13}},"90":{"start":{"line":240,"column":16},"end":{"line":240,"column":16}},"91":{"start":{"line":244,"column":8},"end":{"line":244,"column":8}},"92":{"start":{"line":245,"column":8},"end":{"line":245,"column":8}},"93":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"94":{"start":{"line":255,"column":53},"end":{"line":255,"column":53}},"95":{"start":{"line":255,"column":53},"end":{"line":255,"column":53}},"96":{"start":{"line":256,"column":8},"end":{"line":256,"column":8}},"97":{"start":{"line":257,"column":8},"end":{"line":257,"column":8}},"98":{"start":{"line":259,"column":8},"end":{"line":259,"column":8}},"99":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"100":{"start":{"line":270,"column":48},"end":{"line":270,"column":48}},"101":{"start":{"line":270,"column":48},"end":{"line":270,"column":48}},"102":{"start":{"line":271,"column":8},"end":{"line":271,"column":8}},"103":{"start":{"line":273,"column":8},"end":{"line":275,"column":9}},"104":{"start":{"line":274,"column":12},"end":{"line":274,"column":12}},"105":{"start":{"line":277,"column":8},"end":{"line":277,"column":8}},"106":{"start":{"line":279,"column":16},"end":{"line":279,"column":16}},"107":{"start":{"line":280,"column":16},"end":{"line":280,"column":16}},"108":{"start":{"line":282,"column":16},"end":{"line":282,"column":16}},"109":{"start":{"line":283,"column":16},"end":{"line":283,"column":16}},"110":{"start":{"line":285,"column":16},"end":{"line":285,"column":16}},"111":{"start":{"line":286,"column":16},"end":{"line":286,"column":16}},"112":{"start":{"line":288,"column":16},"end":{"line":288,"column":16}},"113":{"start":{"line":289,"column":16},"end":{"line":289,"column":16}},"114":{"start":{"line":291,"column":16},"end":{"line":291,"column":16}},"115":{"start":{"line":292,"column":16},"end":{"line":292,"column":16}},"116":{"start":{"line":294,"column":16},"end":{"line":294,"column":16}},"117":{"start":{"line":295,"column":16},"end":{"line":295,"column":16}},"118":{"start":{"line":297,"column":16},"end":{"line":297,"column":16}},"119":{"start":{"line":298,"column":16},"end":{"line":298,"column":16}},"120":{"start":{"line":301,"column":8},"end":{"line":301,"column":8}},"121":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"122":{"start":{"line":309,"column":25},"end":{"line":309,"column":25}},"123":{"start":{"line":310,"column":8},"end":{"line":312,"column":9}},"124":{"start":{"line":311,"column":12},"end":{"line":311,"column":12}},"125":{"start":{"line":313,"column":8},"end":{"line":313,"column":8}},"126":{"start":{"line":313,"column":35},"end":{"line":313,"column":35}},"127":{"start":{"line":314,"column":8},"end":{"line":314,"column":8}},"128":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"129":{"start":{"line":322,"column":26},"end":{"line":322,"column":26}},"130":{"start":{"line":323,"column":8},"end":{"line":323,"column":8}},"131":{"start":{"line":324,"column":8},"end":{"line":324,"column":8}},"132":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"133":{"start":{"line":332,"column":25},"end":{"line":332,"column":25}},"134":{"start":{"line":333,"column":8},"end":{"line":333,"column":8}},"135":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"136":{"start":{"line":341,"column":25},"end":{"line":341,"column":25}},"137":{"start":{"line":342,"column":8},"end":{"line":342,"column":8}},"138":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"139":{"start":{"line":350,"column":28},"end":{"line":350,"column":28}},"140":{"start":{"line":351,"column":8},"end":{"line":351,"column":8}},"141":{"start":{"line":352,"column":8},"end":{"line":352,"column":8}},"142":{"start":{"line":353,"column":8},"end":{"line":356,"column":9}},"143":{"start":{"line":354,"column":12},"end":{"line":354,"column":12}},"144":{"start":{"line":355,"column":12},"end":{"line":355,"column":12}},"145":{"start":{"line":357,"column":8},"end":{"line":357,"column":8}},"146":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"147":{"start":{"line":366,"column":24},"end":{"line":366,"column":24}},"148":{"start":{"line":367,"column":8},"end":{"line":367,"column":8}},"149":{"start":{"line":368,"column":8},"end":{"line":368,"column":8}},"150":{"start":{"line":369,"column":8},"end":{"line":369,"column":8}},"151":{"start":{"line":370,"column":8},"end":{"line":373,"column":9}},"152":{"start":{"line":371,"column":12},"end":{"line":371,"column":12}},"153":{"start":{"line":374,"column":8},"end":{"line":374,"column":8}},"154":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"155":{"start":{"line":382,"column":24},"end":{"line":382,"column":24}},"156":{"start":{"line":383,"column":8},"end":{"line":383,"column":8}},"157":{"start":{"line":384,"column":8},"end":{"line":384,"column":8}},"158":{"start":{"line":385,"column":8},"end":{"line":385,"column":8}},"159":{"start":{"line":386,"column":8},"end":{"line":386,"column":8}},"160":{"start":{"line":387,"column":8},"end":{"line":391,"column":9}},"161":{"start":{"line":388,"column":12},"end":{"line":388,"column":12}},"162":{"start":{"line":389,"column":12},"end":{"line":389,"column":12}},"163":{"start":{"line":392,"column":8},"end":{"line":392,"column":8}},"164":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"165":{"start":{"line":401,"column":42},"end":{"line":401,"column":42}},"166":{"start":{"line":401,"column":42},"end":{"line":401,"column":42}},"167":{"start":{"line":402,"column":8},"end":{"line":402,"column":8}},"168":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"169":{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},"170":{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},"171":{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},"172":{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},"173":{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},"174":{"start":{"line":416,"column":8},"end":{"line":416,"column":8}},"175":{"start":{"line":418,"column":8},"end":{"line":420,"column":9}},"176":{"start":{"line":419,"column":12},"end":{"line":419,"column":12}},"177":{"start":{"line":422,"column":8},"end":{"line":422,"column":8}},"178":{"start":{"line":423,"column":8},"end":{"line":427,"column":9}},"179":{"start":{"line":424,"column":12},"end":{"line":424,"column":12}},"180":{"start":{"line":426,"column":12},"end":{"line":426,"column":12}},"181":{"start":{"line":429,"column":8},"end":{"line":429,"column":8}},"182":{"start":{"line":431,"column":16},"end":{"line":431,"column":16}},"183":{"start":{"line":432,"column":16},"end":{"line":432,"column":16}},"184":{"start":{"line":434,"column":16},"end":{"line":434,"column":16}},"185":{"start":{"line":435,"column":16},"end":{"line":435,"column":16}},"186":{"start":{"line":437,"column":16},"end":{"line":437,"column":16}},"187":{"start":{"line":438,"column":16},"end":{"line":438,"column":16}},"188":{"start":{"line":439,"column":16},"end":{"line":439,"column":16}},"189":{"start":{"line":440,"column":16},"end":{"line":440,"column":16}},"190":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"191":{"start":{"line":452,"column":43},"end":{"line":452,"column":43}},"192":{"start":{"line":453,"column":8},"end":{"line":453,"column":8}},"193":{"start":{"line":454,"column":8},"end":{"line":465,"column":9}},"194":{"start":{"line":455,"column":12},"end":{"line":455,"column":12}},"195":{"start":{"line":456,"column":12},"end":{"line":458,"column":13}},"196":{"start":{"line":457,"column":16},"end":{"line":457,"column":16}},"197":{"start":{"line":459,"column":12},"end":{"line":461,"column":13}},"198":{"start":{"line":460,"column":16},"end":{"line":460,"column":16}},"199":{"start":{"line":463,"column":12},"end":{"line":463,"column":12}},"200":{"start":{"line":464,"column":12},"end":{"line":464,"column":12}},"201":{"start":{"line":466,"column":8},"end":{"line":466,"column":8}},"202":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"203":{"start":{"line":471,"column":8},"end":{"line":473,"column":9}},"204":{"start":{"line":472,"column":12},"end":{"line":472,"column":12}},"205":{"start":{"line":475,"column":8},"end":{"line":475,"column":8}},"206":{"start":{"line":477,"column":8},"end":{"line":477,"column":8}},"207":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"208":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}},"branchMap":{"1":{"line":25,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"2":{"line":25,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"3":{"line":27,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"4":{"line":29,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"5":{"line":29,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"6":{"line":29,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"7":{"line":31,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"8":{"line":31,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"9":{"line":31,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"10":{"line":31,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"11":{"line":31,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"12":{"line":141,"type":"if","locations":[{"start":{"line":115,"column":8},"end":{"line":115,"column":8}},{"start":{"line":115,"column":8},"end":{"line":115,"column":8}}]},"13":{"line":173,"type":"if","locations":[{"start":{"line":145,"column":8},"end":{"line":145,"column":8}},{"start":{"line":145,"column":8},"end":{"line":145,"column":8}}]},"14":{"line":192,"type":"if","locations":[{"start":{"line":159,"column":12},"end":{"line":159,"column":12}},{"start":{"line":159,"column":12},"end":{"line":159,"column":12}}]},"15":{"line":219,"type":"if","locations":[{"start":{"line":188,"column":16},"end":{"line":188,"column":16}},{"start":{"line":188,"column":16},"end":{"line":188,"column":16}}]},"16":{"line":222,"type":"binary-expr","locations":[{"start":{"line":191,"column":35},"end":{"line":191,"column":35}},{"start":{"line":191,"column":55},"end":{"line":191,"column":34}}]},"17":{"line":225,"type":"cond-expr","locations":[{"start":{"line":194,"column":51},"end":{"line":194,"column":28}},{"start":{"line":194,"column":68},"end":{"line":194,"column":16}}]},"18":{"line":244,"type":"cond-expr","locations":[{"start":{"line":238,"column":16},"end":{"line":237,"column":25}},{"start":{"line":238,"column":41},"end":{"line":237,"column":12}}]},"19":{"line":244,"type":"binary-expr","locations":[{"start":{"line":237,"column":25},"end":{"line":237,"column":25}},{"start":{"line":237,"column":42},"end":{"line":237,"column":25}}]},"20":{"line":245,"type":"if","locations":[{"start":{"line":239,"column":12},"end":{"line":239,"column":12}},{"start":{"line":239,"column":12},"end":{"line":239,"column":12}}]},"21":{"line":264,"type":"cond-expr","locations":[{"start":{"line":255,"column":53},"end":{"line":255,"column":53}},{"start":{"line":255,"column":37},"end":{"line":255,"column":53}}]},"22":{"line":264,"type":"binary-expr","locations":[{"start":{"line":255,"column":53},"end":{"line":255,"column":53}},{"start":{"line":255,"column":53},"end":{"line":255,"column":53}}]},"23":{"line":267,"type":"binary-expr","locations":[{"start":{"line":256,"column":26},"end":{"line":256,"column":26}},{"start":{"line":256,"column":46},"end":{"line":256,"column":8}}]},"24":{"line":284,"type":"cond-expr","locations":[{"start":{"line":270,"column":48},"end":{"line":270,"column":48}},{"start":{"line":270,"column":32},"end":{"line":270,"column":48}}]},"25":{"line":284,"type":"binary-expr","locations":[{"start":{"line":270,"column":48},"end":{"line":270,"column":48}},{"start":{"line":270,"column":48},"end":{"line":270,"column":48}}]},"26":{"line":289,"type":"if","locations":[{"start":{"line":273,"column":8},"end":{"line":273,"column":8}},{"start":{"line":273,"column":8},"end":{"line":273,"column":8}}]},"27":{"line":289,"type":"binary-expr","locations":[{"start":{"line":273,"column":12},"end":{"line":273,"column":12}},{"start":{"line":273,"column":32},"end":{"line":273,"column":12}},{"start":{"line":273,"column":52},"end":{"line":273,"column":8}}]},"28":{"line":293,"type":"switch","locations":[{"start":{"line":278,"column":12},"end":{"line":280,"column":16}},{"start":{"line":281,"column":12},"end":{"line":283,"column":16}},{"start":{"line":284,"column":12},"end":{"line":286,"column":16}},{"start":{"line":287,"column":12},"end":{"line":289,"column":16}},{"start":{"line":290,"column":12},"end":{"line":292,"column":16}},{"start":{"line":293,"column":12},"end":{"line":295,"column":16}},{"start":{"line":296,"column":12},"end":{"line":298,"column":16}}]},"29":{"line":317,"type":"cond-expr","locations":[{"start":{"line":301,"column":36},"end":{"line":301,"column":15}},{"start":{"line":301,"column":45},"end":{"line":301,"column":8}}]},"30":{"line":328,"type":"cond-expr","locations":[{"start":{"line":309,"column":25},"end":{"line":309,"column":25}},{"start":{"line":309,"column":21},"end":{"line":309,"column":25}}]},"31":{"line":328,"type":"binary-expr","locations":[{"start":{"line":309,"column":25},"end":{"line":309,"column":25}},{"start":{"line":309,"column":25},"end":{"line":309,"column":25}}]},"32":{"line":330,"type":"if","locations":[{"start":{"line":310,"column":8},"end":{"line":310,"column":8}},{"start":{"line":310,"column":8},"end":{"line":310,"column":8}}]},"33":{"line":347,"type":"cond-expr","locations":[{"start":{"line":322,"column":26},"end":{"line":322,"column":26}},{"start":{"line":322,"column":22},"end":{"line":322,"column":26}}]},"34":{"line":347,"type":"binary-expr","locations":[{"start":{"line":322,"column":26},"end":{"line":322,"column":26}},{"start":{"line":322,"column":26},"end":{"line":322,"column":26}}]},"35":{"line":361,"type":"cond-expr","locations":[{"start":{"line":332,"column":25},"end":{"line":332,"column":25}},{"start":{"line":332,"column":21},"end":{"line":332,"column":25}}]},"36":{"line":361,"type":"binary-expr","locations":[{"start":{"line":332,"column":25},"end":{"line":332,"column":25}},{"start":{"line":332,"column":25},"end":{"line":332,"column":25}}]},"37":{"line":374,"type":"cond-expr","locations":[{"start":{"line":341,"column":25},"end":{"line":341,"column":25}},{"start":{"line":341,"column":21},"end":{"line":341,"column":25}}]},"38":{"line":374,"type":"binary-expr","locations":[{"start":{"line":341,"column":25},"end":{"line":341,"column":25}},{"start":{"line":341,"column":25},"end":{"line":341,"column":25}}]},"39":{"line":387,"type":"cond-expr","locations":[{"start":{"line":350,"column":28},"end":{"line":350,"column":28}},{"start":{"line":350,"column":24},"end":{"line":350,"column":28}}]},"40":{"line":387,"type":"binary-expr","locations":[{"start":{"line":350,"column":28},"end":{"line":350,"column":28}},{"start":{"line":350,"column":28},"end":{"line":350,"column":28}}]},"41":{"line":391,"type":"if","locations":[{"start":{"line":353,"column":8},"end":{"line":353,"column":8}},{"start":{"line":353,"column":8},"end":{"line":353,"column":8}}]},"42":{"line":406,"type":"cond-expr","locations":[{"start":{"line":366,"column":24},"end":{"line":366,"column":24}},{"start":{"line":366,"column":20},"end":{"line":366,"column":24}}]},"43":{"line":406,"type":"binary-expr","locations":[{"start":{"line":366,"column":24},"end":{"line":366,"column":24}},{"start":{"line":366,"column":24},"end":{"line":366,"column":24}}]},"44":{"line":411,"type":"if","locations":[{"start":{"line":370,"column":8},"end":{"line":370,"column":8}},{"start":{"line":370,"column":8},"end":{"line":370,"column":8}}]},"45":{"line":425,"type":"cond-expr","locations":[{"start":{"line":382,"column":24},"end":{"line":382,"column":24}},{"start":{"line":382,"column":20},"end":{"line":382,"column":24}}]},"46":{"line":425,"type":"binary-expr","locations":[{"start":{"line":382,"column":24},"end":{"line":382,"column":24}},{"start":{"line":382,"column":24},"end":{"line":382,"column":24}}]},"47":{"line":431,"type":"if","locations":[{"start":{"line":387,"column":8},"end":{"line":387,"column":8}},{"start":{"line":387,"column":8},"end":{"line":387,"column":8}}]},"48":{"line":447,"type":"cond-expr","locations":[{"start":{"line":401,"column":42},"end":{"line":401,"column":42}},{"start":{"line":401,"column":30},"end":{"line":401,"column":42}}]},"49":{"line":447,"type":"binary-expr","locations":[{"start":{"line":401,"column":42},"end":{"line":401,"column":42}},{"start":{"line":401,"column":42},"end":{"line":401,"column":42}}]},"50":{"line":465,"type":"cond-expr","locations":[{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},{"start":{"line":414,"column":25},"end":{"line":415,"column":36}}]},"51":{"line":465,"type":"binary-expr","locations":[{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},{"start":{"line":415,"column":36},"end":{"line":415,"column":36}}]},"52":{"line":467,"type":"cond-expr","locations":[{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},{"start":{"line":414,"column":47},"end":{"line":415,"column":36}}]},"53":{"line":467,"type":"binary-expr","locations":[{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},{"start":{"line":415,"column":36},"end":{"line":415,"column":36}}]},"54":{"line":468,"type":"cond-expr","locations":[{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},{"start":{"line":415,"column":20},"end":{"line":415,"column":36}}]},"55":{"line":468,"type":"binary-expr","locations":[{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},{"start":{"line":415,"column":36},"end":{"line":415,"column":36}}]},"56":{"line":469,"type":"cond-expr","locations":[{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},{"start":{"line":415,"column":32},"end":{"line":415,"column":36}}]},"57":{"line":469,"type":"binary-expr","locations":[{"start":{"line":415,"column":36},"end":{"line":415,"column":36}},{"start":{"line":415,"column":36},"end":{"line":415,"column":36}}]},"58":{"line":473,"type":"if","locations":[{"start":{"line":418,"column":8},"end":{"line":418,"column":8}},{"start":{"line":418,"column":8},"end":{"line":418,"column":8}}]},"59":{"line":478,"type":"if","locations":[{"start":{"line":423,"column":8},"end":{"line":423,"column":8}},{"start":{"line":423,"column":8},"end":{"line":423,"column":8}}]},"60":{"line":478,"type":"binary-expr","locations":[{"start":{"line":423,"column":12},"end":{"line":423,"column":12}},{"start":{"line":423,"column":29},"end":{"line":423,"column":8}}]},"61":{"line":484,"type":"switch","locations":[{"start":{"line":430,"column":12},"end":{"line":432,"column":16}},{"start":{"line":433,"column":12},"end":{"line":435,"column":16}},{"start":{"line":436,"column":12},"end":{"line":440,"column":16}}]},"62":{"line":510,"type":"cond-expr","locations":[{"start":{"line":452,"column":43},"end":{"line":452,"column":43}},{"start":{"line":452,"column":39},"end":{"line":452,"column":43}}]},"63":{"line":510,"type":"binary-expr","locations":[{"start":{"line":452,"column":43},"end":{"line":452,"column":43}},{"start":{"line":452,"column":43},"end":{"line":452,"column":43}}]},"64":{"line":513,"type":"if","locations":[{"start":{"line":454,"column":8},"end":{"line":454,"column":8}},{"start":{"line":454,"column":8},"end":{"line":454,"column":8}}]},"65":{"line":515,"type":"if","locations":[{"start":{"line":456,"column":12},"end":{"line":456,"column":12}},{"start":{"line":456,"column":12},"end":{"line":456,"column":12}}]},"66":{"line":515,"type":"binary-expr","locations":[{"start":{"line":456,"column":16},"end":{"line":456,"column":16}},{"start":{"line":456,"column":35},"end":{"line":456,"column":12}}]},"67":{"line":518,"type":"if","locations":[{"start":{"line":459,"column":12},"end":{"line":459,"column":12}},{"start":{"line":459,"column":12},"end":{"line":459,"column":12}}]},"68":{"line":518,"type":"binary-expr","locations":[{"start":{"line":459,"column":16},"end":{"line":459,"column":16}},{"start":{"line":459,"column":37},"end":{"line":459,"column":12}}]},"69":{"line":522,"type":"binary-expr","locations":[{"start":{"line":463,"column":29},"end":{"line":463,"column":29}},{"start":{"line":463,"column":47},"end":{"line":463,"column":12}}]},"70":{"line":523,"type":"binary-expr","locations":[{"start":{"line":464,"column":38},"end":{"line":464,"column":38}},{"start":{"line":464,"column":65},"end":{"line":464,"column":12}}]},"71":{"line":532,"type":"if","locations":[{"start":{"line":471,"column":8},"end":{"line":471,"column":8}},{"start":{"line":471,"column":8},"end":{"line":471,"column":8}}]}},"code":["import {Feature} from '../../feature';","import {createText, elm} from '../../dom';","import {isArray, isEmpty, EMPTY_FN} from '../../types';","import {numSortAsc} from '../../sort';","import {FORMATTED_NUMBER} from '../../const';","import formatNumber from 'format-number';","import {defaultsFn, defaultsArr} from '../../settings';","import {bound} from '../../event';","","const EVENTS = [","    'after-filtering',","    'after-page-change',","    'after-page-length-change'","];","","const SUM = 'sum';","const MEAN = 'mean';","const MIN = 'min';","const MAX = 'max';","const MEDIAN = 'median';","const Q1 = 'q1';","const Q3 = 'q3';","","/**"," * Column calculations extension"," */","export default class ColOps extends Feature {","","    /**","     * Creates an instance of ColOps","     *","     * @param {TableFilter} tf TableFilter instance","     * @param {Object} opts Configuration object","     */","    constructor(tf, opts) {","        super(tf, ColOps);","","        /**","         * Callback fired before columns operations start","         * @type {Function}","         */","        this.onBeforeOperation = defaultsFn(opts.on_before_operation, EMPTY_FN);","","        /**","         * Callback fired after columns operations are completed","         * @type {Function}","         */","        this.onAfterOperation = defaultsFn(opts.on_after_operation, EMPTY_FN);","","        /**","         * Configuration options","         * @type {Object}","         */","        this.opts = opts;","","        /**","         * List of DOM element IDs containing column's calculation result","         * @type {Array}","         */","        this.labelIds = defaultsArr(opts.id, []);","","        /**","         * List of columns' indexes for calculations","         * @type {Array}","         */","        this.colIndexes = defaultsArr(opts.col, []);","","        /**","         * List of operations - possible values: 'sum', 'mean', 'min', 'max',","         * 'median', 'q1', 'q3'","         * @type {Array}","         */","        this.operations = defaultsArr(opts.operation, []);","","        /**","         * List of write methods used to write the result - possible values:","         * 'innerHTML', 'setValue', 'createTextNode'","         * @type {Array}","         */","        this.outputTypes = defaultsArr(opts.write_method, []);","","        /**","         * List of format objects used for formatting the result -","         * refer to https://github.com/componitable/format-number to check","         * configuration options","         * @type {Array}","         */","        this.formatResults = defaultsArr(opts.format_result, []);","","        /**","         * List of row indexes displaying the results","         * @type {Array}","         */","        this.totRowIndexes = defaultsArr(opts.tot_row_index, []);","","        /**","         * List of row indexes excluded from calculations","         * @type {Array}","         */","        this.excludeRows = defaultsArr(opts.exclude_row, []);","","        /**","         * List of decimal precision for calculation results","         * @type {Array}","         */","        this.decimalPrecisions = defaultsArr(opts.decimal_precision, 2);","","        this.enable();","    }","","    /**","     * Initializes ColOps instance","     */","    init() {","        if (this.initialized) {","            return;","        }","        // subscribe to events","        this.emitter.on(EVENTS, bound(this.calcAll, this));","","        this.calcAll();","","        /** @inherited */","        this.initialized = true;","    }","","    /**","     * Calculates columns' values","     * Configuration options are stored in 'opts' property","     * - 'id' contains ids of elements showing result (array)","     * - 'col' contains the columns' indexes (array)","     * - 'operation' contains operation type (array, values: 'sum', 'mean',","     *   'min', 'max', 'median', 'q1', 'q3')","     * - 'write_method' array defines which method to use for displaying the","     *    result (innerHTML, setValue, createTextNode) - default: 'innerHTML'","     * - 'tot_row_index' defines in which row results are displayed","     *   (integers array)","     *","     * - changes made by Nuovella:","     * (1) optimized the routine (now it will only process each column once),","     * (2) added calculations for the median, lower and upper quartile.","     */","    calcAll() {","        let tf = this.tf;","        if (!tf.isInitialized()) {","            return;","        }","","        this.onBeforeOperation(tf, this);","        this.emitter.emit('before-column-operation', tf, this);","","        let { colIndexes, operations: colOperations, outputTypes,","            totRowIndexes, excludeRows, formatResults,","            decimalPrecisions } = this;","","        //nuovella: determine unique list of columns to operate on","        let uIndexes = [];","        colIndexes.forEach((val) => {","            if (uIndexes.indexOf(val) === -1) {","                uIndexes.push(val);","            }","        });","","        let nbCols = uIndexes.length,","            rows = tf.dom().rows,","            colValues = [];","","        for (let u = 0; u < nbCols; u++) {","            //this retrieves col values","            //use uIndexes because we only want to pass through this loop","            //once for each column get the values in this unique column","            colValues.push(","                tf.getVisibleColumnData(uIndexes[u], false, excludeRows)","            );","","            let curValues = colValues[u];","","            //next: calculate all operations for this column","            let result = 0,","                operations = [],","                precisions = [],","                labels = [],","                writeType,","                formatResult = [],","                idx = 0;","","            for (let k = 0; k < colIndexes.length; k++) {","                if (colIndexes[k] !== uIndexes[u]) {","                    continue;","                }","                operations[idx] = (colOperations[k] || 'sum').toLowerCase();","                precisions[idx] = decimalPrecisions[k];","                labels[idx] = this.labelIds[k];","                writeType = isArray(outputTypes) ? outputTypes[k] : null;","                formatResult[idx] =","                    this.configureFormat(uIndexes[u], formatResults[k]);","                idx++;","            }","","            for (let i = 0; i < idx; i++) {","                // emit values before column calculation","                this.emitter.emit(","                    'before-column-calc',","                    tf,","                    this,","                    uIndexes[u],","                    curValues,","                    operations[i],","                    precisions[i]","                );","","                result = Number(this.calc(curValues, operations[i], null));","","                // emit column calculation result","                this.emitter.emit(","                    'column-calc',","                    tf,","                    this,","                    uIndexes[u],","                    result,","                    operations[i],","                    precisions[i]","                );","","                // write result in expected DOM element","                this.writeResult(","                    result,","                    labels[i],","                    writeType,","                    precisions[i],","                    formatResult[i]","                );","","            }//for i","","            // row(s) with result are always visible","            let totRow = totRowIndexes && totRowIndexes[u] ?","                rows[totRowIndexes[u]] : null;","            if (totRow) {","                totRow.style.display = '';","            }","        }//for u","","        this.onAfterOperation(tf, this);","        this.emitter.emit('after-column-operation', tf, this);","    }","","    /**","     * Make desired calculation on specified column.","     * @param {Number} colIndex Column index","     * @param {String} [operation=SUM] Operation type","     * @param {Number} precision Decimal precision","     * @returns {Number}","     */","    columnCalc(colIndex, operation = SUM, precision) {","        let excludeRows = this.excludeRows || [];","        let colValues = tf.getVisibleColumnData(colIndex, false, excludeRows);","","        return Number(this.calc(colValues, operation, precision));","    }","","    /**","     * Make calculation on passed values.","     * @param {Array} values List of values","     * @param {String} [operation=SUM] Optional operation type","     * @param {Number} precision Optional result precision","     * @returns {Number}","     * @private","     */","    calc(colValues, operation = SUM, precision) {","        let result = 0;","","        if (operation === Q1 || operation === Q3 || operation === MEDIAN) {","            colValues = this.sortColumnValues(colValues, numSortAsc);","        }","","        switch (operation) {","            case MEAN:","                result = this.calcMean(colValues);","                break;","            case SUM:","                result = this.calcSum(colValues);","                break;","            case MIN:","                result = this.calcMin(colValues);","                break;","            case MAX:","                result = this.calcMax(colValues);","                break;","            case MEDIAN:","                result = this.calcMedian(colValues);","                break;","            case Q1:","                result = this.calcQ1(colValues);","                break;","            case Q3:","                result = this.calcQ3(colValues);","                break;","        }","","        return isEmpty(precision) ? result : result.toFixed(precision);","    }","","    /**","     * Calculate the sum of passed values.","     * @param {Array} [values=[]] List of values","     * @returns {Number}","     */","    calcSum(values = []) {","        if (isEmpty(values)) {","            return 0;","        }","        let result = values.reduce((x, y) => Number(x) + Number(y));","        return result;","    }","","    /**","     * Calculate the mean of passed values.","     * @param {Array} [values=[]] List of values","     * @returns {Number}","     */","    calcMean(values = []) {","        let result = this.calcSum(values) / values.length;","        return Number(result);","    }","","    /**","     * Calculate the max value of passed values.","     * @param {Array} [values=[]] List of values","     * @returns {Number}","     */","    calcMax(values = []) {","        return Math.max.apply(null, values);","    }","","    /**","     * Calculate the min value of passed values.","     * @param {Array} [values=[]] List of values","     * @returns {Number}","     */","    calcMin(values = []) {","        return Math.min.apply(null, values);","    }","","    /**","     * Calculate the median of passed values.","     * @param {Array} [values=[]] List of values","     * @returns {Number}","     */","    calcMedian(values = []) {","        let nbValues = values.length;","        let aux = 0;","        if (nbValues % 2 === 1) {","            aux = Math.floor(nbValues / 2);","            return Number(values[aux]);","        }","        return (Number(values[nbValues / 2]) +","            Number(values[((nbValues / 2) - 1)])) / 2;","    }","","    /**","     * Calculate the lower quartile of passed values.","     * @param {Array} [values=[]] List of values","     * @returns {Number}","     */","    calcQ1(values = []) {","        let nbValues = values.length;","        let posa = 0.0;","        posa = Math.floor(nbValues / 4);","        if (4 * posa === nbValues) {","            return (Number(values[posa - 1]) +","                Number(values[posa])) / 2;","        }","        return Number(values[posa]);","    }","","    /**","     * Calculate the upper quartile of passed values.","     * @param {Array} [values=[]] List of values","     * @returns {Number}","     */","    calcQ3(values = []) {","        let nbValues = values.length;","        let posa = 0.0;","        let posb = 0.0;","        posa = Math.floor(nbValues / 4);","        if (4 * posa === nbValues) {","            posb = 3 * posa;","            return (Number(values[posb]) +","                Number(values[posb - 1])) / 2;","        }","        return Number(values[nbValues - posa - 1]);","    }","","    /**","     * Sort passed values with supplied sorter function.","     * @param {Array} [values=[]] List of values to be sorted","     * @param {Function} sorter Sorter function","     * @returns {Array}","     */","    sortColumnValues(values = [], sorter) {","        return values.sort(sorter);","    }","","    /**","     * Write calculation result in passed DOM element with supplied write method","     * and decimal precision.","     * @param {Number} [result=0] Calculation result","     * @param {DOMElement} label DOM element","     * @param {String} [writeType='innerhtml'] Write method","     * @param {Number} [precision=2] Applied decimal precision","     * @private","     */","    writeResult(result = 0, label, writeType = 'innerhtml',","        precision = 2, format = {}) {","        let labelElm = elm(label);","","        if (!labelElm) {","            return;","        }","","        result = result.toFixed(precision);","        if (isNaN(result) || !isFinite(result)) {","            result = '';","        } else {","            result = formatNumber(format)(result);","        }","","        switch (writeType.toLowerCase()) {","            case 'innerhtml':","                labelElm.innerHTML = result;","                break;","            case 'setvalue':","                labelElm.value = result;","                break;","            case 'createtextnode':","                let oldNode = labelElm.firstChild;","                let txtNode = createText(result);","                labelElm.replaceChild(txtNode, oldNode);","                break;","        }","    }","","    /**","     * Configure the format options used to format the operation result based","     * on column type.","     * @param {Number} colIndex Column index","     * @param {Object} [format={}] Format object","     * @returns {Object}","     * @private","     */","    configureFormat(colIndex, format = {}) {","        let tf = this.tf;","        if (tf.hasType(colIndex, [FORMATTED_NUMBER])) {","            let colType = tf.colTypes[colIndex];","            if (colType.decimal && !format.decimal) {","                format.decimal = colType.decimal;","            }","            if (colType.thousands && !format.integerSeparator) {","                format.integerSeparator = colType.thousands;","            }","        } else {","            format.decimal = format.decimal || '';","            format.integerSeparator = format.integerSeparator || '';","        }","        return format;","    }","","    /** Remove extension */","    destroy() {","        if (!this.initialized) {","            return;","        }","        // unsubscribe to events","        this.emitter.off(EVENTS, bound(this.calcAll, this));","","        this.initialized = false;","    }","","}",""]};
}
__cov_yYTFAbucsFeHB$3J0Zdw0A = __cov_yYTFAbucsFeHB$3J0Zdw0A['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\colOps\\colOps.js'];
__cov_yYTFAbucsFeHB$3J0Zdw0A.s['1']++;Object.defineProperty(exports,'__esModule',{value:true});__cov_yYTFAbucsFeHB$3J0Zdw0A.s['2']++;var _feature=__webpack_require__(/*! ../../feature */ "./src/feature.js");__cov_yYTFAbucsFeHB$3J0Zdw0A.s['3']++;var _dom=__webpack_require__(/*! ../../dom */ "./src/dom.js");__cov_yYTFAbucsFeHB$3J0Zdw0A.s['4']++;var _types=__webpack_require__(/*! ../../types */ "./src/types.js");__cov_yYTFAbucsFeHB$3J0Zdw0A.s['5']++;var _sort=__webpack_require__(/*! ../../sort */ "./src/sort.js");__cov_yYTFAbucsFeHB$3J0Zdw0A.s['6']++;var _const=__webpack_require__(/*! ../../const */ "./src/const.js");__cov_yYTFAbucsFeHB$3J0Zdw0A.s['7']++;var _formatNumber=__webpack_require__(/*! format-number */ "./node_modules/format-number/index.js");__cov_yYTFAbucsFeHB$3J0Zdw0A.s['8']++;var _formatNumber2=_interopRequireDefault(_formatNumber);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['9']++;var _settings=__webpack_require__(/*! ../../settings */ "./src/settings.js");__cov_yYTFAbucsFeHB$3J0Zdw0A.s['10']++;var _event=__webpack_require__(/*! ../../event */ "./src/event.js");function _interopRequireDefault(obj){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['1']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['12']++;return(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['2'][0]++,obj)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['2'][1]++,obj.__esModule)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['1'][0]++,obj):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['1'][1]++,{default:obj});}function _classCallCheck(instance,Constructor){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['2']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['14']++;if(!(instance instanceof Constructor)){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['3'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['15']++;throw new TypeError('Cannot call a class as a function');}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['3'][1]++;}}function _possibleConstructorReturn(self,call){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['3']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['17']++;if(!self){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['4'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['18']++;throw new ReferenceError('this hasn\'t been initialised - super() hasn\'t been called');}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['4'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['19']++;return(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['6'][0]++,call)&&((__cov_yYTFAbucsFeHB$3J0Zdw0A.b['6'][1]++,typeof call==='object')||(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['6'][2]++,typeof call==='function'))?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['5'][0]++,call):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['5'][1]++,self);}function _inherits(subClass,superClass){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['4']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['21']++;if((__cov_yYTFAbucsFeHB$3J0Zdw0A.b['8'][0]++,typeof superClass!=='function')&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['8'][1]++,superClass!==null)){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['7'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['22']++;throw new TypeError('Super expression must either be null or a function, not '+typeof superClass);}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['7'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['23']++;subClass.prototype=Object.create((__cov_yYTFAbucsFeHB$3J0Zdw0A.b['9'][0]++,superClass)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['9'][1]++,superClass.prototype),{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});__cov_yYTFAbucsFeHB$3J0Zdw0A.s['24']++;if(superClass){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['10'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['25']++;Object.setPrototypeOf?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['11'][0]++,Object.setPrototypeOf(subClass,superClass)):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['11'][1]++,subClass.__proto__=superClass);}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['10'][1]++;}}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['26']++;var EVENTS=['after-filtering','after-page-change','after-page-length-change'];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['27']++;var SUM='sum';__cov_yYTFAbucsFeHB$3J0Zdw0A.s['28']++;var MEAN='mean';__cov_yYTFAbucsFeHB$3J0Zdw0A.s['29']++;var MIN='min';__cov_yYTFAbucsFeHB$3J0Zdw0A.s['30']++;var MAX='max';__cov_yYTFAbucsFeHB$3J0Zdw0A.s['31']++;var MEDIAN='median';__cov_yYTFAbucsFeHB$3J0Zdw0A.s['32']++;var Q1='q1';__cov_yYTFAbucsFeHB$3J0Zdw0A.s['33']++;var Q3='q3';__cov_yYTFAbucsFeHB$3J0Zdw0A.s['34']++;var ColOps=function(_Feature){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['5']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['35']++;_inherits(ColOps,_Feature);function ColOps(tf,opts){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['6']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['37']++;_classCallCheck(this,ColOps);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['38']++;var _this=_possibleConstructorReturn(this,_Feature.call(this,tf,ColOps));__cov_yYTFAbucsFeHB$3J0Zdw0A.s['39']++;_this.onBeforeOperation=(0,_settings.defaultsFn)(opts.on_before_operation,_types.EMPTY_FN);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['40']++;_this.onAfterOperation=(0,_settings.defaultsFn)(opts.on_after_operation,_types.EMPTY_FN);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['41']++;_this.opts=opts;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['42']++;_this.labelIds=(0,_settings.defaultsArr)(opts.id,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['43']++;_this.colIndexes=(0,_settings.defaultsArr)(opts.col,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['44']++;_this.operations=(0,_settings.defaultsArr)(opts.operation,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['45']++;_this.outputTypes=(0,_settings.defaultsArr)(opts.write_method,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['46']++;_this.formatResults=(0,_settings.defaultsArr)(opts.format_result,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['47']++;_this.totRowIndexes=(0,_settings.defaultsArr)(opts.tot_row_index,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['48']++;_this.excludeRows=(0,_settings.defaultsArr)(opts.exclude_row,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['49']++;_this.decimalPrecisions=(0,_settings.defaultsArr)(opts.decimal_precision,2);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['50']++;_this.enable();__cov_yYTFAbucsFeHB$3J0Zdw0A.s['51']++;return _this;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['52']++;ColOps.prototype.init=function init(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['7']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['53']++;if(this.initialized){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['12'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['54']++;return;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['12'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['55']++;this.emitter.on(EVENTS,(0,_event.bound)(this.calcAll,this));__cov_yYTFAbucsFeHB$3J0Zdw0A.s['56']++;this.calcAll();__cov_yYTFAbucsFeHB$3J0Zdw0A.s['57']++;this.initialized=true;};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['58']++;ColOps.prototype.calcAll=function calcAll(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['8']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['59']++;var tf=this.tf;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['60']++;if(!tf.isInitialized()){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['13'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['61']++;return;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['13'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['62']++;this.onBeforeOperation(tf,this);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['63']++;this.emitter.emit('before-column-operation',tf,this);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['64']++;var colIndexes=this.colIndexes,colOperations=this.operations,outputTypes=this.outputTypes,totRowIndexes=this.totRowIndexes,excludeRows=this.excludeRows,formatResults=this.formatResults,decimalPrecisions=this.decimalPrecisions;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['65']++;var uIndexes=[];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['66']++;colIndexes.forEach(function(val){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['9']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['67']++;if(uIndexes.indexOf(val)===-1){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['14'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['68']++;uIndexes.push(val);}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['14'][1]++;}});__cov_yYTFAbucsFeHB$3J0Zdw0A.s['69']++;var nbCols=uIndexes.length,rows=tf.dom().rows,colValues=[];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['70']++;for(var u=0;u<nbCols;u++){__cov_yYTFAbucsFeHB$3J0Zdw0A.s['71']++;colValues.push(tf.getVisibleColumnData(uIndexes[u],false,excludeRows));__cov_yYTFAbucsFeHB$3J0Zdw0A.s['72']++;var curValues=colValues[u];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['73']++;var result=0,operations=[],precisions=[],labels=[],writeType=void 0,formatResult=[],idx=0;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['74']++;for(var k=0;k<colIndexes.length;k++){__cov_yYTFAbucsFeHB$3J0Zdw0A.s['75']++;if(colIndexes[k]!==uIndexes[u]){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['15'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['76']++;continue;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['15'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['77']++;operations[idx]=((__cov_yYTFAbucsFeHB$3J0Zdw0A.b['16'][0]++,colOperations[k])||(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['16'][1]++,'sum')).toLowerCase();__cov_yYTFAbucsFeHB$3J0Zdw0A.s['78']++;precisions[idx]=decimalPrecisions[k];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['79']++;labels[idx]=this.labelIds[k];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['80']++;writeType=(0,_types.isArray)(outputTypes)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['17'][0]++,outputTypes[k]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['17'][1]++,null);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['81']++;formatResult[idx]=this.configureFormat(uIndexes[u],formatResults[k]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['82']++;idx++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['83']++;for(var i=0;i<idx;i++){__cov_yYTFAbucsFeHB$3J0Zdw0A.s['84']++;this.emitter.emit('before-column-calc',tf,this,uIndexes[u],curValues,operations[i],precisions[i]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['85']++;result=Number(this.calc(curValues,operations[i],null));__cov_yYTFAbucsFeHB$3J0Zdw0A.s['86']++;this.emitter.emit('column-calc',tf,this,uIndexes[u],result,operations[i],precisions[i]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['87']++;this.writeResult(result,labels[i],writeType,precisions[i],formatResult[i]);}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['88']++;var totRow=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['19'][0]++,totRowIndexes)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['19'][1]++,totRowIndexes[u])?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['18'][0]++,rows[totRowIndexes[u]]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['18'][1]++,null);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['89']++;if(totRow){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['20'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['90']++;totRow.style.display='';}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['20'][1]++;}}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['91']++;this.onAfterOperation(tf,this);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['92']++;this.emitter.emit('after-column-operation',tf,this);};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['93']++;ColOps.prototype.columnCalc=function columnCalc(colIndex){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['10']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['94']++;var operation=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['22'][0]++,arguments.length>1)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['22'][1]++,arguments[1]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['21'][0]++,arguments[1]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['21'][1]++,SUM);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['95']++;var precision=arguments[2];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['96']++;var excludeRows=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['23'][0]++,this.excludeRows)||(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['23'][1]++,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['97']++;var colValues=tf.getVisibleColumnData(colIndex,false,excludeRows);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['98']++;return Number(this.calc(colValues,operation,precision));};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['99']++;ColOps.prototype.calc=function calc(colValues){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['11']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['100']++;var operation=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['25'][0]++,arguments.length>1)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['25'][1]++,arguments[1]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['24'][0]++,arguments[1]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['24'][1]++,SUM);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['101']++;var precision=arguments[2];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['102']++;var result=0;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['103']++;if((__cov_yYTFAbucsFeHB$3J0Zdw0A.b['27'][0]++,operation===Q1)||(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['27'][1]++,operation===Q3)||(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['27'][2]++,operation===MEDIAN)){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['26'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['104']++;colValues=this.sortColumnValues(colValues,_sort.numSortAsc);}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['26'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['105']++;switch(operation){case MEAN:__cov_yYTFAbucsFeHB$3J0Zdw0A.b['28'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['106']++;result=this.calcMean(colValues);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['107']++;break;case SUM:__cov_yYTFAbucsFeHB$3J0Zdw0A.b['28'][1]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['108']++;result=this.calcSum(colValues);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['109']++;break;case MIN:__cov_yYTFAbucsFeHB$3J0Zdw0A.b['28'][2]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['110']++;result=this.calcMin(colValues);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['111']++;break;case MAX:__cov_yYTFAbucsFeHB$3J0Zdw0A.b['28'][3]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['112']++;result=this.calcMax(colValues);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['113']++;break;case MEDIAN:__cov_yYTFAbucsFeHB$3J0Zdw0A.b['28'][4]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['114']++;result=this.calcMedian(colValues);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['115']++;break;case Q1:__cov_yYTFAbucsFeHB$3J0Zdw0A.b['28'][5]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['116']++;result=this.calcQ1(colValues);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['117']++;break;case Q3:__cov_yYTFAbucsFeHB$3J0Zdw0A.b['28'][6]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['118']++;result=this.calcQ3(colValues);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['119']++;break;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['120']++;return(0,_types.isEmpty)(precision)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['29'][0]++,result):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['29'][1]++,result.toFixed(precision));};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['121']++;ColOps.prototype.calcSum=function calcSum(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['12']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['122']++;var values=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['31'][0]++,arguments.length>0)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['31'][1]++,arguments[0]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['30'][0]++,arguments[0]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['30'][1]++,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['123']++;if((0,_types.isEmpty)(values)){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['32'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['124']++;return 0;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['32'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['125']++;var result=values.reduce(function(x,y){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['13']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['126']++;return Number(x)+Number(y);});__cov_yYTFAbucsFeHB$3J0Zdw0A.s['127']++;return result;};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['128']++;ColOps.prototype.calcMean=function calcMean(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['14']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['129']++;var values=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['34'][0]++,arguments.length>0)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['34'][1]++,arguments[0]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['33'][0]++,arguments[0]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['33'][1]++,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['130']++;var result=this.calcSum(values)/values.length;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['131']++;return Number(result);};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['132']++;ColOps.prototype.calcMax=function calcMax(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['15']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['133']++;var values=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['36'][0]++,arguments.length>0)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['36'][1]++,arguments[0]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['35'][0]++,arguments[0]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['35'][1]++,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['134']++;return Math.max.apply(null,values);};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['135']++;ColOps.prototype.calcMin=function calcMin(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['16']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['136']++;var values=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['38'][0]++,arguments.length>0)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['38'][1]++,arguments[0]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['37'][0]++,arguments[0]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['37'][1]++,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['137']++;return Math.min.apply(null,values);};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['138']++;ColOps.prototype.calcMedian=function calcMedian(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['17']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['139']++;var values=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['40'][0]++,arguments.length>0)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['40'][1]++,arguments[0]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['39'][0]++,arguments[0]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['39'][1]++,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['140']++;var nbValues=values.length;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['141']++;var aux=0;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['142']++;if(nbValues%2===1){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['41'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['143']++;aux=Math.floor(nbValues/2);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['144']++;return Number(values[aux]);}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['41'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['145']++;return(Number(values[nbValues/2])+Number(values[nbValues/2-1]))/2;};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['146']++;ColOps.prototype.calcQ1=function calcQ1(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['18']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['147']++;var values=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['43'][0]++,arguments.length>0)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['43'][1]++,arguments[0]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['42'][0]++,arguments[0]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['42'][1]++,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['148']++;var nbValues=values.length;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['149']++;var posa=0;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['150']++;posa=Math.floor(nbValues/4);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['151']++;if(4*posa===nbValues){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['44'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['152']++;return(Number(values[posa-1])+Number(values[posa]))/2;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['44'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['153']++;return Number(values[posa]);};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['154']++;ColOps.prototype.calcQ3=function calcQ3(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['19']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['155']++;var values=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['46'][0]++,arguments.length>0)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['46'][1]++,arguments[0]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['45'][0]++,arguments[0]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['45'][1]++,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['156']++;var nbValues=values.length;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['157']++;var posa=0;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['158']++;var posb=0;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['159']++;posa=Math.floor(nbValues/4);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['160']++;if(4*posa===nbValues){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['47'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['161']++;posb=3*posa;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['162']++;return(Number(values[posb])+Number(values[posb-1]))/2;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['47'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['163']++;return Number(values[nbValues-posa-1]);};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['164']++;ColOps.prototype.sortColumnValues=function sortColumnValues(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['20']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['165']++;var values=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['49'][0]++,arguments.length>0)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['49'][1]++,arguments[0]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['48'][0]++,arguments[0]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['48'][1]++,[]);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['166']++;var sorter=arguments[1];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['167']++;return values.sort(sorter);};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['168']++;ColOps.prototype.writeResult=function writeResult(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['21']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['169']++;var result=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['51'][0]++,arguments.length>0)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['51'][1]++,arguments[0]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['50'][0]++,arguments[0]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['50'][1]++,0);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['170']++;var label=arguments[1];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['171']++;var writeType=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['53'][0]++,arguments.length>2)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['53'][1]++,arguments[2]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['52'][0]++,arguments[2]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['52'][1]++,'innerhtml');__cov_yYTFAbucsFeHB$3J0Zdw0A.s['172']++;var precision=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['55'][0]++,arguments.length>3)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['55'][1]++,arguments[3]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['54'][0]++,arguments[3]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['54'][1]++,2);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['173']++;var format=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['57'][0]++,arguments.length>4)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['57'][1]++,arguments[4]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['56'][0]++,arguments[4]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['56'][1]++,{});__cov_yYTFAbucsFeHB$3J0Zdw0A.s['174']++;var labelElm=(0,_dom.elm)(label);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['175']++;if(!labelElm){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['58'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['176']++;return;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['58'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['177']++;result=result.toFixed(precision);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['178']++;if((__cov_yYTFAbucsFeHB$3J0Zdw0A.b['60'][0]++,isNaN(result))||(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['60'][1]++,!isFinite(result))){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['59'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['179']++;result='';}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['59'][1]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['180']++;result=(0,_formatNumber2.default)(format)(result);}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['181']++;switch(writeType.toLowerCase()){case'innerhtml':__cov_yYTFAbucsFeHB$3J0Zdw0A.b['61'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['182']++;labelElm.innerHTML=result;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['183']++;break;case'setvalue':__cov_yYTFAbucsFeHB$3J0Zdw0A.b['61'][1]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['184']++;labelElm.value=result;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['185']++;break;case'createtextnode':__cov_yYTFAbucsFeHB$3J0Zdw0A.b['61'][2]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['186']++;var oldNode=labelElm.firstChild;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['187']++;var txtNode=(0,_dom.createText)(result);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['188']++;labelElm.replaceChild(txtNode,oldNode);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['189']++;break;}};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['190']++;ColOps.prototype.configureFormat=function configureFormat(colIndex){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['22']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['191']++;var format=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['63'][0]++,arguments.length>1)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['63'][1]++,arguments[1]!==undefined)?(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['62'][0]++,arguments[1]):(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['62'][1]++,{});__cov_yYTFAbucsFeHB$3J0Zdw0A.s['192']++;var tf=this.tf;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['193']++;if(tf.hasType(colIndex,[_const.FORMATTED_NUMBER])){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['64'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['194']++;var colType=tf.colTypes[colIndex];__cov_yYTFAbucsFeHB$3J0Zdw0A.s['195']++;if((__cov_yYTFAbucsFeHB$3J0Zdw0A.b['66'][0]++,colType.decimal)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['66'][1]++,!format.decimal)){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['65'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['196']++;format.decimal=colType.decimal;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['65'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['197']++;if((__cov_yYTFAbucsFeHB$3J0Zdw0A.b['68'][0]++,colType.thousands)&&(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['68'][1]++,!format.integerSeparator)){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['67'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['198']++;format.integerSeparator=colType.thousands;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['67'][1]++;}}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['64'][1]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['199']++;format.decimal=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['69'][0]++,format.decimal)||(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['69'][1]++,'');__cov_yYTFAbucsFeHB$3J0Zdw0A.s['200']++;format.integerSeparator=(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['70'][0]++,format.integerSeparator)||(__cov_yYTFAbucsFeHB$3J0Zdw0A.b['70'][1]++,'');}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['201']++;return format;};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['202']++;ColOps.prototype.destroy=function destroy(){__cov_yYTFAbucsFeHB$3J0Zdw0A.f['23']++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['203']++;if(!this.initialized){__cov_yYTFAbucsFeHB$3J0Zdw0A.b['71'][0]++;__cov_yYTFAbucsFeHB$3J0Zdw0A.s['204']++;return;}else{__cov_yYTFAbucsFeHB$3J0Zdw0A.b['71'][1]++;}__cov_yYTFAbucsFeHB$3J0Zdw0A.s['205']++;this.emitter.off(EVENTS,(0,_event.bound)(this.calcAll,this));__cov_yYTFAbucsFeHB$3J0Zdw0A.s['206']++;this.initialized=false;};__cov_yYTFAbucsFeHB$3J0Zdw0A.s['207']++;return ColOps;}(_feature.Feature);__cov_yYTFAbucsFeHB$3J0Zdw0A.s['208']++;exports.default=ColOps;


/***/ }),

/***/ "./src/extensions/colsVisibility/colsVisibility.js":
/*!*********************************************************!*\
  !*** ./src/extensions/colsVisibility/colsVisibility.js ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __cov_o8lZ1tV3qvmAZwNRQYMKAA = (Function('return this'))();
if (!__cov_o8lZ1tV3qvmAZwNRQYMKAA.__coverage__) { __cov_o8lZ1tV3qvmAZwNRQYMKAA.__coverage__ = {}; }
__cov_o8lZ1tV3qvmAZwNRQYMKAA = __cov_o8lZ1tV3qvmAZwNRQYMKAA.__coverage__;
if (!(__cov_o8lZ1tV3qvmAZwNRQYMKAA['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\colsVisibility\\colsVisibility.js'])) {
   __cov_o8lZ1tV3qvmAZwNRQYMKAA['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\colsVisibility\\colsVisibility.js'] = {"path":"C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\colsVisibility\\colsVisibility.js","s":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":0,"8":0,"9":0,"10":1,"11":0,"12":0,"13":1,"14":0,"15":0,"16":0,"17":1,"18":0,"19":0,"20":0,"21":0,"22":0,"23":0,"24":0,"25":1,"26":0,"27":0,"28":0,"29":0,"30":0,"31":0,"32":0,"33":0,"34":0,"35":0,"36":0,"37":0,"38":0,"39":0,"40":0,"41":0,"42":0,"43":0,"44":0,"45":0,"46":0,"47":0,"48":0,"49":0,"50":0,"51":0,"52":0,"53":0,"54":0,"55":0,"56":0,"57":0,"58":0,"59":0,"60":0,"61":0,"62":0,"63":0,"64":0,"65":0,"66":0,"67":0,"68":0,"69":0,"70":0,"71":0,"72":0,"73":0,"74":0,"75":0,"76":0,"77":0,"78":0,"79":0,"80":0,"81":0,"82":0,"83":0,"84":0,"85":0,"86":0,"87":0,"88":0,"89":0,"90":0,"91":0,"92":0,"93":0,"94":0,"95":0,"96":0,"97":0,"98":0,"99":0,"100":0,"101":0,"102":0,"103":0,"104":0,"105":0,"106":0,"107":0,"108":0,"109":0,"110":0,"111":0,"112":0,"113":0,"114":0,"115":0,"116":0,"117":0,"118":0,"119":0,"120":0,"121":0,"122":0,"123":0,"124":0,"125":0,"126":0,"127":0,"128":0,"129":0,"130":0,"131":0,"132":0,"133":0,"134":0,"135":0,"136":0,"137":0,"138":0,"139":0,"140":0,"141":0,"142":0,"143":0,"144":0,"145":0,"146":0,"147":0,"148":0,"149":0,"150":0,"151":0,"152":0,"153":0,"154":0,"155":0,"156":0,"157":0,"158":0,"159":0,"160":0,"161":0,"162":0,"163":0,"164":0,"165":0,"166":0,"167":0,"168":0,"169":0,"170":0,"171":0,"172":0,"173":0,"174":0,"175":0,"176":0,"177":0,"178":0,"179":0,"180":0,"181":0,"182":0,"183":0,"184":0,"185":0,"186":0,"187":0,"188":0,"189":0,"190":0,"191":0,"192":0,"193":0,"194":0,"195":0,"196":0,"197":0,"198":0,"199":0,"200":0,"201":0,"202":0,"203":0,"204":0,"205":0,"206":0,"207":0,"208":0,"209":0,"210":0,"211":0,"212":0,"213":0,"214":0,"215":0,"216":0,"217":0,"218":0,"219":0,"220":0,"221":0,"222":0,"223":0,"224":0,"225":0,"226":0,"227":0,"228":0,"229":0,"230":0,"231":0,"232":0,"233":0,"234":0,"235":0,"236":0,"237":0,"238":0,"239":0,"240":0,"241":0,"242":0,"243":0,"244":0,"245":0,"246":0,"247":0,"248":0,"249":0,"250":0,"251":0,"252":0,"253":0,"254":0,"255":0,"256":0,"257":0,"258":0,"259":0,"260":0,"261":0,"262":0,"263":0,"264":0,"265":0,"266":0,"267":0,"268":0,"269":0,"270":0,"271":0,"272":0,"273":0,"274":0,"275":0,"276":0,"277":0,"278":0,"279":0,"280":0,"281":0,"282":0,"283":0,"284":0,"285":0,"286":0,"287":0,"288":0,"289":0,"290":0,"291":0,"292":0,"293":0,"294":0,"295":0,"296":0,"297":0,"298":0,"299":0,"300":0,"301":0,"302":0,"303":0,"304":0,"305":0,"306":0,"307":0},"b":{"1":[0,0],"2":[0,0],"3":[0,0],"4":[0,0,0],"5":[0,0],"6":[0,0],"7":[0,0],"8":[0,0],"9":[0,0],"10":[0,0],"11":[0,0],"12":[0,0],"13":[0,0,0],"14":[0,0],"15":[0,0],"16":[0,0],"17":[0,0],"18":[0,0],"19":[0,0],"20":[0,0],"21":[0,0],"22":[0,0],"23":[0,0],"24":[0,0],"25":[0,0,0,0],"26":[0,0],"27":[0,0],"28":[0,0],"29":[0,0],"30":[0,0],"31":[0,0],"32":[0,0],"33":[0,0],"34":[0,0],"35":[0,0],"36":[0,0],"37":[0,0],"38":[0,0],"39":[0,0],"40":[0,0],"41":[0,0],"42":[0,0],"43":[0,0],"44":[0,0],"45":[0,0],"46":[0,0],"47":[0,0],"48":[0,0],"49":[0,0],"50":[0,0],"51":[0,0],"52":[0,0],"53":[0,0],"54":[0,0],"55":[0,0],"56":[0,0],"57":[0,0],"58":[0,0],"59":[0,0],"60":[0,0],"61":[0,0],"62":[0,0],"63":[0,0],"64":[0,0],"65":[0,0],"66":[0,0],"67":[0,0],"68":[0,0],"69":[0,0],"70":[0,0],"71":[0,0],"72":[0,0],"73":[0,0]},"f":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":0,"8":0,"9":0,"10":0,"11":0,"12":0,"13":0,"14":0,"15":0,"16":0,"17":0,"18":0,"19":0,"20":0,"21":0,"22":0,"23":0,"24":0,"25":0,"26":0,"27":0,"28":0,"29":0,"30":0,"31":0,"32":0,"33":0,"34":0},"fnMap":{"1":{"name":"_classCallCheck","line":23,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"2":{"name":"_possibleConstructorReturn","line":25,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"3":{"name":"_inherits","line":27,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"4":{"name":"(anonymous_4)","line":32,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"5":{"name":"ColsVisibility","line":40,"loc":{"start":{"line":25,"column":4},"end":{"line":25,"column":23}}},"6":{"name":"onMouseup","line":314,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"7":{"name":"toggle","line":333,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"8":{"name":"checkItem","line":363,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"9":{"name":"init","line":389,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"10":{"name":"(anonymous_10)","line":398,"loc":{"start":{"line":383,"column":12},"end":{"line":383,"column":12}}},"11":{"name":"buildBtn","line":423,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"12":{"name":"(anonymous_12)","line":451,"loc":{"start":{"line":432,"column":37},"end":{"line":432,"column":37}}},"13":{"name":"(anonymous_13)","line":455,"loc":{"start":{"line":434,"column":41},"end":{"line":434,"column":41}}},"14":{"name":"(anonymous_14)","line":464,"loc":{"start":{"line":440,"column":42},"end":{"line":440,"column":42}}},"15":{"name":"(anonymous_15)","line":468,"loc":{"start":{"line":442,"column":46},"end":{"line":442,"column":46}}},"16":{"name":"buildManager","line":485,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"17":{"name":"(anonymous_17)","line":513,"loc":{"start":{"line":485,"column":38},"end":{"line":485,"column":44}}},"18":{"name":"(anonymous_18)","line":537,"loc":{"start":{"line":510,"column":41},"end":{"line":510,"column":50}}},"19":{"name":"(anonymous_19)","line":552,"loc":{"start":{"line":525,"column":33},"end":{"line":525,"column":33}}},"20":{"name":"(anonymous_20)","line":559,"loc":{"start":{"line":530,"column":33},"end":{"line":530,"column":33}}},"21":{"name":"setHidden","line":578,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"22":{"name":"showCol","line":620,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"23":{"name":"hideCol","line":640,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"24":{"name":"isColHidden","line":660,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"25":{"name":"toggleCol","line":673,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"26":{"name":"getHiddenCols","line":687,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"27":{"name":"destroy","line":696,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"28":{"name":"(anonymous_28)","line":713,"loc":{"start":{"line":669,"column":12},"end":{"line":669,"column":12}}},"29":{"name":"_getHeaderText","line":722,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"30":{"name":"_hideElements","line":743,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"31":{"name":"_hideCells","line":748,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"32":{"name":"_hideCol","line":758,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"33":{"name":"_hideAtStart","line":766,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"34":{"name":"(anonymous_34)","line":769,"loc":{"start":{"line":721,"column":29},"end":{"line":721,"column":41}}}},"statementMap":{"1":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"2":{"start":{"line":1,"column":0},"end":{"line":1,"column":0}},"3":{"start":{"line":2,"column":0},"end":{"line":2,"column":0}},"4":{"start":{"line":6,"column":0},"end":{"line":6,"column":0}},"5":{"start":{"line":7,"column":0},"end":{"line":7,"column":0}},"6":{"start":{"line":8,"column":0},"end":{"line":8,"column":0}},"7":{"start":{"line":9,"column":0},"end":{"line":9,"column":0}},"8":{"start":{"line":10,"column":0},"end":{"line":10,"column":0}},"9":{"start":{"line":13,"column":0},"end":{"line":13,"column":0}},"10":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"11":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"12":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"13":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"14":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"15":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"16":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"17":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"18":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"19":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"20":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"21":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"22":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"23":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"24":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"25":{"start":{"line":25,"column":4},"end":{"line":296,"column":5}},"26":{"start":{"line":25,"column":23},"end":{"line":25,"column":23}},"27":{"start":{"line":25,"column":23},"end":{"line":25,"column":23}},"28":{"start":{"line":29,"column":8},"end":{"line":29,"column":8}},"29":{"start":{"line":35,"column":8},"end":{"line":35,"column":8}},"30":{"start":{"line":41,"column":8},"end":{"line":41,"column":8}},"31":{"start":{"line":47,"column":8},"end":{"line":47,"column":8}},"32":{"start":{"line":53,"column":8},"end":{"line":53,"column":8}},"33":{"start":{"line":59,"column":8},"end":{"line":59,"column":8}},"34":{"start":{"line":65,"column":8},"end":{"line":65,"column":8}},"35":{"start":{"line":71,"column":8},"end":{"line":71,"column":8}},"36":{"start":{"line":77,"column":8},"end":{"line":77,"column":8}},"37":{"start":{"line":83,"column":8},"end":{"line":83,"column":8}},"38":{"start":{"line":89,"column":8},"end":{"line":89,"column":8}},"39":{"start":{"line":95,"column":8},"end":{"line":95,"column":8}},"40":{"start":{"line":101,"column":8},"end":{"line":101,"column":8}},"41":{"start":{"line":107,"column":8},"end":{"line":107,"column":8}},"42":{"start":{"line":113,"column":8},"end":{"line":113,"column":8}},"43":{"start":{"line":119,"column":8},"end":{"line":119,"column":8}},"44":{"start":{"line":125,"column":8},"end":{"line":125,"column":8}},"45":{"start":{"line":131,"column":8},"end":{"line":131,"column":8}},"46":{"start":{"line":137,"column":8},"end":{"line":137,"column":8}},"47":{"start":{"line":144,"column":8},"end":{"line":144,"column":8}},"48":{"start":{"line":150,"column":8},"end":{"line":150,"column":8}},"49":{"start":{"line":156,"column":8},"end":{"line":156,"column":8}},"50":{"start":{"line":162,"column":8},"end":{"line":162,"column":8}},"51":{"start":{"line":168,"column":8},"end":{"line":168,"column":8}},"52":{"start":{"line":175,"column":8},"end":{"line":175,"column":8}},"53":{"start":{"line":185,"column":8},"end":{"line":185,"column":8}},"54":{"start":{"line":191,"column":8},"end":{"line":191,"column":8}},"55":{"start":{"line":197,"column":8},"end":{"line":197,"column":8}},"56":{"start":{"line":203,"column":8},"end":{"line":203,"column":8}},"57":{"start":{"line":209,"column":8},"end":{"line":209,"column":8}},"58":{"start":{"line":215,"column":8},"end":{"line":215,"column":8}},"59":{"start":{"line":221,"column":8},"end":{"line":221,"column":8}},"60":{"start":{"line":227,"column":8},"end":{"line":227,"column":8}},"61":{"start":{"line":233,"column":8},"end":{"line":233,"column":8}},"62":{"start":{"line":239,"column":8},"end":{"line":239,"column":8}},"63":{"start":{"line":245,"column":8},"end":{"line":245,"column":8}},"64":{"start":{"line":251,"column":8},"end":{"line":251,"column":8}},"65":{"start":{"line":257,"column":8},"end":{"line":257,"column":8}},"66":{"start":{"line":263,"column":8},"end":{"line":263,"column":8}},"67":{"start":{"line":269,"column":8},"end":{"line":269,"column":8}},"68":{"start":{"line":275,"column":8},"end":{"line":275,"column":8}},"69":{"start":{"line":282,"column":8},"end":{"line":282,"column":8}},"70":{"start":{"line":286,"column":8},"end":{"line":289,"column":9}},"71":{"start":{"line":287,"column":12},"end":{"line":286,"column":27}},"72":{"start":{"line":288,"column":12},"end":{"line":286,"column":27}},"73":{"start":{"line":292,"column":8},"end":{"line":292,"column":8}},"74":{"start":{"line":295,"column":8},"end":{"line":295,"column":8}},"75":{"start":{"line":25,"column":23},"end":{"line":25,"column":23}},"76":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"77":{"start":{"line":303,"column":8},"end":{"line":303,"column":8}},"78":{"start":{"line":305,"column":8},"end":{"line":308,"column":9}},"79":{"start":{"line":307,"column":12},"end":{"line":307,"column":12}},"80":{"start":{"line":310,"column":8},"end":{"line":312,"column":9}},"81":{"start":{"line":311,"column":12},"end":{"line":311,"column":12}},"82":{"start":{"line":314,"column":8},"end":{"line":314,"column":8}},"83":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"84":{"start":{"line":322,"column":8},"end":{"line":322,"column":8}},"85":{"start":{"line":324,"column":8},"end":{"line":324,"column":8}},"86":{"start":{"line":326,"column":8},"end":{"line":328,"column":9}},"87":{"start":{"line":327,"column":12},"end":{"line":327,"column":12}},"88":{"start":{"line":329,"column":8},"end":{"line":331,"column":9}},"89":{"start":{"line":330,"column":12},"end":{"line":330,"column":12}},"90":{"start":{"line":333,"column":8},"end":{"line":333,"column":8}},"91":{"start":{"line":336,"column":8},"end":{"line":339,"column":9}},"92":{"start":{"line":337,"column":12},"end":{"line":337,"column":12}},"93":{"start":{"line":338,"column":12},"end":{"line":338,"column":12}},"94":{"start":{"line":340,"column":8},"end":{"line":342,"column":9}},"95":{"start":{"line":341,"column":12},"end":{"line":341,"column":12}},"96":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"97":{"start":{"line":350,"column":8},"end":{"line":350,"column":8}},"98":{"start":{"line":351,"column":8},"end":{"line":353,"column":9}},"99":{"start":{"line":352,"column":12},"end":{"line":352,"column":12}},"100":{"start":{"line":354,"column":8},"end":{"line":354,"column":8}},"101":{"start":{"line":355,"column":8},"end":{"line":355,"column":8}},"102":{"start":{"line":356,"column":8},"end":{"line":356,"column":8}},"103":{"start":{"line":357,"column":8},"end":{"line":361,"column":9}},"104":{"start":{"line":358,"column":12},"end":{"line":358,"column":12}},"105":{"start":{"line":360,"column":12},"end":{"line":360,"column":12}},"106":{"start":{"line":363,"column":8},"end":{"line":363,"column":8}},"107":{"start":{"line":364,"column":8},"end":{"line":367,"column":9}},"108":{"start":{"line":366,"column":12},"end":{"line":366,"column":12}},"109":{"start":{"line":368,"column":8},"end":{"line":368,"column":8}},"110":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"111":{"start":{"line":374,"column":11},"end":{"line":374,"column":11}},"112":{"start":{"line":375,"column":8},"end":{"line":377,"column":9}},"113":{"start":{"line":376,"column":12},"end":{"line":376,"column":12}},"114":{"start":{"line":379,"column":8},"end":{"line":379,"column":8}},"115":{"start":{"line":382,"column":8},"end":{"line":382,"column":8}},"116":{"start":{"line":383,"column":12},"end":{"line":383,"column":12}},"117":{"start":{"line":385,"column":8},"end":{"line":385,"column":8}},"118":{"start":{"line":386,"column":8},"end":{"line":386,"column":8}},"119":{"start":{"line":389,"column":8},"end":{"line":389,"column":8}},"120":{"start":{"line":391,"column":8},"end":{"line":391,"column":8}},"121":{"start":{"line":393,"column":8},"end":{"line":393,"column":8}},"122":{"start":{"line":394,"column":8},"end":{"line":394,"column":8}},"123":{"start":{"line":398,"column":8},"end":{"line":398,"column":8}},"124":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"125":{"start":{"line":404,"column":15},"end":{"line":404,"column":15}},"126":{"start":{"line":405,"column":8},"end":{"line":407,"column":9}},"127":{"start":{"line":406,"column":12},"end":{"line":406,"column":12}},"128":{"start":{"line":408,"column":8},"end":{"line":408,"column":8}},"129":{"start":{"line":409,"column":8},"end":{"line":409,"column":8}},"130":{"start":{"line":410,"column":8},"end":{"line":410,"column":8}},"131":{"start":{"line":413,"column":8},"end":{"line":413,"column":8}},"132":{"start":{"line":417,"column":8},"end":{"line":422,"column":9}},"133":{"start":{"line":418,"column":12},"end":{"line":418,"column":12}},"134":{"start":{"line":419,"column":12},"end":{"line":419,"column":12}},"135":{"start":{"line":421,"column":12},"end":{"line":421,"column":12}},"136":{"start":{"line":424,"column":8},"end":{"line":444,"column":9}},"137":{"start":{"line":425,"column":12},"end":{"line":425,"column":12}},"138":{"start":{"line":426,"column":12},"end":{"line":426,"column":12}},"139":{"start":{"line":427,"column":12},"end":{"line":427,"column":12}},"140":{"start":{"line":429,"column":12},"end":{"line":429,"column":12}},"141":{"start":{"line":430,"column":12},"end":{"line":430,"column":12}},"142":{"start":{"line":431,"column":12},"end":{"line":435,"column":13}},"143":{"start":{"line":432,"column":16},"end":{"line":432,"column":16}},"144":{"start":{"line":432,"column":37},"end":{"line":432,"column":37}},"145":{"start":{"line":434,"column":16},"end":{"line":434,"column":16}},"146":{"start":{"line":434,"column":41},"end":{"line":434,"column":41}},"147":{"start":{"line":437,"column":12},"end":{"line":437,"column":12}},"148":{"start":{"line":438,"column":12},"end":{"line":438,"column":12}},"149":{"start":{"line":439,"column":12},"end":{"line":443,"column":13}},"150":{"start":{"line":440,"column":16},"end":{"line":440,"column":16}},"151":{"start":{"line":440,"column":42},"end":{"line":440,"column":42}},"152":{"start":{"line":442,"column":16},"end":{"line":442,"column":16}},"153":{"start":{"line":442,"column":46},"end":{"line":442,"column":46}},"154":{"start":{"line":446,"column":8},"end":{"line":446,"column":8}},"155":{"start":{"line":447,"column":8},"end":{"line":447,"column":8}},"156":{"start":{"line":449,"column":8},"end":{"line":449,"column":8}},"157":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"158":{"start":{"line":455,"column":19},"end":{"line":455,"column":19}},"159":{"start":{"line":456,"column":8},"end":{"line":456,"column":8}},"160":{"start":{"line":458,"column":8},"end":{"line":458,"column":8}},"161":{"start":{"line":461,"column":8},"end":{"line":461,"column":8}},"162":{"start":{"line":464,"column":8},"end":{"line":464,"column":8}},"163":{"start":{"line":465,"column":8},"end":{"line":465,"column":8}},"164":{"start":{"line":466,"column":8},"end":{"line":466,"column":8}},"165":{"start":{"line":469,"column":8},"end":{"line":469,"column":8}},"166":{"start":{"line":470,"column":8},"end":{"line":470,"column":8}},"167":{"start":{"line":472,"column":8},"end":{"line":472,"column":8}},"168":{"start":{"line":473,"column":8},"end":{"line":473,"column":8}},"169":{"start":{"line":475,"column":8},"end":{"line":475,"column":8}},"170":{"start":{"line":478,"column":8},"end":{"line":494,"column":9}},"171":{"start":{"line":479,"column":12},"end":{"line":479,"column":12}},"172":{"start":{"line":481,"column":12},"end":{"line":481,"column":12}},"173":{"start":{"line":482,"column":12},"end":{"line":482,"column":12}},"174":{"start":{"line":483,"column":12},"end":{"line":483,"column":12}},"175":{"start":{"line":485,"column":12},"end":{"line":485,"column":12}},"176":{"start":{"line":486,"column":16},"end":{"line":492,"column":17}},"177":{"start":{"line":487,"column":20},"end":{"line":487,"column":20}},"178":{"start":{"line":488,"column":20},"end":{"line":491,"column":21}},"179":{"start":{"line":489,"column":24},"end":{"line":489,"column":24}},"180":{"start":{"line":490,"column":24},"end":{"line":490,"column":24}},"181":{"start":{"line":496,"column":8},"end":{"line":515,"column":9}},"182":{"start":{"line":497,"column":12},"end":{"line":497,"column":12}},"183":{"start":{"line":498,"column":12},"end":{"line":498,"column":12}},"184":{"start":{"line":499,"column":12},"end":{"line":499,"column":12}},"185":{"start":{"line":501,"column":12},"end":{"line":501,"column":12}},"186":{"start":{"line":502,"column":12},"end":{"line":504,"column":13}},"187":{"start":{"line":503,"column":16},"end":{"line":503,"column":16}},"188":{"start":{"line":505,"column":12},"end":{"line":505,"column":12}},"189":{"start":{"line":506,"column":12},"end":{"line":508,"column":13}},"190":{"start":{"line":507,"column":16},"end":{"line":507,"column":16}},"191":{"start":{"line":510,"column":12},"end":{"line":510,"column":12}},"192":{"start":{"line":511,"column":16},"end":{"line":511,"column":16}},"193":{"start":{"line":512,"column":16},"end":{"line":512,"column":16}},"194":{"start":{"line":513,"column":16},"end":{"line":513,"column":16}},"195":{"start":{"line":518,"column":8},"end":{"line":518,"column":8}},"196":{"start":{"line":519,"column":8},"end":{"line":519,"column":8}},"197":{"start":{"line":521,"column":8},"end":{"line":531,"column":9}},"198":{"start":{"line":522,"column":12},"end":{"line":522,"column":12}},"199":{"start":{"line":523,"column":12},"end":{"line":523,"column":12}},"200":{"start":{"line":524,"column":12},"end":{"line":524,"column":12}},"201":{"start":{"line":525,"column":12},"end":{"line":525,"column":12}},"202":{"start":{"line":525,"column":33},"end":{"line":525,"column":33}},"203":{"start":{"line":526,"column":12},"end":{"line":526,"column":12}},"204":{"start":{"line":528,"column":12},"end":{"line":528,"column":12}},"205":{"start":{"line":529,"column":12},"end":{"line":529,"column":12}},"206":{"start":{"line":530,"column":12},"end":{"line":530,"column":12}},"207":{"start":{"line":530,"column":33},"end":{"line":530,"column":33}},"208":{"start":{"line":533,"column":8},"end":{"line":533,"column":8}},"209":{"start":{"line":534,"column":8},"end":{"line":534,"column":8}},"210":{"start":{"line":536,"column":8},"end":{"line":536,"column":8}},"211":{"start":{"line":537,"column":8},"end":{"line":537,"column":8}},"212":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"213":{"start":{"line":546,"column":8},"end":{"line":546,"column":8}},"214":{"start":{"line":547,"column":8},"end":{"line":547,"column":8}},"215":{"start":{"line":549,"column":8},"end":{"line":553,"column":9}},"216":{"start":{"line":550,"column":12},"end":{"line":550,"column":12}},"217":{"start":{"line":552,"column":12},"end":{"line":552,"column":12}},"218":{"start":{"line":555,"column":8},"end":{"line":555,"column":8}},"219":{"start":{"line":556,"column":8},"end":{"line":558,"column":9}},"220":{"start":{"line":557,"column":12},"end":{"line":557,"column":12}},"221":{"start":{"line":560,"column":8},"end":{"line":560,"column":8}},"222":{"start":{"line":561,"column":8},"end":{"line":561,"column":8}},"223":{"start":{"line":562,"column":8},"end":{"line":570,"column":9}},"224":{"start":{"line":563,"column":12},"end":{"line":565,"column":13}},"225":{"start":{"line":564,"column":16},"end":{"line":564,"column":16}},"226":{"start":{"line":567,"column":12},"end":{"line":569,"column":13}},"227":{"start":{"line":568,"column":16},"end":{"line":568,"column":16}},"228":{"start":{"line":572,"column":8},"end":{"line":580,"column":9}},"229":{"start":{"line":573,"column":12},"end":{"line":573,"column":12}},"230":{"start":{"line":574,"column":12},"end":{"line":574,"column":12}},"231":{"start":{"line":577,"column":12},"end":{"line":577,"column":12}},"232":{"start":{"line":578,"column":12},"end":{"line":578,"column":12}},"233":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"234":{"start":{"line":588,"column":8},"end":{"line":590,"column":9}},"235":{"start":{"line":589,"column":12},"end":{"line":589,"column":12}},"236":{"start":{"line":591,"column":8},"end":{"line":598,"column":9}},"237":{"start":{"line":592,"column":12},"end":{"line":592,"column":12}},"238":{"start":{"line":593,"column":12},"end":{"line":595,"column":13}},"239":{"start":{"line":594,"column":16},"end":{"line":594,"column":16}},"240":{"start":{"line":597,"column":12},"end":{"line":597,"column":12}},"241":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"242":{"start":{"line":606,"column":8},"end":{"line":608,"column":9}},"243":{"start":{"line":607,"column":12},"end":{"line":607,"column":12}},"244":{"start":{"line":609,"column":8},"end":{"line":616,"column":9}},"245":{"start":{"line":610,"column":12},"end":{"line":610,"column":12}},"246":{"start":{"line":611,"column":12},"end":{"line":613,"column":13}},"247":{"start":{"line":612,"column":16},"end":{"line":612,"column":16}},"248":{"start":{"line":615,"column":12},"end":{"line":615,"column":12}},"249":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"250":{"start":{"line":624,"column":8},"end":{"line":626,"column":9}},"251":{"start":{"line":625,"column":12},"end":{"line":625,"column":12}},"252":{"start":{"line":627,"column":8},"end":{"line":627,"column":8}},"253":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"254":{"start":{"line":635,"column":8},"end":{"line":639,"column":9}},"255":{"start":{"line":636,"column":12},"end":{"line":636,"column":12}},"256":{"start":{"line":638,"column":12},"end":{"line":638,"column":12}},"257":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"258":{"start":{"line":647,"column":8},"end":{"line":647,"column":8}},"259":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"260":{"start":{"line":653,"column":14},"end":{"line":653,"column":14}},"261":{"start":{"line":654,"column":8},"end":{"line":656,"column":9}},"262":{"start":{"line":655,"column":12},"end":{"line":655,"column":12}},"263":{"start":{"line":657,"column":8},"end":{"line":663,"column":9}},"264":{"start":{"line":658,"column":12},"end":{"line":658,"column":12}},"265":{"start":{"line":660,"column":12},"end":{"line":660,"column":12}},"266":{"start":{"line":661,"column":12},"end":{"line":661,"column":12}},"267":{"start":{"line":662,"column":12},"end":{"line":662,"column":12}},"268":{"start":{"line":664,"column":8},"end":{"line":664,"column":8}},"269":{"start":{"line":665,"column":8},"end":{"line":665,"column":8}},"270":{"start":{"line":666,"column":8},"end":{"line":666,"column":8}},"271":{"start":{"line":668,"column":8},"end":{"line":668,"column":8}},"272":{"start":{"line":669,"column":12},"end":{"line":669,"column":12}},"273":{"start":{"line":671,"column":8},"end":{"line":671,"column":8}},"274":{"start":{"line":673,"column":8},"end":{"line":673,"column":8}},"275":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"276":{"start":{"line":677,"column":8},"end":{"line":679,"column":9}},"277":{"start":{"line":678,"column":12},"end":{"line":678,"column":12}},"278":{"start":{"line":681,"column":8},"end":{"line":693,"column":9}},"279":{"start":{"line":682,"column":12},"end":{"line":682,"column":12}},"280":{"start":{"line":683,"column":12},"end":{"line":691,"column":13}},"281":{"start":{"line":684,"column":16},"end":{"line":684,"column":16}},"282":{"start":{"line":685,"column":19},"end":{"line":691,"column":13}},"283":{"start":{"line":686,"column":16},"end":{"line":690,"column":17}},"284":{"start":{"line":687,"column":20},"end":{"line":687,"column":20}},"285":{"start":{"line":689,"column":20},"end":{"line":689,"column":20}},"286":{"start":{"line":692,"column":12},"end":{"line":692,"column":12}},"287":{"start":{"line":694,"column":8},"end":{"line":694,"column":8}},"288":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"289":{"start":{"line":698,"column":8},"end":{"line":698,"column":8}},"290":{"start":{"line":699,"column":8},"end":{"line":699,"column":8}},"291":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"292":{"start":{"line":703,"column":8},"end":{"line":709,"column":9}},"293":{"start":{"line":704,"column":12},"end":{"line":704,"column":12}},"294":{"start":{"line":705,"column":12},"end":{"line":705,"column":12}},"295":{"start":{"line":706,"column":12},"end":{"line":708,"column":13}},"296":{"start":{"line":707,"column":16},"end":{"line":707,"column":16}},"297":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"298":{"start":{"line":713,"column":8},"end":{"line":713,"column":8}},"299":{"start":{"line":714,"column":8},"end":{"line":716,"column":9}},"300":{"start":{"line":715,"column":12},"end":{"line":715,"column":12}},"301":{"start":{"line":717,"column":8},"end":{"line":717,"column":8}},"302":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"303":{"start":{"line":720,"column":19},"end":{"line":720,"column":19}},"304":{"start":{"line":721,"column":8},"end":{"line":721,"column":8}},"305":{"start":{"line":722,"column":12},"end":{"line":722,"column":12}},"306":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"307":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}},"branchMap":{"1":{"line":23,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"2":{"line":25,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"3":{"line":25,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"4":{"line":25,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"5":{"line":27,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"6":{"line":27,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"7":{"line":27,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"8":{"line":27,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"9":{"line":27,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"10":{"line":94,"type":"binary-expr","locations":[{"start":{"line":77,"column":26},"end":{"line":77,"column":26}},{"start":{"line":77,"column":45},"end":{"line":77,"column":8}}]},"11":{"line":197,"type":"cond-expr","locations":[{"start":{"line":185,"column":58},"end":{"line":185,"column":40}},{"start":{"line":185,"column":69},"end":{"line":185,"column":20}}]},"12":{"line":296,"type":"if","locations":[{"start":{"line":286,"column":8},"end":{"line":286,"column":8}},{"start":{"line":286,"column":8},"end":{"line":286,"column":8}}]},"13":{"line":317,"type":"binary-expr","locations":[{"start":{"line":305,"column":15},"end":{"line":305,"column":15}},{"start":{"line":305,"column":28},"end":{"line":305,"column":15}},{"start":{"line":306,"column":15},"end":{"line":305,"column":8}}]},"14":{"line":321,"type":"if","locations":[{"start":{"line":310,"column":8},"end":{"line":310,"column":8}},{"start":{"line":310,"column":8},"end":{"line":310,"column":8}}]},"15":{"line":321,"type":"binary-expr","locations":[{"start":{"line":310,"column":12},"end":{"line":310,"column":12}},{"start":{"line":310,"column":41},"end":{"line":310,"column":8}}]},"16":{"line":339,"type":"if","locations":[{"start":{"line":326,"column":8},"end":{"line":326,"column":8}},{"start":{"line":326,"column":8},"end":{"line":326,"column":8}}]},"17":{"line":342,"type":"if","locations":[{"start":{"line":329,"column":8},"end":{"line":329,"column":8}},{"start":{"line":329,"column":8},"end":{"line":329,"column":8}}]},"18":{"line":346,"type":"cond-expr","locations":[{"start":{"line":334,"column":12},"end":{"line":333,"column":36}},{"start":{"line":334,"column":19},"end":{"line":333,"column":8}}]},"19":{"line":348,"type":"if","locations":[{"start":{"line":336,"column":8},"end":{"line":336,"column":8}},{"start":{"line":336,"column":8},"end":{"line":336,"column":8}}]},"20":{"line":352,"type":"if","locations":[{"start":{"line":340,"column":8},"end":{"line":340,"column":8}},{"start":{"line":340,"column":8},"end":{"line":340,"column":8}}]},"21":{"line":365,"type":"if","locations":[{"start":{"line":351,"column":8},"end":{"line":351,"column":8}},{"start":{"line":351,"column":8},"end":{"line":351,"column":8}}]},"22":{"line":365,"type":"binary-expr","locations":[{"start":{"line":351,"column":12},"end":{"line":351,"column":12}},{"start":{"line":351,"column":19},"end":{"line":351,"column":8}}]},"23":{"line":371,"type":"if","locations":[{"start":{"line":357,"column":8},"end":{"line":357,"column":8}},{"start":{"line":357,"column":8},"end":{"line":357,"column":8}}]},"24":{"line":378,"type":"if","locations":[{"start":{"line":364,"column":8},"end":{"line":364,"column":8}},{"start":{"line":364,"column":8},"end":{"line":364,"column":8}}]},"25":{"line":378,"type":"binary-expr","locations":[{"start":{"line":364,"column":13},"end":{"line":364,"column":13}},{"start":{"line":364,"column":32},"end":{"line":364,"column":12}},{"start":{"line":365,"column":13},"end":{"line":365,"column":13}},{"start":{"line":365,"column":33},"end":{"line":364,"column":8}}]},"26":{"line":392,"type":"if","locations":[{"start":{"line":375,"column":8},"end":{"line":375,"column":8}},{"start":{"line":375,"column":8},"end":{"line":375,"column":8}}]},"27":{"line":392,"type":"binary-expr","locations":[{"start":{"line":375,"column":12},"end":{"line":375,"column":12}},{"start":{"line":375,"column":32},"end":{"line":375,"column":8}}]},"28":{"line":426,"type":"if","locations":[{"start":{"line":405,"column":8},"end":{"line":405,"column":8}},{"start":{"line":405,"column":8},"end":{"line":405,"column":8}}]},"29":{"line":434,"type":"cond-expr","locations":[{"start":{"line":414,"column":12},"end":{"line":413,"column":23}},{"start":{"line":415,"column":12},"end":{"line":413,"column":8}}]},"30":{"line":436,"type":"if","locations":[{"start":{"line":417,"column":8},"end":{"line":417,"column":8}},{"start":{"line":417,"column":8},"end":{"line":417,"column":8}}]},"31":{"line":443,"type":"if","locations":[{"start":{"line":424,"column":8},"end":{"line":424,"column":8}},{"start":{"line":424,"column":8},"end":{"line":424,"column":8}}]},"32":{"line":450,"type":"if","locations":[{"start":{"line":431,"column":12},"end":{"line":431,"column":12}},{"start":{"line":431,"column":12},"end":{"line":431,"column":12}}]},"33":{"line":463,"type":"if","locations":[{"start":{"line":439,"column":12},"end":{"line":439,"column":12}},{"start":{"line":439,"column":12},"end":{"line":439,"column":12}}]},"34":{"line":490,"type":"cond-expr","locations":[{"start":{"line":459,"column":12},"end":{"line":458,"column":24}},{"start":{"line":460,"column":12},"end":{"line":458,"column":8}}]},"35":{"line":502,"type":"binary-expr","locations":[{"start":{"line":472,"column":18},"end":{"line":472,"column":18}},{"start":{"line":472,"column":37},"end":{"line":472,"column":8}}]},"36":{"line":503,"type":"cond-expr","locations":[{"start":{"line":474,"column":12},"end":{"line":473,"column":26}},{"start":{"line":474,"column":32},"end":{"line":473,"column":8}}]},"37":{"line":507,"type":"if","locations":[{"start":{"line":478,"column":8},"end":{"line":478,"column":8}},{"start":{"line":478,"column":8},"end":{"line":478,"column":8}}]},"38":{"line":516,"type":"if","locations":[{"start":{"line":488,"column":20},"end":{"line":488,"column":20}},{"start":{"line":488,"column":20},"end":{"line":488,"column":20}}]},"39":{"line":516,"type":"binary-expr","locations":[{"start":{"line":488,"column":24},"end":{"line":488,"column":24}},{"start":{"line":488,"column":31},"end":{"line":488,"column":20}}]},"40":{"line":526,"type":"binary-expr","locations":[{"start":{"line":498,"column":27},"end":{"line":498,"column":27}},{"start":{"line":498,"column":50},"end":{"line":498,"column":12}}]},"41":{"line":529,"type":"if","locations":[{"start":{"line":502,"column":12},"end":{"line":502,"column":12}},{"start":{"line":502,"column":12},"end":{"line":502,"column":12}}]},"42":{"line":533,"type":"if","locations":[{"start":{"line":506,"column":12},"end":{"line":506,"column":12}},{"start":{"line":506,"column":12},"end":{"line":506,"column":12}}]},"43":{"line":548,"type":"if","locations":[{"start":{"line":521,"column":8},"end":{"line":521,"column":8}},{"start":{"line":521,"column":8},"end":{"line":521,"column":8}}]},"44":{"line":582,"type":"if","locations":[{"start":{"line":549,"column":8},"end":{"line":549,"column":8}},{"start":{"line":549,"column":8},"end":{"line":549,"column":8}}]},"45":{"line":589,"type":"if","locations":[{"start":{"line":556,"column":8},"end":{"line":556,"column":8}},{"start":{"line":556,"column":8},"end":{"line":556,"column":8}}]},"46":{"line":595,"type":"if","locations":[{"start":{"line":562,"column":8},"end":{"line":562,"column":8}},{"start":{"line":562,"column":8},"end":{"line":562,"column":8}}]},"47":{"line":596,"type":"if","locations":[{"start":{"line":563,"column":12},"end":{"line":563,"column":12}},{"start":{"line":563,"column":12},"end":{"line":563,"column":12}}]},"48":{"line":600,"type":"if","locations":[{"start":{"line":567,"column":12},"end":{"line":567,"column":12}},{"start":{"line":567,"column":12},"end":{"line":567,"column":12}}]},"49":{"line":605,"type":"if","locations":[{"start":{"line":572,"column":8},"end":{"line":572,"column":8}},{"start":{"line":572,"column":8},"end":{"line":572,"column":8}}]},"50":{"line":621,"type":"if","locations":[{"start":{"line":588,"column":8},"end":{"line":588,"column":8}},{"start":{"line":588,"column":8},"end":{"line":588,"column":8}}]},"51":{"line":621,"type":"binary-expr","locations":[{"start":{"line":588,"column":12},"end":{"line":588,"column":12}},{"start":{"line":588,"column":33},"end":{"line":588,"column":8}}]},"52":{"line":624,"type":"if","locations":[{"start":{"line":591,"column":8},"end":{"line":591,"column":8}},{"start":{"line":591,"column":8},"end":{"line":591,"column":8}}]},"53":{"line":624,"type":"binary-expr","locations":[{"start":{"line":591,"column":12},"end":{"line":591,"column":12}},{"start":{"line":591,"column":28},"end":{"line":591,"column":8}}]},"54":{"line":626,"type":"if","locations":[{"start":{"line":593,"column":12},"end":{"line":593,"column":12}},{"start":{"line":593,"column":12},"end":{"line":593,"column":12}}]},"55":{"line":641,"type":"if","locations":[{"start":{"line":606,"column":8},"end":{"line":606,"column":8}},{"start":{"line":606,"column":8},"end":{"line":606,"column":8}}]},"56":{"line":641,"type":"binary-expr","locations":[{"start":{"line":606,"column":12},"end":{"line":606,"column":12}},{"start":{"line":606,"column":33},"end":{"line":606,"column":8}}]},"57":{"line":644,"type":"if","locations":[{"start":{"line":609,"column":8},"end":{"line":609,"column":8}},{"start":{"line":609,"column":8},"end":{"line":609,"column":8}}]},"58":{"line":644,"type":"binary-expr","locations":[{"start":{"line":609,"column":12},"end":{"line":609,"column":12}},{"start":{"line":609,"column":28},"end":{"line":609,"column":8}}]},"59":{"line":646,"type":"if","locations":[{"start":{"line":611,"column":12},"end":{"line":611,"column":12}},{"start":{"line":611,"column":12},"end":{"line":611,"column":12}}]},"60":{"line":661,"type":"if","locations":[{"start":{"line":624,"column":8},"end":{"line":624,"column":8}},{"start":{"line":624,"column":8},"end":{"line":624,"column":8}}]},"61":{"line":674,"type":"if","locations":[{"start":{"line":635,"column":8},"end":{"line":635,"column":8}},{"start":{"line":635,"column":8},"end":{"line":635,"column":8}}]},"62":{"line":674,"type":"binary-expr","locations":[{"start":{"line":635,"column":12},"end":{"line":635,"column":12}},{"start":{"line":635,"column":33},"end":{"line":635,"column":8}}]},"63":{"line":699,"type":"if","locations":[{"start":{"line":654,"column":8},"end":{"line":654,"column":8}},{"start":{"line":654,"column":8},"end":{"line":654,"column":8}}]},"64":{"line":702,"type":"if","locations":[{"start":{"line":657,"column":8},"end":{"line":657,"column":8}},{"start":{"line":657,"column":8},"end":{"line":657,"column":8}}]},"65":{"line":723,"type":"if","locations":[{"start":{"line":677,"column":8},"end":{"line":677,"column":8}},{"start":{"line":677,"column":8},"end":{"line":677,"column":8}}]},"66":{"line":729,"type":"if","locations":[{"start":{"line":683,"column":12},"end":{"line":683,"column":12}},{"start":{"line":683,"column":12},"end":{"line":683,"column":12}}]},"67":{"line":731,"type":"if","locations":[{"start":{"line":685,"column":19},"end":{"line":685,"column":19}},{"start":{"line":685,"column":19},"end":{"line":685,"column":19}}]},"68":{"line":732,"type":"if","locations":[{"start":{"line":686,"column":16},"end":{"line":686,"column":16}},{"start":{"line":686,"column":16},"end":{"line":686,"column":16}}]},"69":{"line":732,"type":"binary-expr","locations":[{"start":{"line":686,"column":20},"end":{"line":686,"column":20}},{"start":{"line":686,"column":28},"end":{"line":686,"column":16}}]},"70":{"line":752,"type":"if","locations":[{"start":{"line":706,"column":12},"end":{"line":706,"column":12}},{"start":{"line":706,"column":12},"end":{"line":706,"column":12}}]},"71":{"line":753,"type":"cond-expr","locations":[{"start":{"line":707,"column":44},"end":{"line":707,"column":37}},{"start":{"line":707,"column":51},"end":{"line":707,"column":16}}]},"72":{"line":760,"type":"if","locations":[{"start":{"line":714,"column":8},"end":{"line":714,"column":8}},{"start":{"line":714,"column":8},"end":{"line":714,"column":8}}]},"73":{"line":763,"type":"cond-expr","locations":[{"start":{"line":717,"column":47},"end":{"line":717,"column":40}},{"start":{"line":717,"column":54},"end":{"line":717,"column":8}}]}},"code":["import {Feature} from '../../feature';","import {","    addClass, removeClass, createCheckItem, createElm, elm, removeElm,","    getText, tag","} from '../../dom';","import {isUndef, EMPTY_FN, isNull} from '../../types';","import {addEvt, targetEvt, removeEvt} from '../../event';","import {root} from '../../root';","import {NONE} from '../../const';","import {","    defaultsBool, defaultsStr, defaultsFn, defaultsNb, defaultsArr","} from '../../settings';","import {RIGHT} from '../../modules/toolbar';","","/**"," * Columns Visibility extension"," */","export default class ColsVisibility extends Feature {","","    /**","     * Creates an instance of ColsVisibility","     * @param {TableFilter} tf TableFilter instance","     * @param {Object} Configuration object","     */","    constructor(tf, f) {","        super(tf, ColsVisibility);","","        // Configuration object","        let cfg = this.config;","","        /**","         * Module name","         * @type {String}","         */","        this.name = f.name;","","        /**","         * Module description","         * @type {String}","         */","        this.desc = defaultsStr(f.description, 'Columns visibility manager');","","        /**","         * show/hide columns container element","         * @private","         */","        this.spanEl = null;","","        /**","         * show/hide columns button element","         * @private","         */","        this.btnEl = null;","","        /**","         * show/hide columns main container element","         * @private","         */","        this.contEl = null;","","        /**","         * Enable tick to hide a column, defaults to true","         * @type {Boolean}","         */","        this.tickToHide = defaultsBool(f.tick_to_hide, true);","","        /**","         * Enable columns manager UI, defaults to true","         * @type {Boolean}","         */","        this.manager = defaultsBool(f.manager, true);","","        /**","         * Headers HTML table reference only if headers are external","         * @type {DOMElement}","         */","        this.headersTbl = f.headers_table || null;","","        /**","         * Headers row index only if headers are external","         * @type {Number}","         */","        this.headersIndex = defaultsNb(f.headers_index, 1);","","        /**","         * ID of main container element","         * @type {String}","         */","        this.contElTgtId = defaultsStr(f.container_target_id, null);","","        /**","         * Alternative text for column headers in column manager UI","         * @type {Array}","         */","        this.headersText = defaultsArr(f.headers_text, []);","","        /**","         * ID of button's container element","         * @type {String}","         */","        this.btnTgtId = defaultsStr(f.btn_target_id, null);","","        /**","         * Button's text, defaults to Columns&#9660;","         * @type {String}","         */","        this.btnText = defaultsStr(f.btn_text, 'Columns&#9660;');","","        /**","         * Button's inner HTML","         * @type {String}","         */","        this.btnHtml = defaultsStr(f.btn_html, null);","","        /**","         * Css class for button","         * @type {String}","         */","        this.btnCssClass = defaultsStr(f.btn_css_class, 'colVis');","","        /**","         * Columns manager UI close link text, defaults to 'Close'","         * @type {String}","         */","        this.btnCloseText = defaultsStr(f.btn_close_text, 'Close');","","        /**","         * Columns manager UI close link HTML","         * @type {String}","         */","        this.btnCloseHtml = defaultsStr(f.btn_close_html, null);","","        /**","         * Css for columns manager UI close link","         * @type {String}","         */","        this.btnCloseCssClass = defaultsStr(f.btn_close_css_class,","            this.btnCssClass);","","        /**","         * Extension's stylesheet filename","         * @type {String}","         */","        this.stylesheet = defaultsStr(f.stylesheet, 'colsVisibility.css');","","        /**","         * Css for columns manager UI span","         * @type {String}","         */","        this.spanCssClass = defaultsStr(f.span_css_class, 'colVisSpan');","","        /**","         * Css for columns manager UI main container","         * @type {String}","         */","        this.contCssClass = defaultsStr(f.cont_css_class, 'colVisCont');","","        /**","         * Css for columns manager UI checklist (ul)","         * @type {String}","         */","        this.listCssClass = defaultsStr(cfg.list_css_class, 'cols_checklist');","","        /**","         * Css for columns manager UI checklist item (li)","         * @type {String}","         */","        this.listItemCssClass = defaultsStr(cfg.checklist_item_css_class,","            'cols_checklist_item');","","        /**","         * Css for columns manager UI checklist item selected state (li)","         * @type {String}","         */","        this.listSlcItemCssClass = defaultsStr(","            cfg.checklist_selected_item_css_class,","            'cols_checklist_slc_item'","        );","","        /**","         * Text preceding the columns list, defaults to 'Hide' or 'Show'","         * depending on tick mode (tick_to_hide option)","         * @type {String}","         */","        this.text = defaultsStr(f.text, this.tickToHide ? 'Hide: ' : 'Show: ');","","        /**","         * List of columns indexes to be hidden at initialization","         * @type {Array}","         */","        this.atStart = defaultsArr(f.at_start, []);","","        /**","         * Enable hover behaviour on columns manager button/link","         * @type {Boolean}","         */","        this.enableHover = Boolean(f.enable_hover);","","        /**","         * Enable select all option, disabled by default","         * @type {Boolean}","         */","        this.enableTickAll = Boolean(f.enable_tick_all);","","        /**","         * Text for select all option, defaults to 'Select all:'","         * @type {String}","         */","        this.tickAllText = defaultsStr(f.tick_all_text, 'Select all:');","","        /**","         * Default position in toolbar ('left'|'center'|'right')","         * @type {String}","         */","        this.toolbarPosition = defaultsStr(f.toolbar_position, RIGHT);","","        /**","         * List of indexes of hidden columns","         * @private","         */","        this.hiddenCols = [];","","        /**","         * Bound mouseup wrapper","         * @private","         */","        this.boundMouseup = null;","","        /**","         * Callback fired when the extension is initialized","         * @type {Function}","         */","        this.onLoaded = defaultsFn(f.on_loaded, EMPTY_FN);","","        /**","         * Callback fired before the columns manager is opened","         * @type {Function}","         */","        this.onBeforeOpen = defaultsFn(f.on_before_open, EMPTY_FN);","","        /**","         * Callback fired after the columns manager is opened","         * @type {Function}","         */","        this.onAfterOpen = defaultsFn(f.on_after_open, EMPTY_FN);","","        /**","         * Callback fired before the columns manager is closed","         * @type {Function}","         */","        this.onBeforeClose = defaultsFn(f.on_before_close, EMPTY_FN);","","        /**","         * Callback fired after the columns manager is closed","         * @type {Function}","         */","        this.onAfterClose = defaultsFn(f.on_after_close, EMPTY_FN);","","        /**","         * Callback fired before a column is hidden","         * @type {Function}","         */","        this.onBeforeColHidden = defaultsFn(f.on_before_col_hidden, EMPTY_FN);","","        /**","         * Callback fired after a column is hidden","         * @type {Function}","         */","        this.onAfterColHidden = defaultsFn(f.on_after_col_hidden, EMPTY_FN);","","        /**","         * Callback fired before a column is displayed","         * @type {Function}","         */","        this.onBeforeColDisplayed = defaultsFn(f.on_before_col_displayed,","            EMPTY_FN);","","        /**","         * Callback fired after a column is displayed","         * @type {Function}","         */","        this.onAfterColDisplayed = defaultsFn(f.on_after_col_displayed,","            EMPTY_FN);","","        //Grid layout support","        if (tf.gridLayout) {","            this.headersTbl = tf.feature('gridLayout').headTbl; //headers table","            this.headersIndex = 0; //headers index","        }","","        //Loads extension stylesheet","        tf.import(f.name + 'Style', tf.getStylePath() + this.stylesheet, null,","            'link');","","        this.enable();","    }","","    /**","     * Mouse-up event handler handling popup auto-close behaviour","     * @private","     */","    onMouseup(evt) {","        let targetElm = targetEvt(evt);","","        while (targetElm && targetElm !== this.contEl","            && targetElm !== this.btnEl) {","            targetElm = targetElm.parentNode;","        }","","        if (targetElm !== this.contEl && targetElm !== this.btnEl) {","            this.toggle();","        }","","        return;","    }","","    /**","     * Toggle columns manager UI","     */","    toggle() {","        // ensure mouseup event handler is removed","        removeEvt(root, 'mouseup', this.boundMouseup);","","        let contDisplay = this.contEl.style.display;","","        if (contDisplay !== 'inline') {","            this.onBeforeOpen(this);","        }","        if (contDisplay === 'inline') {","            this.onBeforeClose(this);","        }","","        this.contEl.style.display = contDisplay === 'inline' ?","            NONE : 'inline';","","        if (contDisplay !== 'inline') {","            this.onAfterOpen(this);","            addEvt(root, 'mouseup', this.boundMouseup);","        }","        if (contDisplay === 'inline') {","            this.onAfterClose(this);","        }","    }","","    /**","     * Check an item in columns manager UI","     * @private","     */","    checkItem(lbl) {","        let li = lbl.parentNode;","        if (!li || !lbl) {","            return;","        }","        let isChecked = lbl.firstChild.checked;","        let colIndex = lbl.firstChild.getAttribute('id').split('_')[1];","        colIndex = parseInt(colIndex, 10);","        if (isChecked) {","            addClass(li, this.listSlcItemCssClass);","        } else {","            removeClass(li, this.listSlcItemCssClass);","        }","","        let hide = false;","        if ((this.tickToHide && isChecked) ||","            (!this.tickToHide && !isChecked)) {","            hide = true;","        }","        this.setHidden(colIndex, hide);","    }","","    /**","     * Initializes ColsVisibility instance","     */","    init() {","        if (this.initialized || !this.manager) {","            return;","        }","","        this.emitter.emit('initializing-extension', this,","            !isNull(this.btnTgtId));","","        this.emitter.on(['hide-column'],","            (tf, colIndex) => this.hideCol(colIndex));","","        this.buildBtn();","        this.buildManager();","","        /** @inherited */","        this.initialized = true;","","        this.boundMouseup = this.onMouseup.bind(this);","","        this.emitter.emit('columns-visibility-initialized', this.tf, this);","        this.emitter.emit('extension-initialized', this);","","        // Hide columns at start at very end of initialization, do not move","        // as order is important","        this._hideAtStart();","    }","","    /**","     * Build main button UI","     */","    buildBtn() {","        if (this.btnEl) {","            return;","        }","        let tf = this.tf;","        let span = createElm('span');","        span.className = this.spanCssClass;","","        // Container element (rdiv or custom element)","        let targetEl = !this.btnTgtId ?","            tf.feature('toolbar').container(this.toolbarPosition) :","            elm(this.btnTgtId);","","        if (!this.btnTgtId) {","            let firstChild = targetEl.firstChild;","            firstChild.parentNode.insertBefore(span, firstChild);","        } else {","            targetEl.appendChild(span);","        }","","        if (!this.btnHtml) {","            let btn = createElm('a', ['href', 'javascript:;']);","            btn.className = this.btnCssClass;","            btn.title = this.desc;","","            btn.innerHTML = this.btnText;","            span.appendChild(btn);","            if (!this.enableHover) {","                addEvt(btn, 'click', (evt) => this.toggle(evt));","            } else {","                addEvt(btn, 'mouseover', (evt) => this.toggle(evt));","            }","        } else { // Custom html","            span.innerHTML = this.btnHtml;","            let colVisEl = span.firstChild;","            if (!this.enableHover) {","                addEvt(colVisEl, 'click', (evt) => this.toggle(evt));","            } else {","                addEvt(colVisEl, 'mouseover', (evt) => this.toggle(evt));","            }","        }","","        this.spanEl = span;","        this.btnEl = this.spanEl.firstChild;","","        this.onLoaded(this);","    }","","    /**","     * Build columns manager UI","     */","    buildManager() {","        let tf = this.tf;","","        let container = !this.contElTgtId ?","            createElm('div') :","            elm(this.contElTgtId);","        container.className = this.contCssClass;","","        //Extension description","        let extNameLabel = createElm('p');","        extNameLabel.innerHTML = this.text;","        container.appendChild(extNameLabel);","","        //Headers list","        let ul = createElm('ul');","        ul.className = this.listCssClass;","","        let tbl = this.headersTbl || tf.dom();","        let headerIndex = this.headersTbl ?","            this.headersIndex : tf.getHeadersRowIndex();","        let headerRow = tbl.rows[headerIndex];","","        //Tick all option","        if (this.enableTickAll) {","            let li = createCheckItem('col__' + tf.id, this.tickAllText,","                this.tickAllText);","            addClass(li, this.listItemCssClass);","            ul.appendChild(li);","            li.check.checked = !this.tickToHide;","","            addEvt(li.check, 'click', () => {","                for (let h = 0; h < headerRow.cells.length; h++) {","                    let itm = elm('col_' + h + '_' + tf.id);","                    if (itm && li.check.checked !== itm.checked) {","                        itm.click();","                        itm.checked = li.check.checked;","                    }","                }","            });","        }","","        for (let i = 0; i < headerRow.cells.length; i++) {","            let cell = headerRow.cells[i];","            let cellText = this.headersText[i] || this._getHeaderText(cell);","            let liElm = createCheckItem('col_' + i + '_' + tf.id, cellText,","                cellText);","            addClass(liElm, this.listItemCssClass);","            if (!this.tickToHide) {","                addClass(liElm, this.listSlcItemCssClass);","            }","            ul.appendChild(liElm);","            if (!this.tickToHide) {","                liElm.check.checked = true;","            }","","            addEvt(liElm.check, 'click', (evt) => {","                let elm = targetEvt(evt);","                let lbl = elm.parentNode;","                this.checkItem(lbl);","            });","        }","","        //separator","        let p = createElm('p', ['align', 'center']);","        let btn;","        //Close link","        if (!this.btnCloseHtml) {","            btn = createElm('a', ['href', 'javascript:;']);","            btn.className = this.btnCloseCssClass;","            btn.innerHTML = this.btnCloseText;","            addEvt(btn, 'click', (evt) => this.toggle(evt));","            p.appendChild(btn);","        } else {","            p.innerHTML = this.btnCloseHtml;","            btn = p.firstChild;","            addEvt(btn, 'click', (evt) => this.toggle(evt));","        }","","        container.appendChild(ul);","        container.appendChild(p);","","        this.btnEl.parentNode.insertBefore(container, this.btnEl);","        this.contEl = container;","    }","","    /**","     * Hide or show specified columns","     * @param {Number} colIndex Column index","     * @param {Boolean} hide    Hide column if true or show if false","     */","    setHidden(colIndex, hide) {","        let tf = this.tf;","        let tbl = tf.dom();","","        if (hide) {","            this.onBeforeColHidden(this, colIndex);","        } else {","            this.onBeforeColDisplayed(this, colIndex);","        }","","        this._hideElements(tbl, colIndex, hide);","        if (this.headersTbl) {","            this._hideElements(this.headersTbl, colIndex, hide);","        }","","        let hiddenCols = this.hiddenCols;","        let itemIndex = hiddenCols.indexOf(colIndex);","        if (hide) {","            if (itemIndex === -1) {","                this.hiddenCols.push(colIndex);","            }","        } else {","            if (itemIndex !== -1) {","                this.hiddenCols.splice(itemIndex, 1);","            }","        }","","        if (hide) {","            this.onAfterColHidden(this, colIndex);","            this.emitter.emit('column-hidden', tf, this, colIndex,","                this.hiddenCols);","        } else {","            this.onAfterColDisplayed(this, colIndex);","            this.emitter.emit('column-shown', tf, this, colIndex,","                this.hiddenCols);","        }","    }","","    /**","     * Show specified column","     * @param  {Number} colIndex Column index","     */","    showCol(colIndex) {","        if (isUndef(colIndex) || !this.isColHidden(colIndex)) {","            return;","        }","        if (this.manager && this.contEl) {","            let itm = elm('col_' + colIndex + '_' + this.tf.id);","            if (itm) {","                itm.click();","            }","        } else {","            this.setHidden(colIndex, false);","        }","    }","","    /**","     * Hide specified column","     * @param  {Number} colIndex Column index","     */","    hideCol(colIndex) {","        if (isUndef(colIndex) || this.isColHidden(colIndex)) {","            return;","        }","        if (this.manager && this.contEl) {","            let itm = elm('col_' + colIndex + '_' + this.tf.id);","            if (itm) {","                itm.click();","            }","        } else {","            this.setHidden(colIndex, true);","        }","    }","","    /**","     * Determine if specified column is hidden","     * @param  {Number} colIndex Column index","     */","    isColHidden(colIndex) {","        if (this.hiddenCols.indexOf(colIndex) !== -1) {","            return true;","        }","        return false;","    }","","    /**","     * Toggle visibility of specified column","     * @param  {Number} colIndex Column index","     */","    toggleCol(colIndex) {","        if (isUndef(colIndex) || this.isColHidden(colIndex)) {","            this.showCol(colIndex);","        } else {","            this.hideCol(colIndex);","        }","    }","","    /**","     * Return the indexes of the columns currently hidden","     * @return {Array} column indexes","     */","    getHiddenCols() {","        return this.hiddenCols;","    }","","    /**","     * Remove the columns manager","     */","    destroy() {","        if (!this.initialized) {","            return;","        }","        if (elm(this.contElTgtId)) {","            elm(this.contElTgtId).innerHTML = '';","        } else {","            this.contEl.innerHTML = '';","            removeElm(this.contEl);","            this.contEl = null;","        }","        this.btnEl.innerHTML = '';","        removeElm(this.btnEl);","        this.btnEl = null;","","        this.emitter.off(['hide-column'],","            (tf, colIndex) => this.hideCol(colIndex));","","        this.boundMouseup = null;","","        this.initialized = false;","    }","","    _getHeaderText(cell) {","        if (!cell.hasChildNodes) {","            return '';","        }","","        for (let i = 0; i < cell.childNodes.length; i++) {","            let n = cell.childNodes[i];","            if (n.nodeType === 3) {","                return n.nodeValue;","            } else if (n.nodeType === 1) {","                if (n.id && n.id.indexOf('popUp') !== -1) {","                    continue;","                } else {","                    return getText(n);","                }","            }","            continue;","        }","        return '';","    }","","    _hideElements(tbl, colIdx, hide) {","        this._hideCells(tbl, colIdx, hide);","        this._hideCol(tbl, colIdx, hide);","    }","","    _hideCells(tbl, colIdx, hide) {","        for (let i = 0; i < tbl.rows.length; i++) {","            let row = tbl.rows[i];","            let cell = row.cells[colIdx];","            if (cell) {","                cell.style.display = hide ? NONE : '';","            }","        }","    }","","    _hideCol(tbl, colIdx, hide) {","        let colElms = tag(tbl, 'col');","        if (colElms.length === 0) {","            return;","        }","        colElms[colIdx].style.display = hide ? NONE : '';","    }","","    _hideAtStart() {","        this.atStart.forEach((colIdx) => {","            this.hideCol(colIdx);","        });","    }","}",""]};
}
__cov_o8lZ1tV3qvmAZwNRQYMKAA = __cov_o8lZ1tV3qvmAZwNRQYMKAA['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\colsVisibility\\colsVisibility.js'];
__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['1']++;Object.defineProperty(exports,'__esModule',{value:true});__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['2']++;var _feature=__webpack_require__(/*! ../../feature */ "./src/feature.js");__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['3']++;var _dom=__webpack_require__(/*! ../../dom */ "./src/dom.js");__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['4']++;var _types=__webpack_require__(/*! ../../types */ "./src/types.js");__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['5']++;var _event=__webpack_require__(/*! ../../event */ "./src/event.js");__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['6']++;var _root=__webpack_require__(/*! ../../root */ "./src/root.js");__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['7']++;var _const=__webpack_require__(/*! ../../const */ "./src/const.js");__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['8']++;var _settings=__webpack_require__(/*! ../../settings */ "./src/settings.js");__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['9']++;var _toolbar=__webpack_require__(/*! ../../modules/toolbar */ "./src/modules/toolbar.js");function _classCallCheck(instance,Constructor){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['1']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['11']++;if(!(instance instanceof Constructor)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['1'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['12']++;throw new TypeError('Cannot call a class as a function');}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['1'][1]++;}}function _possibleConstructorReturn(self,call){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['2']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['14']++;if(!self){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['2'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['15']++;throw new ReferenceError('this hasn\'t been initialised - super() hasn\'t been called');}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['2'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['16']++;return(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['4'][0]++,call)&&((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['4'][1]++,typeof call==='object')||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['4'][2]++,typeof call==='function'))?(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['3'][0]++,call):(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['3'][1]++,self);}function _inherits(subClass,superClass){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['3']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['18']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['6'][0]++,typeof superClass!=='function')&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['6'][1]++,superClass!==null)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['5'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['19']++;throw new TypeError('Super expression must either be null or a function, not '+typeof superClass);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['5'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['20']++;subClass.prototype=Object.create((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['7'][0]++,superClass)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['7'][1]++,superClass.prototype),{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['21']++;if(superClass){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['8'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['22']++;Object.setPrototypeOf?(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['9'][0]++,Object.setPrototypeOf(subClass,superClass)):(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['9'][1]++,subClass.__proto__=superClass);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['8'][1]++;}}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['23']++;var ColsVisibility=function(_Feature){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['4']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['24']++;_inherits(ColsVisibility,_Feature);function ColsVisibility(tf,f){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['5']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['26']++;_classCallCheck(this,ColsVisibility);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['27']++;var _this=_possibleConstructorReturn(this,_Feature.call(this,tf,ColsVisibility));__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['28']++;var cfg=_this.config;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['29']++;_this.name=f.name;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['30']++;_this.desc=(0,_settings.defaultsStr)(f.description,'Columns visibility manager');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['31']++;_this.spanEl=null;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['32']++;_this.btnEl=null;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['33']++;_this.contEl=null;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['34']++;_this.tickToHide=(0,_settings.defaultsBool)(f.tick_to_hide,true);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['35']++;_this.manager=(0,_settings.defaultsBool)(f.manager,true);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['36']++;_this.headersTbl=(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['10'][0]++,f.headers_table)||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['10'][1]++,null);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['37']++;_this.headersIndex=(0,_settings.defaultsNb)(f.headers_index,1);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['38']++;_this.contElTgtId=(0,_settings.defaultsStr)(f.container_target_id,null);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['39']++;_this.headersText=(0,_settings.defaultsArr)(f.headers_text,[]);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['40']++;_this.btnTgtId=(0,_settings.defaultsStr)(f.btn_target_id,null);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['41']++;_this.btnText=(0,_settings.defaultsStr)(f.btn_text,'Columns&#9660;');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['42']++;_this.btnHtml=(0,_settings.defaultsStr)(f.btn_html,null);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['43']++;_this.btnCssClass=(0,_settings.defaultsStr)(f.btn_css_class,'colVis');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['44']++;_this.btnCloseText=(0,_settings.defaultsStr)(f.btn_close_text,'Close');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['45']++;_this.btnCloseHtml=(0,_settings.defaultsStr)(f.btn_close_html,null);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['46']++;_this.btnCloseCssClass=(0,_settings.defaultsStr)(f.btn_close_css_class,_this.btnCssClass);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['47']++;_this.stylesheet=(0,_settings.defaultsStr)(f.stylesheet,'colsVisibility.css');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['48']++;_this.spanCssClass=(0,_settings.defaultsStr)(f.span_css_class,'colVisSpan');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['49']++;_this.contCssClass=(0,_settings.defaultsStr)(f.cont_css_class,'colVisCont');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['50']++;_this.listCssClass=(0,_settings.defaultsStr)(cfg.list_css_class,'cols_checklist');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['51']++;_this.listItemCssClass=(0,_settings.defaultsStr)(cfg.checklist_item_css_class,'cols_checklist_item');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['52']++;_this.listSlcItemCssClass=(0,_settings.defaultsStr)(cfg.checklist_selected_item_css_class,'cols_checklist_slc_item');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['53']++;_this.text=(0,_settings.defaultsStr)(f.text,_this.tickToHide?(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['11'][0]++,'Hide: '):(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['11'][1]++,'Show: '));__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['54']++;_this.atStart=(0,_settings.defaultsArr)(f.at_start,[]);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['55']++;_this.enableHover=Boolean(f.enable_hover);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['56']++;_this.enableTickAll=Boolean(f.enable_tick_all);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['57']++;_this.tickAllText=(0,_settings.defaultsStr)(f.tick_all_text,'Select all:');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['58']++;_this.toolbarPosition=(0,_settings.defaultsStr)(f.toolbar_position,_toolbar.RIGHT);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['59']++;_this.hiddenCols=[];__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['60']++;_this.boundMouseup=null;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['61']++;_this.onLoaded=(0,_settings.defaultsFn)(f.on_loaded,_types.EMPTY_FN);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['62']++;_this.onBeforeOpen=(0,_settings.defaultsFn)(f.on_before_open,_types.EMPTY_FN);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['63']++;_this.onAfterOpen=(0,_settings.defaultsFn)(f.on_after_open,_types.EMPTY_FN);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['64']++;_this.onBeforeClose=(0,_settings.defaultsFn)(f.on_before_close,_types.EMPTY_FN);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['65']++;_this.onAfterClose=(0,_settings.defaultsFn)(f.on_after_close,_types.EMPTY_FN);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['66']++;_this.onBeforeColHidden=(0,_settings.defaultsFn)(f.on_before_col_hidden,_types.EMPTY_FN);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['67']++;_this.onAfterColHidden=(0,_settings.defaultsFn)(f.on_after_col_hidden,_types.EMPTY_FN);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['68']++;_this.onBeforeColDisplayed=(0,_settings.defaultsFn)(f.on_before_col_displayed,_types.EMPTY_FN);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['69']++;_this.onAfterColDisplayed=(0,_settings.defaultsFn)(f.on_after_col_displayed,_types.EMPTY_FN);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['70']++;if(tf.gridLayout){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['12'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['71']++;_this.headersTbl=tf.feature('gridLayout').headTbl;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['72']++;_this.headersIndex=0;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['12'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['73']++;tf.import(f.name+'Style',tf.getStylePath()+_this.stylesheet,null,'link');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['74']++;_this.enable();__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['75']++;return _this;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['76']++;ColsVisibility.prototype.onMouseup=function onMouseup(evt){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['6']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['77']++;var targetElm=(0,_event.targetEvt)(evt);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['78']++;while((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['13'][0]++,targetElm)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['13'][1]++,targetElm!==this.contEl)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['13'][2]++,targetElm!==this.btnEl)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['79']++;targetElm=targetElm.parentNode;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['80']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['15'][0]++,targetElm!==this.contEl)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['15'][1]++,targetElm!==this.btnEl)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['14'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['81']++;this.toggle();}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['14'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['82']++;return;};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['83']++;ColsVisibility.prototype.toggle=function toggle(){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['7']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['84']++;(0,_event.removeEvt)(_root.root,'mouseup',this.boundMouseup);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['85']++;var contDisplay=this.contEl.style.display;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['86']++;if(contDisplay!=='inline'){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['16'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['87']++;this.onBeforeOpen(this);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['16'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['88']++;if(contDisplay==='inline'){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['17'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['89']++;this.onBeforeClose(this);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['17'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['90']++;this.contEl.style.display=contDisplay==='inline'?(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['18'][0]++,_const.NONE):(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['18'][1]++,'inline');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['91']++;if(contDisplay!=='inline'){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['19'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['92']++;this.onAfterOpen(this);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['93']++;(0,_event.addEvt)(_root.root,'mouseup',this.boundMouseup);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['19'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['94']++;if(contDisplay==='inline'){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['20'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['95']++;this.onAfterClose(this);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['20'][1]++;}};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['96']++;ColsVisibility.prototype.checkItem=function checkItem(lbl){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['8']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['97']++;var li=lbl.parentNode;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['98']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['22'][0]++,!li)||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['22'][1]++,!lbl)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['21'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['99']++;return;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['21'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['100']++;var isChecked=lbl.firstChild.checked;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['101']++;var colIndex=lbl.firstChild.getAttribute('id').split('_')[1];__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['102']++;colIndex=parseInt(colIndex,10);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['103']++;if(isChecked){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['23'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['104']++;(0,_dom.addClass)(li,this.listSlcItemCssClass);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['23'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['105']++;(0,_dom.removeClass)(li,this.listSlcItemCssClass);}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['106']++;var hide=false;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['107']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['25'][0]++,this.tickToHide)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['25'][1]++,isChecked)||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['25'][2]++,!this.tickToHide)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['25'][3]++,!isChecked)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['24'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['108']++;hide=true;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['24'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['109']++;this.setHidden(colIndex,hide);};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['110']++;ColsVisibility.prototype.init=function init(){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['9']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['111']++;var _this2=this;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['112']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['27'][0]++,this.initialized)||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['27'][1]++,!this.manager)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['26'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['113']++;return;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['26'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['114']++;this.emitter.emit('initializing-extension',this,!(0,_types.isNull)(this.btnTgtId));__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['115']++;this.emitter.on(['hide-column'],function(tf,colIndex){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['10']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['116']++;return _this2.hideCol(colIndex);});__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['117']++;this.buildBtn();__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['118']++;this.buildManager();__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['119']++;this.initialized=true;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['120']++;this.boundMouseup=this.onMouseup.bind(this);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['121']++;this.emitter.emit('columns-visibility-initialized',this.tf,this);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['122']++;this.emitter.emit('extension-initialized',this);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['123']++;this._hideAtStart();};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['124']++;ColsVisibility.prototype.buildBtn=function buildBtn(){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['11']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['125']++;var _this3=this;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['126']++;if(this.btnEl){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['28'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['127']++;return;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['28'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['128']++;var tf=this.tf;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['129']++;var span=(0,_dom.createElm)('span');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['130']++;span.className=this.spanCssClass;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['131']++;var targetEl=!this.btnTgtId?(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['29'][0]++,tf.feature('toolbar').container(this.toolbarPosition)):(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['29'][1]++,(0,_dom.elm)(this.btnTgtId));__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['132']++;if(!this.btnTgtId){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['30'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['133']++;var firstChild=targetEl.firstChild;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['134']++;firstChild.parentNode.insertBefore(span,firstChild);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['30'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['135']++;targetEl.appendChild(span);}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['136']++;if(!this.btnHtml){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['31'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['137']++;var btn=(0,_dom.createElm)('a',['href','javascript:;']);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['138']++;btn.className=this.btnCssClass;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['139']++;btn.title=this.desc;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['140']++;btn.innerHTML=this.btnText;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['141']++;span.appendChild(btn);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['142']++;if(!this.enableHover){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['32'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['143']++;(0,_event.addEvt)(btn,'click',function(evt){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['12']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['144']++;return _this3.toggle(evt);});}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['32'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['145']++;(0,_event.addEvt)(btn,'mouseover',function(evt){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['13']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['146']++;return _this3.toggle(evt);});}}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['31'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['147']++;span.innerHTML=this.btnHtml;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['148']++;var colVisEl=span.firstChild;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['149']++;if(!this.enableHover){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['33'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['150']++;(0,_event.addEvt)(colVisEl,'click',function(evt){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['14']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['151']++;return _this3.toggle(evt);});}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['33'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['152']++;(0,_event.addEvt)(colVisEl,'mouseover',function(evt){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['15']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['153']++;return _this3.toggle(evt);});}}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['154']++;this.spanEl=span;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['155']++;this.btnEl=this.spanEl.firstChild;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['156']++;this.onLoaded(this);};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['157']++;ColsVisibility.prototype.buildManager=function buildManager(){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['16']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['158']++;var _this4=this;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['159']++;var tf=this.tf;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['160']++;var container=!this.contElTgtId?(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['34'][0]++,(0,_dom.createElm)('div')):(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['34'][1]++,(0,_dom.elm)(this.contElTgtId));__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['161']++;container.className=this.contCssClass;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['162']++;var extNameLabel=(0,_dom.createElm)('p');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['163']++;extNameLabel.innerHTML=this.text;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['164']++;container.appendChild(extNameLabel);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['165']++;var ul=(0,_dom.createElm)('ul');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['166']++;ul.className=this.listCssClass;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['167']++;var tbl=(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['35'][0]++,this.headersTbl)||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['35'][1]++,tf.dom());__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['168']++;var headerIndex=this.headersTbl?(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['36'][0]++,this.headersIndex):(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['36'][1]++,tf.getHeadersRowIndex());__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['169']++;var headerRow=tbl.rows[headerIndex];__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['170']++;if(this.enableTickAll){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['37'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['171']++;var li=(0,_dom.createCheckItem)('col__'+tf.id,this.tickAllText,this.tickAllText);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['172']++;(0,_dom.addClass)(li,this.listItemCssClass);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['173']++;ul.appendChild(li);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['174']++;li.check.checked=!this.tickToHide;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['175']++;(0,_event.addEvt)(li.check,'click',function(){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['17']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['176']++;for(var h=0;h<headerRow.cells.length;h++){__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['177']++;var itm=(0,_dom.elm)('col_'+h+'_'+tf.id);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['178']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['39'][0]++,itm)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['39'][1]++,li.check.checked!==itm.checked)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['38'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['179']++;itm.click();__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['180']++;itm.checked=li.check.checked;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['38'][1]++;}}});}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['37'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['181']++;for(var i=0;i<headerRow.cells.length;i++){__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['182']++;var cell=headerRow.cells[i];__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['183']++;var cellText=(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['40'][0]++,this.headersText[i])||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['40'][1]++,this._getHeaderText(cell));__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['184']++;var liElm=(0,_dom.createCheckItem)('col_'+i+'_'+tf.id,cellText,cellText);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['185']++;(0,_dom.addClass)(liElm,this.listItemCssClass);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['186']++;if(!this.tickToHide){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['41'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['187']++;(0,_dom.addClass)(liElm,this.listSlcItemCssClass);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['41'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['188']++;ul.appendChild(liElm);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['189']++;if(!this.tickToHide){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['42'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['190']++;liElm.check.checked=true;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['42'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['191']++;(0,_event.addEvt)(liElm.check,'click',function(evt){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['18']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['192']++;var elm=(0,_event.targetEvt)(evt);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['193']++;var lbl=elm.parentNode;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['194']++;_this4.checkItem(lbl);});}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['195']++;var p=(0,_dom.createElm)('p',['align','center']);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['196']++;var btn=void 0;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['197']++;if(!this.btnCloseHtml){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['43'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['198']++;btn=(0,_dom.createElm)('a',['href','javascript:;']);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['199']++;btn.className=this.btnCloseCssClass;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['200']++;btn.innerHTML=this.btnCloseText;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['201']++;(0,_event.addEvt)(btn,'click',function(evt){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['19']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['202']++;return _this4.toggle(evt);});__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['203']++;p.appendChild(btn);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['43'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['204']++;p.innerHTML=this.btnCloseHtml;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['205']++;btn=p.firstChild;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['206']++;(0,_event.addEvt)(btn,'click',function(evt){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['20']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['207']++;return _this4.toggle(evt);});}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['208']++;container.appendChild(ul);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['209']++;container.appendChild(p);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['210']++;this.btnEl.parentNode.insertBefore(container,this.btnEl);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['211']++;this.contEl=container;};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['212']++;ColsVisibility.prototype.setHidden=function setHidden(colIndex,hide){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['21']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['213']++;var tf=this.tf;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['214']++;var tbl=tf.dom();__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['215']++;if(hide){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['44'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['216']++;this.onBeforeColHidden(this,colIndex);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['44'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['217']++;this.onBeforeColDisplayed(this,colIndex);}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['218']++;this._hideElements(tbl,colIndex,hide);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['219']++;if(this.headersTbl){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['45'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['220']++;this._hideElements(this.headersTbl,colIndex,hide);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['45'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['221']++;var hiddenCols=this.hiddenCols;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['222']++;var itemIndex=hiddenCols.indexOf(colIndex);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['223']++;if(hide){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['46'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['224']++;if(itemIndex===-1){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['47'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['225']++;this.hiddenCols.push(colIndex);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['47'][1]++;}}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['46'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['226']++;if(itemIndex!==-1){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['48'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['227']++;this.hiddenCols.splice(itemIndex,1);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['48'][1]++;}}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['228']++;if(hide){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['49'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['229']++;this.onAfterColHidden(this,colIndex);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['230']++;this.emitter.emit('column-hidden',tf,this,colIndex,this.hiddenCols);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['49'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['231']++;this.onAfterColDisplayed(this,colIndex);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['232']++;this.emitter.emit('column-shown',tf,this,colIndex,this.hiddenCols);}};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['233']++;ColsVisibility.prototype.showCol=function showCol(colIndex){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['22']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['234']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['51'][0]++,(0,_types.isUndef)(colIndex))||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['51'][1]++,!this.isColHidden(colIndex))){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['50'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['235']++;return;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['50'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['236']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['53'][0]++,this.manager)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['53'][1]++,this.contEl)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['52'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['237']++;var itm=(0,_dom.elm)('col_'+colIndex+'_'+this.tf.id);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['238']++;if(itm){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['54'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['239']++;itm.click();}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['54'][1]++;}}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['52'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['240']++;this.setHidden(colIndex,false);}};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['241']++;ColsVisibility.prototype.hideCol=function hideCol(colIndex){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['23']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['242']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['56'][0]++,(0,_types.isUndef)(colIndex))||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['56'][1]++,this.isColHidden(colIndex))){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['55'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['243']++;return;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['55'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['244']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['58'][0]++,this.manager)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['58'][1]++,this.contEl)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['57'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['245']++;var itm=(0,_dom.elm)('col_'+colIndex+'_'+this.tf.id);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['246']++;if(itm){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['59'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['247']++;itm.click();}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['59'][1]++;}}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['57'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['248']++;this.setHidden(colIndex,true);}};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['249']++;ColsVisibility.prototype.isColHidden=function isColHidden(colIndex){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['24']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['250']++;if(this.hiddenCols.indexOf(colIndex)!==-1){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['60'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['251']++;return true;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['60'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['252']++;return false;};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['253']++;ColsVisibility.prototype.toggleCol=function toggleCol(colIndex){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['25']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['254']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['62'][0]++,(0,_types.isUndef)(colIndex))||(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['62'][1]++,this.isColHidden(colIndex))){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['61'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['255']++;this.showCol(colIndex);}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['61'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['256']++;this.hideCol(colIndex);}};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['257']++;ColsVisibility.prototype.getHiddenCols=function getHiddenCols(){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['26']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['258']++;return this.hiddenCols;};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['259']++;ColsVisibility.prototype.destroy=function destroy(){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['27']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['260']++;var _this5=this;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['261']++;if(!this.initialized){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['63'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['262']++;return;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['63'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['263']++;if((0,_dom.elm)(this.contElTgtId)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['64'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['264']++;(0,_dom.elm)(this.contElTgtId).innerHTML='';}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['64'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['265']++;this.contEl.innerHTML='';__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['266']++;(0,_dom.removeElm)(this.contEl);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['267']++;this.contEl=null;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['268']++;this.btnEl.innerHTML='';__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['269']++;(0,_dom.removeElm)(this.btnEl);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['270']++;this.btnEl=null;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['271']++;this.emitter.off(['hide-column'],function(tf,colIndex){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['28']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['272']++;return _this5.hideCol(colIndex);});__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['273']++;this.boundMouseup=null;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['274']++;this.initialized=false;};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['275']++;ColsVisibility.prototype._getHeaderText=function _getHeaderText(cell){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['29']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['276']++;if(!cell.hasChildNodes){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['65'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['277']++;return'';}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['65'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['278']++;for(var i=0;i<cell.childNodes.length;i++){__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['279']++;var n=cell.childNodes[i];__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['280']++;if(n.nodeType===3){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['66'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['281']++;return n.nodeValue;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['66'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['282']++;if(n.nodeType===1){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['67'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['283']++;if((__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['69'][0]++,n.id)&&(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['69'][1]++,n.id.indexOf('popUp')!==-1)){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['68'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['284']++;continue;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['68'][1]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['285']++;return(0,_dom.getText)(n);}}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['67'][1]++;}}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['286']++;continue;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['287']++;return'';};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['288']++;ColsVisibility.prototype._hideElements=function _hideElements(tbl,colIdx,hide){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['30']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['289']++;this._hideCells(tbl,colIdx,hide);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['290']++;this._hideCol(tbl,colIdx,hide);};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['291']++;ColsVisibility.prototype._hideCells=function _hideCells(tbl,colIdx,hide){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['31']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['292']++;for(var i=0;i<tbl.rows.length;i++){__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['293']++;var row=tbl.rows[i];__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['294']++;var cell=row.cells[colIdx];__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['295']++;if(cell){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['70'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['296']++;cell.style.display=hide?(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['71'][0]++,_const.NONE):(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['71'][1]++,'');}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['70'][1]++;}}};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['297']++;ColsVisibility.prototype._hideCol=function _hideCol(tbl,colIdx,hide){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['32']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['298']++;var colElms=(0,_dom.tag)(tbl,'col');__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['299']++;if(colElms.length===0){__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['72'][0]++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['300']++;return;}else{__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['72'][1]++;}__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['301']++;colElms[colIdx].style.display=hide?(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['73'][0]++,_const.NONE):(__cov_o8lZ1tV3qvmAZwNRQYMKAA.b['73'][1]++,'');};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['302']++;ColsVisibility.prototype._hideAtStart=function _hideAtStart(){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['33']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['303']++;var _this6=this;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['304']++;this.atStart.forEach(function(colIdx){__cov_o8lZ1tV3qvmAZwNRQYMKAA.f['34']++;__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['305']++;_this6.hideCol(colIdx);});};__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['306']++;return ColsVisibility;}(_feature.Feature);__cov_o8lZ1tV3qvmAZwNRQYMKAA.s['307']++;exports.default=ColsVisibility;


/***/ }),

/***/ "./src/extensions/filtersVisibility/filtersVisibility.js":
/*!***************************************************************!*\
  !*** ./src/extensions/filtersVisibility/filtersVisibility.js ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __cov_Qo4iAdus5GVvl_gjC_68lA = (Function('return this'))();
if (!__cov_Qo4iAdus5GVvl_gjC_68lA.__coverage__) { __cov_Qo4iAdus5GVvl_gjC_68lA.__coverage__ = {}; }
__cov_Qo4iAdus5GVvl_gjC_68lA = __cov_Qo4iAdus5GVvl_gjC_68lA.__coverage__;
if (!(__cov_Qo4iAdus5GVvl_gjC_68lA['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\filtersVisibility\\filtersVisibility.js'])) {
   __cov_Qo4iAdus5GVvl_gjC_68lA['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\filtersVisibility\\filtersVisibility.js'] = {"path":"C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\filtersVisibility\\filtersVisibility.js","s":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":0,"8":1,"9":0,"10":0,"11":1,"12":0,"13":0,"14":0,"15":1,"16":0,"17":0,"18":0,"19":0,"20":0,"21":0,"22":0,"23":1,"24":0,"25":0,"26":0,"27":0,"28":0,"29":0,"30":0,"31":0,"32":0,"33":0,"34":0,"35":0,"36":0,"37":0,"38":0,"39":0,"40":0,"41":0,"42":0,"43":0,"44":0,"45":0,"46":0,"47":0,"48":0,"49":0,"50":0,"51":0,"52":0,"53":0,"54":0,"55":0,"56":0,"57":0,"58":0,"59":0,"60":0,"61":0,"62":0,"63":0,"64":0,"65":0,"66":0,"67":0,"68":0,"69":0,"70":0,"71":0,"72":0,"73":0,"74":0,"75":0,"76":0,"77":0,"78":0,"79":0,"80":0,"81":0,"82":0,"83":0,"84":0,"85":0,"86":0,"87":0,"88":0,"89":0,"90":0,"91":0,"92":0,"93":0,"94":0,"95":0,"96":0,"97":0,"98":0,"99":0,"100":0,"101":0,"102":0,"103":0,"104":0,"105":0,"106":0,"107":0,"108":0,"109":0,"110":0,"111":0,"112":0,"113":0,"114":0,"115":0,"116":0,"117":0,"118":0,"119":0,"120":0,"121":0,"122":0,"123":0,"124":0,"125":0,"126":0,"127":0},"b":{"1":[0,0],"2":[0,0],"3":[0,0],"4":[0,0,0],"5":[0,0],"6":[0,0],"7":[0,0],"8":[0,0],"9":[0,0],"10":[0,0],"11":[0,0],"12":[0,0],"13":[0,0],"14":[0,0],"15":[0,0],"16":[0,0],"17":[0,0],"18":[0,0],"19":[0,0],"20":[0,0],"21":[0,0],"22":[0,0],"23":[0,0],"24":[0,0],"25":[0,0],"26":[0,0],"27":[0,0],"28":[0,0],"29":[0,0],"30":[0,0],"31":[0,0],"32":[0,0],"33":[0,0]},"f":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":0,"8":0,"9":0,"10":0,"11":0,"12":0,"13":0},"fnMap":{"1":{"name":"_classCallCheck","line":19,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"2":{"name":"_possibleConstructorReturn","line":21,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"3":{"name":"_inherits","line":23,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"4":{"name":"(anonymous_4)","line":28,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"5":{"name":"FiltersVisibility","line":36,"loc":{"start":{"line":20,"column":4},"end":{"line":20,"column":23}}},"6":{"name":"init","line":203,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"7":{"name":"(anonymous_7)","line":217,"loc":{"start":{"line":204,"column":42},"end":{"line":204,"column":42}}},"8":{"name":"buildUI","line":229,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"9":{"name":"(anonymous_9)","line":259,"loc":{"start":{"line":241,"column":29},"end":{"line":241,"column":29}}},"10":{"name":"toggle","line":276,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"11":{"name":"show","line":292,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"12":{"name":"destroy","line":326,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"13":{"name":"(anonymous_13)","line":333,"loc":{"start":{"line":304,"column":43},"end":{"line":304,"column":43}}}},"statementMap":{"1":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"2":{"start":{"line":1,"column":0},"end":{"line":1,"column":0}},"3":{"start":{"line":2,"column":0},"end":{"line":2,"column":0}},"4":{"start":{"line":3,"column":0},"end":{"line":3,"column":0}},"5":{"start":{"line":4,"column":0},"end":{"line":4,"column":0}},"6":{"start":{"line":5,"column":0},"end":{"line":5,"column":0}},"7":{"start":{"line":8,"column":0},"end":{"line":8,"column":0}},"8":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"9":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"10":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"11":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"12":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"13":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"14":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"15":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"16":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"17":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"18":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"19":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"20":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"21":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"22":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"23":{"start":{"line":20,"column":4},"end":{"line":186,"column":5}},"24":{"start":{"line":20,"column":23},"end":{"line":20,"column":23}},"25":{"start":{"line":20,"column":23},"end":{"line":20,"column":23}},"26":{"start":{"line":27,"column":8},"end":{"line":27,"column":8}},"27":{"start":{"line":33,"column":8},"end":{"line":33,"column":8}},"28":{"start":{"line":40,"column":8},"end":{"line":40,"column":8}},"29":{"start":{"line":46,"column":8},"end":{"line":46,"column":8}},"30":{"start":{"line":52,"column":8},"end":{"line":52,"column":8}},"31":{"start":{"line":58,"column":8},"end":{"line":58,"column":8}},"32":{"start":{"line":64,"column":8},"end":{"line":64,"column":8}},"33":{"start":{"line":70,"column":8},"end":{"line":70,"column":8}},"34":{"start":{"line":77,"column":8},"end":{"line":77,"column":8}},"35":{"start":{"line":84,"column":8},"end":{"line":84,"column":8}},"36":{"start":{"line":90,"column":8},"end":{"line":90,"column":8}},"37":{"start":{"line":96,"column":8},"end":{"line":96,"column":8}},"38":{"start":{"line":102,"column":8},"end":{"line":102,"column":8}},"39":{"start":{"line":108,"column":8},"end":{"line":108,"column":8}},"40":{"start":{"line":116,"column":8},"end":{"line":116,"column":8}},"41":{"start":{"line":124,"column":8},"end":{"line":124,"column":8}},"42":{"start":{"line":130,"column":8},"end":{"line":130,"column":8}},"43":{"start":{"line":136,"column":8},"end":{"line":136,"column":8}},"44":{"start":{"line":142,"column":8},"end":{"line":142,"column":8}},"45":{"start":{"line":149,"column":8},"end":{"line":149,"column":8}},"46":{"start":{"line":155,"column":8},"end":{"line":155,"column":8}},"47":{"start":{"line":161,"column":8},"end":{"line":161,"column":8}},"48":{"start":{"line":167,"column":8},"end":{"line":167,"column":8}},"49":{"start":{"line":173,"column":8},"end":{"line":173,"column":8}},"50":{"start":{"line":179,"column":8},"end":{"line":179,"column":8}},"51":{"start":{"line":182,"column":8},"end":{"line":182,"column":8}},"52":{"start":{"line":185,"column":8},"end":{"line":185,"column":8}},"53":{"start":{"line":20,"column":23},"end":{"line":20,"column":23}},"54":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"55":{"start":{"line":191,"column":11},"end":{"line":191,"column":11}},"56":{"start":{"line":192,"column":8},"end":{"line":194,"column":9}},"57":{"start":{"line":193,"column":12},"end":{"line":193,"column":12}},"58":{"start":{"line":196,"column":8},"end":{"line":196,"column":8}},"59":{"start":{"line":199,"column":8},"end":{"line":199,"column":8}},"60":{"start":{"line":202,"column":8},"end":{"line":202,"column":8}},"61":{"start":{"line":204,"column":8},"end":{"line":204,"column":8}},"62":{"start":{"line":204,"column":42},"end":{"line":204,"column":42}},"63":{"start":{"line":205,"column":8},"end":{"line":205,"column":8}},"64":{"start":{"line":206,"column":8},"end":{"line":206,"column":8}},"65":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"66":{"start":{"line":212,"column":14},"end":{"line":212,"column":14}},"67":{"start":{"line":213,"column":8},"end":{"line":213,"column":8}},"68":{"start":{"line":214,"column":8},"end":{"line":214,"column":8}},"69":{"start":{"line":215,"column":8},"end":{"line":215,"column":8}},"70":{"start":{"line":218,"column":8},"end":{"line":218,"column":8}},"71":{"start":{"line":222,"column":8},"end":{"line":227,"column":9}},"72":{"start":{"line":223,"column":12},"end":{"line":223,"column":12}},"73":{"start":{"line":224,"column":12},"end":{"line":224,"column":12}},"74":{"start":{"line":226,"column":12},"end":{"line":226,"column":12}},"75":{"start":{"line":229,"column":8},"end":{"line":229,"column":8}},"76":{"start":{"line":230,"column":8},"end":{"line":239,"column":9}},"77":{"start":{"line":231,"column":12},"end":{"line":231,"column":12}},"78":{"start":{"line":232,"column":12},"end":{"line":232,"column":12}},"79":{"start":{"line":233,"column":12},"end":{"line":233,"column":12}},"80":{"start":{"line":234,"column":12},"end":{"line":234,"column":12}},"81":{"start":{"line":235,"column":12},"end":{"line":235,"column":12}},"82":{"start":{"line":237,"column":12},"end":{"line":237,"column":12}},"83":{"start":{"line":238,"column":12},"end":{"line":238,"column":12}},"84":{"start":{"line":241,"column":8},"end":{"line":241,"column":8}},"85":{"start":{"line":241,"column":29},"end":{"line":241,"column":29}},"86":{"start":{"line":243,"column":8},"end":{"line":243,"column":8}},"87":{"start":{"line":244,"column":8},"end":{"line":244,"column":8}},"88":{"start":{"line":246,"column":8},"end":{"line":248,"column":9}},"89":{"start":{"line":247,"column":12},"end":{"line":247,"column":12}},"90":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"91":{"start":{"line":255,"column":8},"end":{"line":255,"column":8}},"92":{"start":{"line":256,"column":8},"end":{"line":256,"column":8}},"93":{"start":{"line":257,"column":8},"end":{"line":257,"column":8}},"94":{"start":{"line":258,"column":8},"end":{"line":258,"column":8}},"95":{"start":{"line":260,"column":8},"end":{"line":260,"column":8}},"96":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"97":{"start":{"line":268,"column":25},"end":{"line":268,"column":25}},"98":{"start":{"line":269,"column":8},"end":{"line":269,"column":8}},"99":{"start":{"line":270,"column":8},"end":{"line":270,"column":8}},"100":{"start":{"line":271,"column":8},"end":{"line":271,"column":8}},"101":{"start":{"line":273,"column":8},"end":{"line":275,"column":9}},"102":{"start":{"line":274,"column":12},"end":{"line":274,"column":12}},"103":{"start":{"line":276,"column":8},"end":{"line":278,"column":9}},"104":{"start":{"line":277,"column":12},"end":{"line":277,"column":12}},"105":{"start":{"line":280,"column":8},"end":{"line":280,"column":8}},"106":{"start":{"line":281,"column":8},"end":{"line":284,"column":9}},"107":{"start":{"line":282,"column":12},"end":{"line":282,"column":12}},"108":{"start":{"line":286,"column":8},"end":{"line":288,"column":9}},"109":{"start":{"line":287,"column":12},"end":{"line":287,"column":12}},"110":{"start":{"line":289,"column":8},"end":{"line":291,"column":9}},"111":{"start":{"line":290,"column":12},"end":{"line":290,"column":12}},"112":{"start":{"line":293,"column":8},"end":{"line":293,"column":8}},"113":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"114":{"start":{"line":299,"column":14},"end":{"line":299,"column":14}},"115":{"start":{"line":300,"column":8},"end":{"line":302,"column":9}},"116":{"start":{"line":301,"column":12},"end":{"line":301,"column":12}},"117":{"start":{"line":304,"column":8},"end":{"line":304,"column":8}},"118":{"start":{"line":304,"column":43},"end":{"line":304,"column":43}},"119":{"start":{"line":306,"column":8},"end":{"line":306,"column":8}},"120":{"start":{"line":307,"column":8},"end":{"line":307,"column":8}},"121":{"start":{"line":308,"column":8},"end":{"line":308,"column":8}},"122":{"start":{"line":310,"column":8},"end":{"line":310,"column":8}},"123":{"start":{"line":311,"column":8},"end":{"line":311,"column":8}},"124":{"start":{"line":312,"column":8},"end":{"line":312,"column":8}},"125":{"start":{"line":313,"column":8},"end":{"line":313,"column":8}},"126":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"127":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}},"branchMap":{"1":{"line":19,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"2":{"line":21,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"3":{"line":21,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"4":{"line":21,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"5":{"line":23,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"6":{"line":23,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"7":{"line":23,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"8":{"line":23,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"9":{"line":23,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"10":{"line":105,"type":"binary-expr","locations":[{"start":{"line":90,"column":24},"end":{"line":90,"column":24}},{"start":{"line":90,"column":39},"end":{"line":90,"column":8}}]},"11":{"line":123,"type":"cond-expr","locations":[{"start":{"line":109,"column":12},"end":{"line":108,"column":31}},{"start":{"line":110,"column":12},"end":{"line":108,"column":8}}]},"12":{"line":123,"type":"binary-expr","locations":[{"start":{"line":110,"column":12},"end":{"line":110,"column":12}},{"start":{"line":110,"column":28},"end":{"line":108,"column":8}}]},"13":{"line":129,"type":"cond-expr","locations":[{"start":{"line":117,"column":12},"end":{"line":116,"column":29}},{"start":{"line":118,"column":12},"end":{"line":116,"column":8}}]},"14":{"line":129,"type":"binary-expr","locations":[{"start":{"line":118,"column":12},"end":{"line":118,"column":12}},{"start":{"line":118,"column":28},"end":{"line":116,"column":8}}]},"15":{"line":206,"type":"if","locations":[{"start":{"line":192,"column":8},"end":{"line":192,"column":8}},{"start":{"line":192,"column":8},"end":{"line":192,"column":8}}]},"16":{"line":237,"type":"cond-expr","locations":[{"start":{"line":219,"column":12},"end":{"line":218,"column":23}},{"start":{"line":220,"column":12},"end":{"line":218,"column":8}}]},"17":{"line":239,"type":"if","locations":[{"start":{"line":222,"column":8},"end":{"line":222,"column":8}},{"start":{"line":222,"column":8},"end":{"line":222,"column":8}}]},"18":{"line":247,"type":"if","locations":[{"start":{"line":230,"column":8},"end":{"line":230,"column":8}},{"start":{"line":230,"column":8},"end":{"line":230,"column":8}}]},"19":{"line":250,"type":"binary-expr","locations":[{"start":{"line":233,"column":24},"end":{"line":233,"column":24}},{"start":{"line":233,"column":40},"end":{"line":233,"column":12}}]},"20":{"line":266,"type":"if","locations":[{"start":{"line":246,"column":8},"end":{"line":246,"column":8}},{"start":{"line":246,"column":8},"end":{"line":246,"column":8}}]},"21":{"line":278,"type":"cond-expr","locations":[{"start":{"line":256,"column":34},"end":{"line":256,"column":18}},{"start":{"line":256,"column":69},"end":{"line":256,"column":8}}]},"22":{"line":293,"type":"cond-expr","locations":[{"start":{"line":268,"column":25},"end":{"line":268,"column":25}},{"start":{"line":268,"column":19},"end":{"line":268,"column":25}}]},"23":{"line":293,"type":"binary-expr","locations":[{"start":{"line":268,"column":25},"end":{"line":268,"column":25}},{"start":{"line":268,"column":25},"end":{"line":268,"column":25}}]},"24":{"line":296,"type":"cond-expr","locations":[{"start":{"line":270,"column":34},"end":{"line":270,"column":18}},{"start":{"line":270,"column":69},"end":{"line":270,"column":8}}]},"25":{"line":299,"type":"if","locations":[{"start":{"line":273,"column":8},"end":{"line":273,"column":8}},{"start":{"line":273,"column":8},"end":{"line":273,"column":8}}]},"26":{"line":302,"type":"if","locations":[{"start":{"line":276,"column":8},"end":{"line":276,"column":8}},{"start":{"line":276,"column":8},"end":{"line":276,"column":8}}]},"27":{"line":306,"type":"cond-expr","locations":[{"start":{"line":280,"column":41},"end":{"line":280,"column":31}},{"start":{"line":280,"column":46},"end":{"line":280,"column":8}}]},"28":{"line":307,"type":"if","locations":[{"start":{"line":281,"column":8},"end":{"line":281,"column":8}},{"start":{"line":281,"column":8},"end":{"line":281,"column":8}}]},"29":{"line":307,"type":"binary-expr","locations":[{"start":{"line":281,"column":12},"end":{"line":281,"column":12}},{"start":{"line":281,"column":31},"end":{"line":281,"column":8}}]},"30":{"line":308,"type":"cond-expr","locations":[{"start":{"line":283,"column":16},"end":{"line":282,"column":35}},{"start":{"line":283,"column":39},"end":{"line":282,"column":12}}]},"31":{"line":311,"type":"if","locations":[{"start":{"line":286,"column":8},"end":{"line":286,"column":8}},{"start":{"line":286,"column":8},"end":{"line":286,"column":8}}]},"32":{"line":314,"type":"if","locations":[{"start":{"line":289,"column":8},"end":{"line":289,"column":8}},{"start":{"line":289,"column":8},"end":{"line":289,"column":8}}]},"33":{"line":329,"type":"if","locations":[{"start":{"line":300,"column":8},"end":{"line":300,"column":8}},{"start":{"line":300,"column":8},"end":{"line":300,"column":8}}]}},"code":["import {Feature} from '../../feature';","import {createElm, removeElm, elm} from '../../dom';","import {EMPTY_FN, isNull} from '../../types';","import {addEvt} from '../../event';","import {","    defaultsBool, defaultsStr, defaultsFn, defaultsNb,","} from '../../settings';","import {RIGHT} from '../../modules/toolbar';","","/**"," * Filters Visibility extension"," */","export default class FiltersVisibility extends Feature {","","    /**","     * Creates an instance of FiltersVisibility","     * @param {TableFilter} tf TableFilter instance","     * @param {Object} Configuration object","     */","    constructor(tf, f) {","        super(tf, FiltersVisibility);","","        /**","         * Module name","         * @type {String}","         */","        this.name = f.name;","","        /**","         * Module description","         * @type {String}","         */","        this.desc = defaultsStr(f.description,","            'Filters row visibility manager');","","        /**","         * Extension's stylesheet filename","         * @type {String}","         */","        this.stylesheet = defaultsStr(f.stylesheet , 'filtersVisibility.css');","","        /**","         * Expand icon filename","         * @type {String}","         */","        this.icnExpand = defaultsStr(f.expand_icon_name, 'icn_exp.png');","","        /**","         * Collapse icon filename","         * @type {String}","         */","        this.icnCollapse = defaultsStr(f.collapse_icon_name, 'icn_clp.png');","","        /**","         * Main container element","         * @private","         */","        this.contEl = null;","","        /**","         * Button element","         * @private","         */","        this.btnEl = null;","","        /**","         * Expand icon HTML","         * @private","         */","        this.icnExpandHtml = '<img src=\"' + tf.themesPath + this.icnExpand +","            '\" alt=\"Expand filters\" >';","","        /**","         * Collapse icon HTML","         * @private","         */","        this.icnCollapseHtml = '<img src=\"' + tf.themesPath + this.icnCollapse +","            '\" alt=\"Collapse filters\" >';","","        /**","         * Default text","         * @private","         */","        this.defaultText = 'Toggle filters';","","        /**","         * ID of main container element","         * @type {String}","         */","        this.targetId = f.target_id || null;","","        /**","         * Enable expand/collapse icon, defaults to true","         * @type {Boolean}","         */","        this.enableIcon = defaultsBool(f.enable_icon, true);","","        /**","         * Custom text for button","         * @type {String}","         */","        this.btnText = defaultsStr(f.btn_text, '');","","        /**","         * Collapse button HTML","         * @private","         */","        this.collapseBtnHtml = this.enableIcon ?","            this.icnCollapseHtml + this.btnText :","            this.btnText || this.defaultText;","","        /**","         * Expand button HTML","         * @private","         */","        this.expandBtnHtml = this.enableIcon ?","            this.icnExpandHtml + this.btnText :","            this.btnText || this.defaultText;","","        /**","         * Button's custom HTML","         * @type {String}","         */","        this.btnHtml = defaultsStr(f.btn_html, null);","","        /**","         * Css class for expand/collapse filters button","         * @type {String}","         */","        this.btnCssClass = defaultsStr(f.btn_css_class, 'btnExpClpFlt');","","        /**","         * Css class for main container","         * @type {String}","         */","        this.contCssClass = defaultsStr(f.cont_css_class, 'expClpFlt');","","        /**","         * Filters row index","         * @type {Number}","         */","        this.filtersRowIndex = defaultsNb(f.filters_row_index,","            tf.getFiltersRowIndex());","","        /**","         * Make filters visible at initialization, defaults to true","         * @type {Boolean}","         */","        this.visibleAtStart = defaultsNb(f.visible_at_start, true);","","        /**","         * Default position in toolbar ('left'|'center'|'right')","         * @type {String}","         */","        this.toolbarPosition = defaultsStr(f.toolbar_position, RIGHT);","","        /**","         * Callback fired before filters row is shown","         * @type {Function}","         */","        this.onBeforeShow = defaultsFn(f.on_before_show, EMPTY_FN);","","        /**","         * Callback fired after filters row is shown","         * @type {Function}","         */","        this.onAfterShow = defaultsFn(f.on_after_show, EMPTY_FN);","","        /**","         * Callback fired before filters row is hidden","         * @type {Function}","         */","        this.onBeforeHide = defaultsFn(f.on_before_hide, EMPTY_FN);","","        /**","         * Callback fired after filters row is hidden","         * @type {Function}","         */","        this.onAfterHide = defaultsFn(f.on_after_hide, EMPTY_FN);","","        //Import extension's stylesheet","        tf.import(f.name + 'Style', tf.getStylePath() + this.stylesheet, null,","            'link');","","        this.enable();","    }","","    /**","     * Initialise extension","     */","    init() {","        if (this.initialized) {","            return;","        }","","        this.emitter.emit('initializing-extension', this,","            !isNull(this.targetId));","","        this.buildUI();","","        /** @inherited */","        this.initialized = true;","","        this.emitter.on(['show-filters'], (tf, visible) => this.show(visible));","        this.emitter.emit('filters-visibility-initialized', this.tf, this);","        this.emitter.emit('extension-initialized', this);","    }","","    /**","     * Build UI elements","     */","    buildUI() {","        let tf = this.tf;","        let span = createElm('span');","        span.className = this.contCssClass;","","        // Container element (rdiv or custom element)","        let targetEl = !this.targetId ?","            tf.feature('toolbar').container(this.toolbarPosition) :","            elm(this.targetId);","","        if (!this.targetId) {","            let firstChild = targetEl.firstChild;","            firstChild.parentNode.insertBefore(span, firstChild);","        } else {","            targetEl.appendChild(span);","        }","","        let btn;","        if (!this.btnHtml) {","            btn = createElm('a', ['href', 'javascript:void(0);']);","            btn.className = this.btnCssClass;","            btn.title = this.btnText || this.defaultText;","            btn.innerHTML = this.collapseBtnHtml;","            span.appendChild(btn);","        } else { // Custom html","            span.innerHTML = this.btnHtml;","            btn = span.firstChild;","        }","","        addEvt(btn, 'click', () => this.toggle());","","        this.contEl = span;","        this.btnEl = btn;","","        if (!this.visibleAtStart) {","            this.toggle();","        }","    }","","    /**","     * Toggle filters visibility","     */","    toggle() {","        let tf = this.tf;","        let tbl = tf.gridLayout ? tf.feature('gridLayout').headTbl : tf.dom();","        let fltRow = tbl.rows[this.filtersRowIndex];","        let isDisplayed = fltRow.style.display === '';","","        this.show(!isDisplayed);","    }","","    /**","     * Show or hide filters","     *","     * @param {boolean} [visible=true] Visibility flag","     */","    show(visible = true) {","        let tf = this.tf;","        let tbl = tf.gridLayout ? tf.feature('gridLayout').headTbl : tf.dom();","        let fltRow = tbl.rows[this.filtersRowIndex];","","        if (visible) {","            this.onBeforeShow(this);","        }","        if (!visible) {","            this.onBeforeHide(this);","        }","","        fltRow.style.display = visible ? '' : 'none';","        if (this.enableIcon && !this.btnHtml) {","            this.btnEl.innerHTML = visible ?","                this.collapseBtnHtml : this.expandBtnHtml;","        }","","        if (visible) {","            this.onAfterShow(this);","        }","        if (!visible) {","            this.onAfterHide(this);","        }","","        this.emitter.emit('filters-toggled', tf, this, visible);","    }","","    /**","     * Destroy the UI","     */","    destroy() {","        if (!this.initialized) {","            return;","        }","","        this.emitter.off(['show-filters'], (tf, visible) => this.show(visible));","","        this.btnEl.innerHTML = '';","        removeElm(this.btnEl);","        this.btnEl = null;","","        this.contEl.innerHTML = '';","        removeElm(this.contEl);","        this.contEl = null;","        this.initialized = false;","    }","","}",""]};
}
__cov_Qo4iAdus5GVvl_gjC_68lA = __cov_Qo4iAdus5GVvl_gjC_68lA['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\filtersVisibility\\filtersVisibility.js'];
__cov_Qo4iAdus5GVvl_gjC_68lA.s['1']++;Object.defineProperty(exports,'__esModule',{value:true});__cov_Qo4iAdus5GVvl_gjC_68lA.s['2']++;var _feature=__webpack_require__(/*! ../../feature */ "./src/feature.js");__cov_Qo4iAdus5GVvl_gjC_68lA.s['3']++;var _dom=__webpack_require__(/*! ../../dom */ "./src/dom.js");__cov_Qo4iAdus5GVvl_gjC_68lA.s['4']++;var _types=__webpack_require__(/*! ../../types */ "./src/types.js");__cov_Qo4iAdus5GVvl_gjC_68lA.s['5']++;var _event=__webpack_require__(/*! ../../event */ "./src/event.js");__cov_Qo4iAdus5GVvl_gjC_68lA.s['6']++;var _settings=__webpack_require__(/*! ../../settings */ "./src/settings.js");__cov_Qo4iAdus5GVvl_gjC_68lA.s['7']++;var _toolbar=__webpack_require__(/*! ../../modules/toolbar */ "./src/modules/toolbar.js");function _classCallCheck(instance,Constructor){__cov_Qo4iAdus5GVvl_gjC_68lA.f['1']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['9']++;if(!(instance instanceof Constructor)){__cov_Qo4iAdus5GVvl_gjC_68lA.b['1'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['10']++;throw new TypeError('Cannot call a class as a function');}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['1'][1]++;}}function _possibleConstructorReturn(self,call){__cov_Qo4iAdus5GVvl_gjC_68lA.f['2']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['12']++;if(!self){__cov_Qo4iAdus5GVvl_gjC_68lA.b['2'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['13']++;throw new ReferenceError('this hasn\'t been initialised - super() hasn\'t been called');}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['2'][1]++;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['14']++;return(__cov_Qo4iAdus5GVvl_gjC_68lA.b['4'][0]++,call)&&((__cov_Qo4iAdus5GVvl_gjC_68lA.b['4'][1]++,typeof call==='object')||(__cov_Qo4iAdus5GVvl_gjC_68lA.b['4'][2]++,typeof call==='function'))?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['3'][0]++,call):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['3'][1]++,self);}function _inherits(subClass,superClass){__cov_Qo4iAdus5GVvl_gjC_68lA.f['3']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['16']++;if((__cov_Qo4iAdus5GVvl_gjC_68lA.b['6'][0]++,typeof superClass!=='function')&&(__cov_Qo4iAdus5GVvl_gjC_68lA.b['6'][1]++,superClass!==null)){__cov_Qo4iAdus5GVvl_gjC_68lA.b['5'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['17']++;throw new TypeError('Super expression must either be null or a function, not '+typeof superClass);}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['5'][1]++;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['18']++;subClass.prototype=Object.create((__cov_Qo4iAdus5GVvl_gjC_68lA.b['7'][0]++,superClass)&&(__cov_Qo4iAdus5GVvl_gjC_68lA.b['7'][1]++,superClass.prototype),{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});__cov_Qo4iAdus5GVvl_gjC_68lA.s['19']++;if(superClass){__cov_Qo4iAdus5GVvl_gjC_68lA.b['8'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['20']++;Object.setPrototypeOf?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['9'][0]++,Object.setPrototypeOf(subClass,superClass)):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['9'][1]++,subClass.__proto__=superClass);}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['8'][1]++;}}__cov_Qo4iAdus5GVvl_gjC_68lA.s['21']++;var FiltersVisibility=function(_Feature){__cov_Qo4iAdus5GVvl_gjC_68lA.f['4']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['22']++;_inherits(FiltersVisibility,_Feature);function FiltersVisibility(tf,f){__cov_Qo4iAdus5GVvl_gjC_68lA.f['5']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['24']++;_classCallCheck(this,FiltersVisibility);__cov_Qo4iAdus5GVvl_gjC_68lA.s['25']++;var _this=_possibleConstructorReturn(this,_Feature.call(this,tf,FiltersVisibility));__cov_Qo4iAdus5GVvl_gjC_68lA.s['26']++;_this.name=f.name;__cov_Qo4iAdus5GVvl_gjC_68lA.s['27']++;_this.desc=(0,_settings.defaultsStr)(f.description,'Filters row visibility manager');__cov_Qo4iAdus5GVvl_gjC_68lA.s['28']++;_this.stylesheet=(0,_settings.defaultsStr)(f.stylesheet,'filtersVisibility.css');__cov_Qo4iAdus5GVvl_gjC_68lA.s['29']++;_this.icnExpand=(0,_settings.defaultsStr)(f.expand_icon_name,'icn_exp.png');__cov_Qo4iAdus5GVvl_gjC_68lA.s['30']++;_this.icnCollapse=(0,_settings.defaultsStr)(f.collapse_icon_name,'icn_clp.png');__cov_Qo4iAdus5GVvl_gjC_68lA.s['31']++;_this.contEl=null;__cov_Qo4iAdus5GVvl_gjC_68lA.s['32']++;_this.btnEl=null;__cov_Qo4iAdus5GVvl_gjC_68lA.s['33']++;_this.icnExpandHtml='<img src="'+tf.themesPath+_this.icnExpand+'" alt="Expand filters" >';__cov_Qo4iAdus5GVvl_gjC_68lA.s['34']++;_this.icnCollapseHtml='<img src="'+tf.themesPath+_this.icnCollapse+'" alt="Collapse filters" >';__cov_Qo4iAdus5GVvl_gjC_68lA.s['35']++;_this.defaultText='Toggle filters';__cov_Qo4iAdus5GVvl_gjC_68lA.s['36']++;_this.targetId=(__cov_Qo4iAdus5GVvl_gjC_68lA.b['10'][0]++,f.target_id)||(__cov_Qo4iAdus5GVvl_gjC_68lA.b['10'][1]++,null);__cov_Qo4iAdus5GVvl_gjC_68lA.s['37']++;_this.enableIcon=(0,_settings.defaultsBool)(f.enable_icon,true);__cov_Qo4iAdus5GVvl_gjC_68lA.s['38']++;_this.btnText=(0,_settings.defaultsStr)(f.btn_text,'');__cov_Qo4iAdus5GVvl_gjC_68lA.s['39']++;_this.collapseBtnHtml=_this.enableIcon?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['11'][0]++,_this.icnCollapseHtml+_this.btnText):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['11'][1]++,(__cov_Qo4iAdus5GVvl_gjC_68lA.b['12'][0]++,_this.btnText)||(__cov_Qo4iAdus5GVvl_gjC_68lA.b['12'][1]++,_this.defaultText));__cov_Qo4iAdus5GVvl_gjC_68lA.s['40']++;_this.expandBtnHtml=_this.enableIcon?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['13'][0]++,_this.icnExpandHtml+_this.btnText):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['13'][1]++,(__cov_Qo4iAdus5GVvl_gjC_68lA.b['14'][0]++,_this.btnText)||(__cov_Qo4iAdus5GVvl_gjC_68lA.b['14'][1]++,_this.defaultText));__cov_Qo4iAdus5GVvl_gjC_68lA.s['41']++;_this.btnHtml=(0,_settings.defaultsStr)(f.btn_html,null);__cov_Qo4iAdus5GVvl_gjC_68lA.s['42']++;_this.btnCssClass=(0,_settings.defaultsStr)(f.btn_css_class,'btnExpClpFlt');__cov_Qo4iAdus5GVvl_gjC_68lA.s['43']++;_this.contCssClass=(0,_settings.defaultsStr)(f.cont_css_class,'expClpFlt');__cov_Qo4iAdus5GVvl_gjC_68lA.s['44']++;_this.filtersRowIndex=(0,_settings.defaultsNb)(f.filters_row_index,tf.getFiltersRowIndex());__cov_Qo4iAdus5GVvl_gjC_68lA.s['45']++;_this.visibleAtStart=(0,_settings.defaultsNb)(f.visible_at_start,true);__cov_Qo4iAdus5GVvl_gjC_68lA.s['46']++;_this.toolbarPosition=(0,_settings.defaultsStr)(f.toolbar_position,_toolbar.RIGHT);__cov_Qo4iAdus5GVvl_gjC_68lA.s['47']++;_this.onBeforeShow=(0,_settings.defaultsFn)(f.on_before_show,_types.EMPTY_FN);__cov_Qo4iAdus5GVvl_gjC_68lA.s['48']++;_this.onAfterShow=(0,_settings.defaultsFn)(f.on_after_show,_types.EMPTY_FN);__cov_Qo4iAdus5GVvl_gjC_68lA.s['49']++;_this.onBeforeHide=(0,_settings.defaultsFn)(f.on_before_hide,_types.EMPTY_FN);__cov_Qo4iAdus5GVvl_gjC_68lA.s['50']++;_this.onAfterHide=(0,_settings.defaultsFn)(f.on_after_hide,_types.EMPTY_FN);__cov_Qo4iAdus5GVvl_gjC_68lA.s['51']++;tf.import(f.name+'Style',tf.getStylePath()+_this.stylesheet,null,'link');__cov_Qo4iAdus5GVvl_gjC_68lA.s['52']++;_this.enable();__cov_Qo4iAdus5GVvl_gjC_68lA.s['53']++;return _this;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['54']++;FiltersVisibility.prototype.init=function init(){__cov_Qo4iAdus5GVvl_gjC_68lA.f['6']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['55']++;var _this2=this;__cov_Qo4iAdus5GVvl_gjC_68lA.s['56']++;if(this.initialized){__cov_Qo4iAdus5GVvl_gjC_68lA.b['15'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['57']++;return;}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['15'][1]++;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['58']++;this.emitter.emit('initializing-extension',this,!(0,_types.isNull)(this.targetId));__cov_Qo4iAdus5GVvl_gjC_68lA.s['59']++;this.buildUI();__cov_Qo4iAdus5GVvl_gjC_68lA.s['60']++;this.initialized=true;__cov_Qo4iAdus5GVvl_gjC_68lA.s['61']++;this.emitter.on(['show-filters'],function(tf,visible){__cov_Qo4iAdus5GVvl_gjC_68lA.f['7']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['62']++;return _this2.show(visible);});__cov_Qo4iAdus5GVvl_gjC_68lA.s['63']++;this.emitter.emit('filters-visibility-initialized',this.tf,this);__cov_Qo4iAdus5GVvl_gjC_68lA.s['64']++;this.emitter.emit('extension-initialized',this);};__cov_Qo4iAdus5GVvl_gjC_68lA.s['65']++;FiltersVisibility.prototype.buildUI=function buildUI(){__cov_Qo4iAdus5GVvl_gjC_68lA.f['8']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['66']++;var _this3=this;__cov_Qo4iAdus5GVvl_gjC_68lA.s['67']++;var tf=this.tf;__cov_Qo4iAdus5GVvl_gjC_68lA.s['68']++;var span=(0,_dom.createElm)('span');__cov_Qo4iAdus5GVvl_gjC_68lA.s['69']++;span.className=this.contCssClass;__cov_Qo4iAdus5GVvl_gjC_68lA.s['70']++;var targetEl=!this.targetId?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['16'][0]++,tf.feature('toolbar').container(this.toolbarPosition)):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['16'][1]++,(0,_dom.elm)(this.targetId));__cov_Qo4iAdus5GVvl_gjC_68lA.s['71']++;if(!this.targetId){__cov_Qo4iAdus5GVvl_gjC_68lA.b['17'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['72']++;var firstChild=targetEl.firstChild;__cov_Qo4iAdus5GVvl_gjC_68lA.s['73']++;firstChild.parentNode.insertBefore(span,firstChild);}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['17'][1]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['74']++;targetEl.appendChild(span);}__cov_Qo4iAdus5GVvl_gjC_68lA.s['75']++;var btn=void 0;__cov_Qo4iAdus5GVvl_gjC_68lA.s['76']++;if(!this.btnHtml){__cov_Qo4iAdus5GVvl_gjC_68lA.b['18'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['77']++;btn=(0,_dom.createElm)('a',['href','javascript:void(0);']);__cov_Qo4iAdus5GVvl_gjC_68lA.s['78']++;btn.className=this.btnCssClass;__cov_Qo4iAdus5GVvl_gjC_68lA.s['79']++;btn.title=(__cov_Qo4iAdus5GVvl_gjC_68lA.b['19'][0]++,this.btnText)||(__cov_Qo4iAdus5GVvl_gjC_68lA.b['19'][1]++,this.defaultText);__cov_Qo4iAdus5GVvl_gjC_68lA.s['80']++;btn.innerHTML=this.collapseBtnHtml;__cov_Qo4iAdus5GVvl_gjC_68lA.s['81']++;span.appendChild(btn);}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['18'][1]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['82']++;span.innerHTML=this.btnHtml;__cov_Qo4iAdus5GVvl_gjC_68lA.s['83']++;btn=span.firstChild;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['84']++;(0,_event.addEvt)(btn,'click',function(){__cov_Qo4iAdus5GVvl_gjC_68lA.f['9']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['85']++;return _this3.toggle();});__cov_Qo4iAdus5GVvl_gjC_68lA.s['86']++;this.contEl=span;__cov_Qo4iAdus5GVvl_gjC_68lA.s['87']++;this.btnEl=btn;__cov_Qo4iAdus5GVvl_gjC_68lA.s['88']++;if(!this.visibleAtStart){__cov_Qo4iAdus5GVvl_gjC_68lA.b['20'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['89']++;this.toggle();}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['20'][1]++;}};__cov_Qo4iAdus5GVvl_gjC_68lA.s['90']++;FiltersVisibility.prototype.toggle=function toggle(){__cov_Qo4iAdus5GVvl_gjC_68lA.f['10']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['91']++;var tf=this.tf;__cov_Qo4iAdus5GVvl_gjC_68lA.s['92']++;var tbl=tf.gridLayout?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['21'][0]++,tf.feature('gridLayout').headTbl):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['21'][1]++,tf.dom());__cov_Qo4iAdus5GVvl_gjC_68lA.s['93']++;var fltRow=tbl.rows[this.filtersRowIndex];__cov_Qo4iAdus5GVvl_gjC_68lA.s['94']++;var isDisplayed=fltRow.style.display==='';__cov_Qo4iAdus5GVvl_gjC_68lA.s['95']++;this.show(!isDisplayed);};__cov_Qo4iAdus5GVvl_gjC_68lA.s['96']++;FiltersVisibility.prototype.show=function show(){__cov_Qo4iAdus5GVvl_gjC_68lA.f['11']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['97']++;var visible=(__cov_Qo4iAdus5GVvl_gjC_68lA.b['23'][0]++,arguments.length>0)&&(__cov_Qo4iAdus5GVvl_gjC_68lA.b['23'][1]++,arguments[0]!==undefined)?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['22'][0]++,arguments[0]):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['22'][1]++,true);__cov_Qo4iAdus5GVvl_gjC_68lA.s['98']++;var tf=this.tf;__cov_Qo4iAdus5GVvl_gjC_68lA.s['99']++;var tbl=tf.gridLayout?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['24'][0]++,tf.feature('gridLayout').headTbl):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['24'][1]++,tf.dom());__cov_Qo4iAdus5GVvl_gjC_68lA.s['100']++;var fltRow=tbl.rows[this.filtersRowIndex];__cov_Qo4iAdus5GVvl_gjC_68lA.s['101']++;if(visible){__cov_Qo4iAdus5GVvl_gjC_68lA.b['25'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['102']++;this.onBeforeShow(this);}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['25'][1]++;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['103']++;if(!visible){__cov_Qo4iAdus5GVvl_gjC_68lA.b['26'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['104']++;this.onBeforeHide(this);}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['26'][1]++;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['105']++;fltRow.style.display=visible?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['27'][0]++,''):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['27'][1]++,'none');__cov_Qo4iAdus5GVvl_gjC_68lA.s['106']++;if((__cov_Qo4iAdus5GVvl_gjC_68lA.b['29'][0]++,this.enableIcon)&&(__cov_Qo4iAdus5GVvl_gjC_68lA.b['29'][1]++,!this.btnHtml)){__cov_Qo4iAdus5GVvl_gjC_68lA.b['28'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['107']++;this.btnEl.innerHTML=visible?(__cov_Qo4iAdus5GVvl_gjC_68lA.b['30'][0]++,this.collapseBtnHtml):(__cov_Qo4iAdus5GVvl_gjC_68lA.b['30'][1]++,this.expandBtnHtml);}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['28'][1]++;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['108']++;if(visible){__cov_Qo4iAdus5GVvl_gjC_68lA.b['31'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['109']++;this.onAfterShow(this);}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['31'][1]++;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['110']++;if(!visible){__cov_Qo4iAdus5GVvl_gjC_68lA.b['32'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['111']++;this.onAfterHide(this);}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['32'][1]++;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['112']++;this.emitter.emit('filters-toggled',tf,this,visible);};__cov_Qo4iAdus5GVvl_gjC_68lA.s['113']++;FiltersVisibility.prototype.destroy=function destroy(){__cov_Qo4iAdus5GVvl_gjC_68lA.f['12']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['114']++;var _this4=this;__cov_Qo4iAdus5GVvl_gjC_68lA.s['115']++;if(!this.initialized){__cov_Qo4iAdus5GVvl_gjC_68lA.b['33'][0]++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['116']++;return;}else{__cov_Qo4iAdus5GVvl_gjC_68lA.b['33'][1]++;}__cov_Qo4iAdus5GVvl_gjC_68lA.s['117']++;this.emitter.off(['show-filters'],function(tf,visible){__cov_Qo4iAdus5GVvl_gjC_68lA.f['13']++;__cov_Qo4iAdus5GVvl_gjC_68lA.s['118']++;return _this4.show(visible);});__cov_Qo4iAdus5GVvl_gjC_68lA.s['119']++;this.btnEl.innerHTML='';__cov_Qo4iAdus5GVvl_gjC_68lA.s['120']++;(0,_dom.removeElm)(this.btnEl);__cov_Qo4iAdus5GVvl_gjC_68lA.s['121']++;this.btnEl=null;__cov_Qo4iAdus5GVvl_gjC_68lA.s['122']++;this.contEl.innerHTML='';__cov_Qo4iAdus5GVvl_gjC_68lA.s['123']++;(0,_dom.removeElm)(this.contEl);__cov_Qo4iAdus5GVvl_gjC_68lA.s['124']++;this.contEl=null;__cov_Qo4iAdus5GVvl_gjC_68lA.s['125']++;this.initialized=false;};__cov_Qo4iAdus5GVvl_gjC_68lA.s['126']++;return FiltersVisibility;}(_feature.Feature);__cov_Qo4iAdus5GVvl_gjC_68lA.s['127']++;exports.default=FiltersVisibility;


/***/ }),

/***/ "./src/extensions/sort/adapterSortabletable.js":
/*!*****************************************************!*\
  !*** ./src/extensions/sort/adapterSortabletable.js ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __cov_LyI3jxXOy1lYGCWCsfZRUw = (Function('return this'))();
if (!__cov_LyI3jxXOy1lYGCWCsfZRUw.__coverage__) { __cov_LyI3jxXOy1lYGCWCsfZRUw.__coverage__ = {}; }
__cov_LyI3jxXOy1lYGCWCsfZRUw = __cov_LyI3jxXOy1lYGCWCsfZRUw.__coverage__;
if (!(__cov_LyI3jxXOy1lYGCWCsfZRUw['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\sort\\adapterSortabletable.js'])) {
   __cov_LyI3jxXOy1lYGCWCsfZRUw['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\sort\\adapterSortabletable.js'] = {"path":"C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\sort\\adapterSortabletable.js","s":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":0,"8":0,"9":1,"10":0,"11":0,"12":1,"13":0,"14":0,"15":0,"16":1,"17":0,"18":0,"19":0,"20":0,"21":0,"22":0,"23":0,"24":1,"25":0,"26":0,"27":0,"28":0,"29":0,"30":0,"31":0,"32":0,"33":0,"34":0,"35":0,"36":0,"37":0,"38":0,"39":0,"40":0,"41":0,"42":0,"43":0,"44":0,"45":0,"46":0,"47":0,"48":0,"49":0,"50":0,"51":0,"52":0,"53":0,"54":0,"55":0,"56":0,"57":0,"58":0,"59":0,"60":0,"61":0,"62":0,"63":0,"64":0,"65":0,"66":0,"67":0,"68":0,"69":0,"70":0,"71":0,"72":0,"73":0,"74":0,"75":0,"76":0,"77":0,"78":0,"79":0,"80":0,"81":0,"82":0,"83":0,"84":0,"85":0,"86":0,"87":0,"88":0,"89":0,"90":0,"91":0,"92":0,"93":0,"94":0,"95":0,"96":0,"97":0,"98":0,"99":0,"100":0,"101":0,"102":0,"103":0,"104":0,"105":0,"106":0,"107":0,"108":0,"109":0,"110":0,"111":0,"112":0,"113":0,"114":0,"115":0,"116":0,"117":0,"118":0,"119":0,"120":0,"121":0,"122":0,"123":0,"124":0,"125":0,"126":0,"127":0,"128":0,"129":0,"130":0,"131":0,"132":0,"133":0,"134":0,"135":0,"136":0,"137":0,"138":0,"139":0,"140":0,"141":0,"142":0,"143":0,"144":0,"145":0,"146":0,"147":0,"148":0,"149":0,"150":0,"151":0,"152":0,"153":0,"154":0,"155":0,"156":0,"157":0,"158":0,"159":0,"160":0,"161":0,"162":0,"163":0,"164":0,"165":0,"166":0,"167":0,"168":0,"169":0,"170":0,"171":0,"172":0,"173":0,"174":0,"175":0,"176":0,"177":0,"178":0,"179":0,"180":0,"181":0,"182":0,"183":0,"184":0,"185":0,"186":0,"187":0,"188":0,"189":0,"190":0,"191":0,"192":0,"193":0,"194":0,"195":0,"196":0,"197":0,"198":0,"199":0,"200":0,"201":0,"202":0,"203":0,"204":0,"205":0,"206":0,"207":0,"208":0,"209":0,"210":0,"211":0,"212":0,"213":0,"214":0,"215":0,"216":0,"217":0,"218":0,"219":0,"220":0,"221":0,"222":0,"223":0,"224":0,"225":0,"226":0,"227":0,"228":0,"229":0,"230":0,"231":0,"232":0,"233":1,"234":0,"235":0,"236":0,"237":0,"238":0,"239":0,"240":0,"241":1,"242":0,"243":0,"244":0,"245":0,"246":0,"247":0,"248":0},"b":{"1":[0,0],"2":[0,0],"3":[0,0],"4":[0,0,0],"5":[0,0],"6":[0,0],"7":[0,0],"8":[0,0],"9":[0,0],"10":[0,0],"11":[0,0],"12":[0,0],"13":[0,0],"14":[0,0],"15":[0,0],"16":[0,0],"17":[0,0],"18":[0,0],"19":[0,0],"20":[0,0],"21":[0,0],"22":[0,0],"23":[0,0],"24":[0,0],"25":[0,0],"26":[0,0],"27":[0,0],"28":[0,0],"29":[0,0],"30":[0,0],"31":[0,0],"32":[0,0],"33":[0,0],"34":[0,0],"35":[0,0],"36":[0,0],"37":[0,0],"38":[0,0],"39":[0,0],"40":[0,0],"41":[0,0],"42":[0,0],"43":[0,0],"44":[0,0],"45":[0,0],"46":[0,0],"47":[0,0],"48":[0,0],"49":[0,0],"50":[0,0],"51":[0,0],"52":[0,0],"53":[0,0],"54":[0,0],"55":[0,0],"56":[0,0],"57":[0,0],"58":[0,0],"59":[0,0],"60":[0,0]},"f":{"1":0,"2":0,"3":0,"4":0,"5":0,"6":0,"7":0,"8":0,"9":0,"10":0,"11":0,"12":0,"13":0,"14":0,"15":0,"16":0,"17":0,"18":0,"19":0,"20":0,"21":0,"22":0,"23":0,"24":0,"25":0,"26":0,"27":0,"28":0,"29":0},"fnMap":{"1":{"name":"_classCallCheck","line":21,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"2":{"name":"_possibleConstructorReturn","line":23,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"3":{"name":"_inherits","line":25,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"4":{"name":"(anonymous_4)","line":30,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"5":{"name":"AdapterSortableTable","line":38,"loc":{"start":{"line":22,"column":4},"end":{"line":22,"column":26}}},"6":{"name":"init","line":158,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"7":{"name":"(anonymous_7)","line":179,"loc":{"start":{"line":160,"column":32},"end":{"line":160,"column":44}}},"8":{"name":"(anonymous_8)","line":188,"loc":{"start":{"line":169,"column":26},"end":{"line":169,"column":38}}},"9":{"name":"sortByColumnIndex","line":225,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"10":{"name":"sortByColumnIndexHandler","line":232,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"11":{"name":"overrideSortableTable","line":241,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"12":{"name":"(anonymous_12)","line":249,"loc":{"start":{"line":225,"column":48},"end":{"line":225,"column":63}}},"13":{"name":"(anonymous_13)","line":270,"loc":{"start":{"line":249,"column":37},"end":{"line":249,"column":52}}},"14":{"name":"(anonymous_14)","line":282,"loc":{"start":{"line":260,"column":45},"end":{"line":260,"column":67}}},"15":{"name":"(anonymous_15)","line":320,"loc":{"start":{"line":298,"column":53},"end":{"line":298,"column":65}}},"16":{"name":"(anonymous_16)","line":369,"loc":{"start":{"line":349,"column":46},"end":{"line":349,"column":78}}},"17":{"name":"(anonymous_17)","line":387,"loc":{"start":{"line":367,"column":37},"end":{"line":367,"column":53}}},"18":{"name":"addSortType","line":404,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"19":{"name":"setSortTypes","line":424,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"20":{"name":"(anonymous_20)","line":431,"loc":{"start":{"line":397,"column":19},"end":{"line":397,"column":26}}},"21":{"name":"(anonymous_21)","line":470,"loc":{"start":{"line":439,"column":58},"end":{"line":439,"column":58}}},"22":{"name":"(anonymous_22)","line":480,"loc":{"start":{"line":449,"column":45},"end":{"line":449,"column":54}}},"23":{"name":"_addDateType","line":494,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"24":{"name":"(anonymous_24)","line":500,"loc":{"start":{"line":468,"column":34},"end":{"line":468,"column":45}}},"25":{"name":"_addNumberType","line":508,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"26":{"name":"(anonymous_26)","line":511,"loc":{"start":{"line":479,"column":34},"end":{"line":479,"column":45}}},"27":{"name":"destroy","line":522,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true},"28":{"name":"ipAddress","line":552,"loc":{"start":{"line":514,"column":0},"end":{"line":514,"column":26}}},"29":{"name":"sortIP","line":565,"loc":{"start":{"line":527,"column":0},"end":{"line":527,"column":22}}}},"statementMap":{"1":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"2":{"start":{"line":1,"column":0},"end":{"line":1,"column":0}},"3":{"start":{"line":2,"column":0},"end":{"line":2,"column":0}},"4":{"start":{"line":3,"column":0},"end":{"line":3,"column":0}},"5":{"start":{"line":4,"column":0},"end":{"line":4,"column":0}},"6":{"start":{"line":5,"column":0},"end":{"line":5,"column":0}},"7":{"start":{"line":6,"column":0},"end":{"line":6,"column":0}},"8":{"start":{"line":10,"column":0},"end":{"line":10,"column":0}},"9":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"10":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"11":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"12":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"13":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"14":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"15":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"16":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"17":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"18":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"19":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"20":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"21":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"22":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"23":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"24":{"start":{"line":22,"column":4},"end":{"line":134,"column":5}},"25":{"start":{"line":22,"column":26},"end":{"line":22,"column":26}},"26":{"start":{"line":22,"column":26},"end":{"line":22,"column":26}},"27":{"start":{"line":29,"column":8},"end":{"line":29,"column":8}},"28":{"start":{"line":35,"column":8},"end":{"line":35,"column":8}},"29":{"start":{"line":42,"column":8},"end":{"line":42,"column":8}},"30":{"start":{"line":48,"column":8},"end":{"line":48,"column":8}},"31":{"start":{"line":55,"column":8},"end":{"line":55,"column":8}},"32":{"start":{"line":61,"column":8},"end":{"line":61,"column":8}},"33":{"start":{"line":67,"column":8},"end":{"line":67,"column":8}},"34":{"start":{"line":75,"column":8},"end":{"line":75,"column":8}},"35":{"start":{"line":81,"column":8},"end":{"line":81,"column":8}},"36":{"start":{"line":87,"column":8},"end":{"line":87,"column":8}},"37":{"start":{"line":93,"column":8},"end":{"line":93,"column":8}},"38":{"start":{"line":100,"column":8},"end":{"line":100,"column":8}},"39":{"start":{"line":107,"column":8},"end":{"line":107,"column":8}},"40":{"start":{"line":113,"column":8},"end":{"line":113,"column":8}},"41":{"start":{"line":119,"column":8},"end":{"line":119,"column":8}},"42":{"start":{"line":125,"column":8},"end":{"line":125,"column":8}},"43":{"start":{"line":131,"column":8},"end":{"line":131,"column":8}},"44":{"start":{"line":133,"column":8},"end":{"line":133,"column":8}},"45":{"start":{"line":22,"column":26},"end":{"line":22,"column":26}},"46":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"47":{"start":{"line":140,"column":8},"end":{"line":142,"column":9}},"48":{"start":{"line":141,"column":12},"end":{"line":141,"column":12}},"49":{"start":{"line":143,"column":8},"end":{"line":143,"column":8}},"50":{"start":{"line":144,"column":8},"end":{"line":144,"column":8}},"51":{"start":{"line":147,"column":8},"end":{"line":149,"column":9}},"52":{"start":{"line":148,"column":12},"end":{"line":148,"column":12}},"53":{"start":{"line":152,"column":8},"end":{"line":152,"column":8}},"54":{"start":{"line":154,"column":8},"end":{"line":154,"column":8}},"55":{"start":{"line":155,"column":8},"end":{"line":155,"column":8}},"56":{"start":{"line":157,"column":8},"end":{"line":157,"column":8}},"57":{"start":{"line":160,"column":8},"end":{"line":160,"column":8}},"58":{"start":{"line":161,"column":12},"end":{"line":161,"column":12}},"59":{"start":{"line":164,"column":12},"end":{"line":166,"column":13}},"60":{"start":{"line":165,"column":16},"end":{"line":165,"column":16}},"61":{"start":{"line":169,"column":8},"end":{"line":169,"column":8}},"62":{"start":{"line":170,"column":12},"end":{"line":170,"column":12}},"63":{"start":{"line":173,"column":12},"end":{"line":179,"column":13}},"64":{"start":{"line":174,"column":16},"end":{"line":174,"column":16}},"65":{"start":{"line":176,"column":16},"end":{"line":176,"column":16}},"66":{"start":{"line":177,"column":16},"end":{"line":177,"column":16}},"67":{"start":{"line":178,"column":16},"end":{"line":178,"column":16}},"68":{"start":{"line":181,"column":12},"end":{"line":181,"column":12}},"69":{"start":{"line":182,"column":12},"end":{"line":182,"column":12}},"70":{"start":{"line":187,"column":8},"end":{"line":187,"column":8}},"71":{"start":{"line":188,"column":8},"end":{"line":190,"column":9}},"72":{"start":{"line":189,"column":12},"end":{"line":189,"column":12}},"73":{"start":{"line":192,"column":8},"end":{"line":192,"column":8}},"74":{"start":{"line":195,"column":8},"end":{"line":195,"column":8}},"75":{"start":{"line":197,"column":8},"end":{"line":197,"column":8}},"76":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"77":{"start":{"line":206,"column":8},"end":{"line":206,"column":8}},"78":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"79":{"start":{"line":211,"column":8},"end":{"line":211,"column":8}},"80":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"81":{"start":{"line":218,"column":8},"end":{"line":218,"column":8}},"82":{"start":{"line":225,"column":8},"end":{"line":225,"column":8}},"83":{"start":{"line":226,"column":12},"end":{"line":228,"column":13}},"84":{"start":{"line":227,"column":16},"end":{"line":227,"column":16}},"85":{"start":{"line":231,"column":12},"end":{"line":231,"column":12}},"86":{"start":{"line":233,"column":12},"end":{"line":235,"column":13}},"87":{"start":{"line":234,"column":16},"end":{"line":234,"column":16}},"88":{"start":{"line":237,"column":12},"end":{"line":237,"column":12}},"89":{"start":{"line":249,"column":8},"end":{"line":249,"column":8}},"90":{"start":{"line":250,"column":12},"end":{"line":250,"column":12}},"91":{"start":{"line":252,"column":12},"end":{"line":252,"column":59}},"92":{"start":{"line":253,"column":12},"end":{"line":253,"column":12}},"93":{"start":{"line":260,"column":8},"end":{"line":260,"column":8}},"94":{"start":{"line":261,"column":12},"end":{"line":261,"column":12}},"95":{"start":{"line":262,"column":12},"end":{"line":268,"column":13}},"96":{"start":{"line":263,"column":16},"end":{"line":267,"column":17}},"97":{"start":{"line":264,"column":20},"end":{"line":264,"column":20}},"98":{"start":{"line":266,"column":20},"end":{"line":266,"column":20}},"99":{"start":{"line":270,"column":12},"end":{"line":270,"column":12}},"100":{"start":{"line":271,"column":12},"end":{"line":271,"column":12}},"101":{"start":{"line":272,"column":12},"end":{"line":272,"column":12}},"102":{"start":{"line":273,"column":12},"end":{"line":273,"column":12}},"103":{"start":{"line":274,"column":12},"end":{"line":274,"column":12}},"104":{"start":{"line":276,"column":12},"end":{"line":291,"column":13}},"105":{"start":{"line":277,"column":16},"end":{"line":277,"column":16}},"106":{"start":{"line":278,"column":16},"end":{"line":290,"column":17}},"107":{"start":{"line":279,"column":20},"end":{"line":279,"column":20}},"108":{"start":{"line":280,"column":20},"end":{"line":280,"column":20}},"109":{"start":{"line":282,"column":20},"end":{"line":282,"column":20}},"110":{"start":{"line":283,"column":20},"end":{"line":285,"column":21}},"111":{"start":{"line":284,"column":24},"end":{"line":284,"column":24}},"112":{"start":{"line":286,"column":20},"end":{"line":286,"column":20}},"113":{"start":{"line":288,"column":20},"end":{"line":288,"column":20}},"114":{"start":{"line":289,"column":20},"end":{"line":289,"column":20}},"115":{"start":{"line":292,"column":12},"end":{"line":292,"column":12}},"116":{"start":{"line":298,"column":8},"end":{"line":298,"column":8}},"117":{"start":{"line":299,"column":12},"end":{"line":299,"column":12}},"118":{"start":{"line":300,"column":12},"end":{"line":300,"column":12}},"119":{"start":{"line":303,"column":12},"end":{"line":316,"column":13}},"120":{"start":{"line":304,"column":16},"end":{"line":304,"column":16}},"121":{"start":{"line":305,"column":16},"end":{"line":305,"column":16}},"122":{"start":{"line":306,"column":16},"end":{"line":306,"column":16}},"123":{"start":{"line":307,"column":16},"end":{"line":309,"column":17}},"124":{"start":{"line":308,"column":20},"end":{"line":308,"column":20}},"125":{"start":{"line":311,"column":16},"end":{"line":313,"column":17}},"126":{"start":{"line":312,"column":20},"end":{"line":312,"column":20}},"127":{"start":{"line":314,"column":16},"end":{"line":314,"column":16}},"128":{"start":{"line":315,"column":16},"end":{"line":315,"column":16}},"129":{"start":{"line":317,"column":12},"end":{"line":339,"column":13}},"130":{"start":{"line":318,"column":16},"end":{"line":318,"column":16}},"131":{"start":{"line":319,"column":16},"end":{"line":321,"column":17}},"132":{"start":{"line":320,"column":20},"end":{"line":320,"column":20}},"133":{"start":{"line":322,"column":16},"end":{"line":322,"column":16}},"134":{"start":{"line":323,"column":16},"end":{"line":338,"column":17}},"135":{"start":{"line":324,"column":20},"end":{"line":324,"column":20}},"136":{"start":{"line":325,"column":20},"end":{"line":329,"column":21}},"137":{"start":{"line":326,"column":24},"end":{"line":326,"column":24}},"138":{"start":{"line":328,"column":24},"end":{"line":328,"column":24}},"139":{"start":{"line":330,"column":20},"end":{"line":337,"column":21}},"140":{"start":{"line":331,"column":24},"end":{"line":331,"column":24}},"141":{"start":{"line":336,"column":24},"end":{"line":336,"column":24}},"142":{"start":{"line":349,"column":8},"end":{"line":349,"column":8}},"143":{"start":{"line":350,"column":12},"end":{"line":350,"column":12}},"144":{"start":{"line":352,"column":12},"end":{"line":352,"column":12}},"145":{"start":{"line":353,"column":12},"end":{"line":355,"column":13}},"146":{"start":{"line":354,"column":16},"end":{"line":354,"column":16}},"147":{"start":{"line":356,"column":12},"end":{"line":356,"column":12}},"148":{"start":{"line":357,"column":12},"end":{"line":357,"column":12}},"149":{"start":{"line":358,"column":12},"end":{"line":358,"column":12}},"150":{"start":{"line":367,"column":8},"end":{"line":367,"column":8}},"151":{"start":{"line":368,"column":12},"end":{"line":370,"column":13}},"152":{"start":{"line":369,"column":16},"end":{"line":369,"column":16}},"153":{"start":{"line":371,"column":12},"end":{"line":375,"column":13}},"154":{"start":{"line":372,"column":16},"end":{"line":372,"column":16}},"155":{"start":{"line":374,"column":16},"end":{"line":374,"column":16}},"156":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"157":{"start":{"line":382,"column":25},"end":{"line":382,"column":25}},"158":{"start":{"line":382,"column":19},"end":{"line":382,"column":25}},"159":{"start":{"line":382,"column":25},"end":{"line":382,"column":25}},"160":{"start":{"line":385,"column":8},"end":{"line":385,"column":8}},"161":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"162":{"start":{"line":392,"column":19},"end":{"line":392,"column":19}},"163":{"start":{"line":393,"column":8},"end":{"line":393,"column":8}},"164":{"start":{"line":397,"column":8},"end":{"line":397,"column":8}},"165":{"start":{"line":398,"column":12},"end":{"line":398,"column":12}},"166":{"start":{"line":399,"column":12},"end":{"line":425,"column":13}},"167":{"start":{"line":400,"column":16},"end":{"line":400,"column":16}},"168":{"start":{"line":401,"column":16},"end":{"line":422,"column":17}},"169":{"start":{"line":402,"column":20},"end":{"line":408,"column":21}},"170":{"start":{"line":403,"column":24},"end":{"line":403,"column":24}},"171":{"start":{"line":405,"column":25},"end":{"line":408,"column":21}},"172":{"start":{"line":406,"column":24},"end":{"line":406,"column":24}},"173":{"start":{"line":407,"column":24},"end":{"line":407,"column":24}},"174":{"start":{"line":410,"column":20},"end":{"line":410,"column":20}},"175":{"start":{"line":411,"column":20},"end":{"line":421,"column":21}},"176":{"start":{"line":412,"column":24},"end":{"line":412,"column":24}},"177":{"start":{"line":414,"column":25},"end":{"line":421,"column":21}},"178":{"start":{"line":416,"column":24},"end":{"line":416,"column":24}},"179":{"start":{"line":418,"column":25},"end":{"line":421,"column":21}},"180":{"start":{"line":420,"column":24},"end":{"line":420,"column":24}},"181":{"start":{"line":424,"column":16},"end":{"line":424,"column":16}},"182":{"start":{"line":426,"column":12},"end":{"line":426,"column":12}},"183":{"start":{"line":432,"column":8},"end":{"line":432,"column":8}},"184":{"start":{"line":433,"column":8},"end":{"line":433,"column":8}},"185":{"start":{"line":434,"column":8},"end":{"line":434,"column":8}},"186":{"start":{"line":436,"column":8},"end":{"line":436,"column":8}},"187":{"start":{"line":439,"column":8},"end":{"line":459,"column":9}},"188":{"start":{"line":439,"column":58},"end":{"line":439,"column":58}},"189":{"start":{"line":440,"column":12},"end":{"line":440,"column":12}},"190":{"start":{"line":441,"column":12},"end":{"line":458,"column":13}},"191":{"start":{"line":442,"column":16},"end":{"line":444,"column":17}},"192":{"start":{"line":443,"column":20},"end":{"line":443,"column":20}},"193":{"start":{"line":445,"column":16},"end":{"line":445,"column":16}},"194":{"start":{"line":446,"column":16},"end":{"line":457,"column":17}},"195":{"start":{"line":447,"column":20},"end":{"line":447,"column":20}},"196":{"start":{"line":449,"column":20},"end":{"line":449,"column":20}},"197":{"start":{"line":450,"column":24},"end":{"line":450,"column":24}},"198":{"start":{"line":451,"column":24},"end":{"line":453,"column":25}},"199":{"start":{"line":452,"column":28},"end":{"line":452,"column":28}},"200":{"start":{"line":454,"column":24},"end":{"line":454,"column":24}},"201":{"start":{"line":456,"column":20},"end":{"line":456,"column":20}},"202":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"203":{"start":{"line":463,"column":8},"end":{"line":463,"column":8}},"204":{"start":{"line":464,"column":8},"end":{"line":464,"column":8}},"205":{"start":{"line":465,"column":8},"end":{"line":465,"column":8}},"206":{"start":{"line":466,"column":8},"end":{"line":466,"column":8}},"207":{"start":{"line":468,"column":8},"end":{"line":468,"column":8}},"208":{"start":{"line":469,"column":12},"end":{"line":469,"column":12}},"209":{"start":{"line":471,"column":12},"end":{"line":471,"column":12}},"210":{"start":{"line":473,"column":8},"end":{"line":473,"column":8}},"211":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"212":{"start":{"line":477,"column":8},"end":{"line":477,"column":8}},"213":{"start":{"line":479,"column":8},"end":{"line":479,"column":8}},"214":{"start":{"line":480,"column":12},"end":{"line":480,"column":12}},"215":{"start":{"line":482,"column":8},"end":{"line":482,"column":8}},"216":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"217":{"start":{"line":489,"column":8},"end":{"line":491,"column":9}},"218":{"start":{"line":490,"column":12},"end":{"line":490,"column":12}},"219":{"start":{"line":492,"column":8},"end":{"line":492,"column":8}},"220":{"start":{"line":493,"column":8},"end":{"line":493,"column":8}},"221":{"start":{"line":494,"column":8},"end":{"line":494,"column":8}},"222":{"start":{"line":495,"column":8},"end":{"line":495,"column":8}},"223":{"start":{"line":497,"column":8},"end":{"line":497,"column":8}},"224":{"start":{"line":498,"column":8},"end":{"line":505,"column":9}},"225":{"start":{"line":499,"column":12},"end":{"line":499,"column":12}},"226":{"start":{"line":500,"column":12},"end":{"line":500,"column":12}},"227":{"start":{"line":502,"column":12},"end":{"line":504,"column":13}},"228":{"start":{"line":503,"column":16},"end":{"line":503,"column":16}},"229":{"start":{"line":506,"column":8},"end":{"line":506,"column":8}},"230":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"231":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"232":{"start":{"line":511,"column":0},"end":{"line":511,"column":0}},"233":{"start":{"line":514,"column":0},"end":{"line":525,"column":1}},"234":{"start":{"line":515,"column":4},"end":{"line":515,"column":4}},"235":{"start":{"line":517,"column":4},"end":{"line":523,"column":5}},"236":{"start":{"line":518,"column":8},"end":{"line":518,"column":8}},"237":{"start":{"line":519,"column":8},"end":{"line":521,"column":9}},"238":{"start":{"line":520,"column":12},"end":{"line":520,"column":12}},"239":{"start":{"line":522,"column":8},"end":{"line":522,"column":8}},"240":{"start":{"line":524,"column":4},"end":{"line":524,"column":4}},"241":{"start":{"line":527,"column":0},"end":{"line":537,"column":1}},"242":{"start":{"line":528,"column":4},"end":{"line":528,"column":4}},"243":{"start":{"line":529,"column":4},"end":{"line":529,"column":4}},"244":{"start":{"line":530,"column":4},"end":{"line":536,"column":5}},"245":{"start":{"line":531,"column":8},"end":{"line":531,"column":8}},"246":{"start":{"line":532,"column":11},"end":{"line":536,"column":5}},"247":{"start":{"line":533,"column":8},"end":{"line":533,"column":8}},"248":{"start":{"line":535,"column":8},"end":{"line":535,"column":8}}},"branchMap":{"1":{"line":21,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"2":{"line":23,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"3":{"line":23,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"4":{"line":23,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"5":{"line":25,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"6":{"line":25,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"7":{"line":25,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"8":{"line":25,"type":"if","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"9":{"line":25,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"10":{"line":159,"type":"if","locations":[{"start":{"line":140,"column":8},"end":{"line":140,"column":8}},{"start":{"line":140,"column":8},"end":{"line":140,"column":8}}]},"11":{"line":166,"type":"if","locations":[{"start":{"line":147,"column":8},"end":{"line":147,"column":8}},{"start":{"line":147,"column":8},"end":{"line":147,"column":8}}]},"12":{"line":183,"type":"if","locations":[{"start":{"line":164,"column":12},"end":{"line":164,"column":12}},{"start":{"line":164,"column":12},"end":{"line":164,"column":12}}]},"13":{"line":192,"type":"if","locations":[{"start":{"line":173,"column":12},"end":{"line":173,"column":12}},{"start":{"line":173,"column":12},"end":{"line":173,"column":12}}]},"14":{"line":206,"type":"if","locations":[{"start":{"line":188,"column":8},"end":{"line":188,"column":8}},{"start":{"line":188,"column":8},"end":{"line":188,"column":8}}]},"15":{"line":250,"type":"if","locations":[{"start":{"line":226,"column":12},"end":{"line":226,"column":12}},{"start":{"line":226,"column":12},"end":{"line":226,"column":12}}]},"16":{"line":255,"type":"binary-expr","locations":[{"start":{"line":231,"column":21},"end":{"line":231,"column":21}},{"start":{"line":231,"column":35},"end":{"line":231,"column":12}}]},"17":{"line":257,"type":"binary-expr","locations":[{"start":{"line":233,"column":19},"end":{"line":233,"column":19}},{"start":{"line":233,"column":46},"end":{"line":233,"column":12}}]},"18":{"line":261,"type":"cond-expr","locations":[{"start":{"line":239,"column":20},"end":{"line":238,"column":16}},{"start":{"line":239,"column":53},"end":{"line":237,"column":12}}]},"19":{"line":274,"type":"binary-expr","locations":[{"start":{"line":252,"column":24},"end":{"line":252,"column":24}},{"start":{"line":252,"column":44},"end":{"line":252,"column":12}}]},"20":{"line":284,"type":"if","locations":[{"start":{"line":262,"column":12},"end":{"line":262,"column":12}},{"start":{"line":262,"column":12},"end":{"line":262,"column":12}}]},"21":{"line":285,"type":"if","locations":[{"start":{"line":263,"column":16},"end":{"line":263,"column":16}},{"start":{"line":263,"column":16},"end":{"line":263,"column":16}}]},"22":{"line":294,"type":"binary-expr","locations":[{"start":{"line":272,"column":28},"end":{"line":272,"column":28}},{"start":{"line":272,"column":42},"end":{"line":272,"column":12}}]},"23":{"line":301,"type":"if","locations":[{"start":{"line":278,"column":16},"end":{"line":278,"column":16}},{"start":{"line":278,"column":16},"end":{"line":278,"column":16}}]},"24":{"line":301,"type":"binary-expr","locations":[{"start":{"line":278,"column":20},"end":{"line":278,"column":20}},{"start":{"line":278,"column":49},"end":{"line":278,"column":16}}]},"25":{"line":305,"type":"if","locations":[{"start":{"line":283,"column":20},"end":{"line":283,"column":20}},{"start":{"line":283,"column":20},"end":{"line":283,"column":20}}]},"26":{"line":327,"type":"if","locations":[{"start":{"line":303,"column":12},"end":{"line":303,"column":12}},{"start":{"line":303,"column":12},"end":{"line":303,"column":12}}]},"27":{"line":327,"type":"binary-expr","locations":[{"start":{"line":303,"column":16},"end":{"line":303,"column":16}},{"start":{"line":303,"column":34},"end":{"line":303,"column":12}}]},"28":{"line":335,"type":"if","locations":[{"start":{"line":311,"column":16},"end":{"line":311,"column":16}},{"start":{"line":311,"column":16},"end":{"line":311,"column":16}}]},"29":{"line":343,"type":"if","locations":[{"start":{"line":319,"column":16},"end":{"line":319,"column":16}},{"start":{"line":319,"column":16},"end":{"line":319,"column":16}}]},"30":{"line":347,"type":"if","locations":[{"start":{"line":323,"column":16},"end":{"line":323,"column":16}},{"start":{"line":323,"column":16},"end":{"line":323,"column":16}}]},"31":{"line":347,"type":"binary-expr","locations":[{"start":{"line":323,"column":20},"end":{"line":323,"column":20}},{"start":{"line":323,"column":41},"end":{"line":323,"column":16}}]},"32":{"line":348,"type":"binary-expr","locations":[{"start":{"line":324,"column":26},"end":{"line":324,"column":26}},{"start":{"line":324,"column":44},"end":{"line":324,"column":20}}]},"33":{"line":349,"type":"if","locations":[{"start":{"line":325,"column":20},"end":{"line":325,"column":20}},{"start":{"line":325,"column":20},"end":{"line":325,"column":20}}]},"34":{"line":353,"type":"if","locations":[{"start":{"line":330,"column":20},"end":{"line":330,"column":20}},{"start":{"line":330,"column":20},"end":{"line":330,"column":20}}]},"35":{"line":354,"type":"cond-expr","locations":[{"start":{"line":333,"column":32},"end":{"line":332,"column":29}},{"start":{"line":334,"column":32},"end":{"line":331,"column":40}}]},"36":{"line":373,"type":"if","locations":[{"start":{"line":353,"column":12},"end":{"line":353,"column":12}},{"start":{"line":353,"column":12},"end":{"line":353,"column":12}}]},"37":{"line":373,"type":"binary-expr","locations":[{"start":{"line":353,"column":16},"end":{"line":353,"column":16}},{"start":{"line":353,"column":32},"end":{"line":353,"column":12}}]},"38":{"line":388,"type":"if","locations":[{"start":{"line":368,"column":12},"end":{"line":368,"column":12}},{"start":{"line":368,"column":12},"end":{"line":368,"column":12}}]},"39":{"line":391,"type":"if","locations":[{"start":{"line":371,"column":12},"end":{"line":371,"column":12}},{"start":{"line":371,"column":12},"end":{"line":371,"column":12}}]},"40":{"line":433,"type":"if","locations":[{"start":{"line":399,"column":12},"end":{"line":399,"column":12}},{"start":{"line":399,"column":12},"end":{"line":399,"column":12}}]},"41":{"line":435,"type":"if","locations":[{"start":{"line":401,"column":16},"end":{"line":401,"column":16}},{"start":{"line":401,"column":16},"end":{"line":401,"column":16}}]},"42":{"line":436,"type":"if","locations":[{"start":{"line":402,"column":20},"end":{"line":402,"column":20}},{"start":{"line":402,"column":20},"end":{"line":402,"column":20}}]},"43":{"line":438,"type":"if","locations":[{"start":{"line":405,"column":25},"end":{"line":405,"column":25}},{"start":{"line":405,"column":25},"end":{"line":405,"column":25}}]},"44":{"line":439,"type":"binary-expr","locations":[{"start":{"line":406,"column":38},"end":{"line":406,"column":38}},{"start":{"line":406,"column":57},"end":{"line":406,"column":24}}]},"45":{"line":444,"type":"if","locations":[{"start":{"line":411,"column":20},"end":{"line":411,"column":20}},{"start":{"line":411,"column":20},"end":{"line":411,"column":20}}]},"46":{"line":446,"type":"if","locations":[{"start":{"line":414,"column":25},"end":{"line":414,"column":25}},{"start":{"line":414,"column":25},"end":{"line":414,"column":25}}]},"47":{"line":446,"type":"binary-expr","locations":[{"start":{"line":414,"column":29},"end":{"line":414,"column":29}},{"start":{"line":415,"column":24},"end":{"line":414,"column":25}}]},"48":{"line":448,"type":"if","locations":[{"start":{"line":418,"column":25},"end":{"line":418,"column":25}},{"start":{"line":418,"column":25},"end":{"line":418,"column":25}}]},"49":{"line":469,"type":"if","locations":[{"start":{"line":439,"column":8},"end":{"line":439,"column":8}},{"start":{"line":439,"column":8},"end":{"line":439,"column":8}}]},"50":{"line":469,"type":"binary-expr","locations":[{"start":{"line":439,"column":12},"end":{"line":439,"column":12}},{"start":{"line":439,"column":30},"end":{"line":439,"column":8}}]},"51":{"line":473,"type":"if","locations":[{"start":{"line":442,"column":16},"end":{"line":442,"column":16}},{"start":{"line":442,"column":16},"end":{"line":442,"column":16}}]},"52":{"line":477,"type":"if","locations":[{"start":{"line":446,"column":16},"end":{"line":446,"column":16}},{"start":{"line":446,"column":16},"end":{"line":446,"column":16}}]},"53":{"line":482,"type":"if","locations":[{"start":{"line":451,"column":24},"end":{"line":451,"column":24}},{"start":{"line":451,"column":24},"end":{"line":451,"column":24}}]},"54":{"line":497,"type":"binary-expr","locations":[{"start":{"line":465,"column":21},"end":{"line":465,"column":21}},{"start":{"line":465,"column":68},"end":{"line":465,"column":8}}]},"55":{"line":503,"type":"cond-expr","locations":[{"start":{"line":471,"column":40},"end":{"line":471,"column":19}},{"start":{"line":471,"column":68},"end":{"line":471,"column":12}}]},"56":{"line":509,"type":"cond-expr","locations":[{"start":{"line":477,"column":62},"end":{"line":477,"column":44}},{"start":{"line":477,"column":67},"end":{"line":477,"column":12}}]},"57":{"line":523,"type":"if","locations":[{"start":{"line":489,"column":8},"end":{"line":489,"column":8}},{"start":{"line":489,"column":8},"end":{"line":489,"column":8}}]},"58":{"line":536,"type":"if","locations":[{"start":{"line":502,"column":12},"end":{"line":502,"column":12}},{"start":{"line":502,"column":12},"end":{"line":502,"column":12}}]},"59":{"line":568,"type":"if","locations":[{"start":{"line":530,"column":4},"end":{"line":530,"column":4}},{"start":{"line":530,"column":4},"end":{"line":530,"column":4}}]},"60":{"line":570,"type":"if","locations":[{"start":{"line":532,"column":11},"end":{"line":532,"column":11}},{"start":{"line":532,"column":11},"end":{"line":532,"column":11}}]}},"code":["import {Feature} from '../../feature';","import {isUndef, isObj, EMPTY_FN} from '../../types';","import {createElm, elm, tag} from '../../dom';","import {addEvt, bound} from '../../event';","import {parse as parseNb} from '../../number';","import {","    NONE, CELL_TAG, HEADER_TAG, STRING, NUMBER, DATE, FORMATTED_NUMBER,","    IP_ADDRESS","} from '../../const';","import {defaultsStr, defaultsFn, defaultsArr} from '../../settings';","","/**"," * SortableTable Adapter module"," */","export default class AdapterSortableTable extends Feature {","","    /**","     * Creates an instance of AdapterSortableTable","     * @param {TableFilter} tf TableFilter instance","     * @param {Object} opts Configuration object","     */","    constructor(tf, opts) {","        super(tf, AdapterSortableTable);","","        /**","         * Module name","         * @type {String}","         */","        this.name = opts.name;","","        /**","         * Module description","         * @type {String}","         */","        this.desc = defaultsStr(opts.description, 'Sortable table');","","        /**","         * Indicate whether table previously sorted","         * @type {Boolean}","         * @private","         */","        this.sorted = false;","","        /**","         * List of sort type per column basis","         * @type {Array}","         */","        this.sortTypes = defaultsArr(opts.types, tf.colTypes);","","        /**","         * Column to be sorted at initialization, ie:","         * sort_col_at_start: [1, true]","         * @type {Array}","         */","        this.sortColAtStart = defaultsArr(opts.sort_col_at_start, null);","","        /**","         * Enable asynchronous sort, if triggers are external","         * @type {Boolean}","         */","        this.asyncSort = Boolean(opts.async_sort);","","        /**","         * List of element IDs triggering sort on a per column basis","         * @type {Array}","         */","        this.triggerIds = defaultsArr(opts.trigger_ids, []);","","        // edit .sort-arrow.descending / .sort-arrow.ascending in","        // tablefilter.css to reflect any path change","        /**","         * Path to images","         * @type {String}","         */","        this.imgPath = defaultsStr(opts.images_path, tf.themesPath);","","        /**","         * Blank image file name","         * @type {String}","         */","        this.imgBlank = defaultsStr(opts.image_blank, 'blank.png');","","        /**","         * Css class for sort indicator image","         * @type {String}","         */","        this.imgClassName = defaultsStr(opts.image_class_name, 'sort-arrow');","","        /**","         * Css class for ascending sort indicator image","         * @type {String}","         */","        this.imgAscClassName = defaultsStr(opts.image_asc_class_name,","            'ascending');","","        /**","         * Css class for descending sort indicator image","         * @type {String}","         */","        this.imgDescClassName = defaultsStr(opts.image_desc_class_name,","            'descending');","","        /**","         * Cell attribute key storing custom value used for sorting","         * @type {String}","         */","        this.customKey = defaultsStr(opts.custom_key, 'data-tf-sortKey');","","        /**","         * Callback fired when sort extension is instanciated","         * @type {Function}","         */","        this.onSortLoaded = defaultsFn(opts.on_sort_loaded, EMPTY_FN);","","        /**","         * Callback fired before a table column is sorted","         * @type {Function}","         */","        this.onBeforeSort = defaultsFn(opts.on_before_sort, EMPTY_FN);","","        /**","         * Callback fired after a table column is sorted","         * @type {Function}","         */","        this.onAfterSort = defaultsFn(opts.on_after_sort, EMPTY_FN);","","        /**","         * SortableTable instance","         * @private","         */","        this.stt = null;","","        this.enable();","    }","","    /**","     * Initializes AdapterSortableTable instance","     */","    init() {","        if (this.initialized) {","            return;","        }","        let tf = this.tf;","        let adpt = this;","","        // SortableTable class sanity check (sortabletable.js)","        if (isUndef(SortableTable)) {","            throw new Error('SortableTable class not found.');","        }","","        // Add any date format if needed","        this.emitter.emit('add-date-type-formats', this.tf, this.sortTypes);","","        this.overrideSortableTable();","        this.setSortTypes();","","        this.onSortLoaded(tf, this);","","        /*** SortableTable callbacks ***/","        this.stt.onbeforesort = function () {","            adpt.onBeforeSort(tf, adpt.stt.sortColumn);","","            /*** sort behaviour for paging ***/","            if (tf.paging) {","                tf.feature('paging').disable();","            }","        };","","        this.stt.onsort = function () {","            adpt.sorted = true;","","            //sort behaviour for paging","            if (tf.paging) {","                let paginator = tf.feature('paging');","                // recalculate valid rows index as sorting may have change it","                tf.getValidRows(true);","                paginator.enable();","                paginator.setPage(paginator.getPage());","            }","","            adpt.onAfterSort(tf, adpt.stt.sortColumn, adpt.stt.descending);","            adpt.emitter.emit('column-sorted', tf, adpt.stt.sortColumn,","                adpt.stt.descending);","        };","","        // Column sort at start","        let sortColAtStart = adpt.sortColAtStart;","        if (sortColAtStart) {","            this.stt.sort(sortColAtStart[0], sortColAtStart[1]);","        }","","        this.emitter.on(['sort'], bound(this.sortByColumnIndexHandler, this));","","        /** @inherited */","        this.initialized = true;","","        this.emitter.emit('sort-initialized', tf, this);","    }","","    /**","     * Sort specified column","     * @param {Number} colIdx Column index","     * @param {Boolean} desc Optional: descending manner","     */","    sortByColumnIndex(colIdx, desc) {","        this.stt.sort(colIdx, desc);","    }","","    /** @private */","    sortByColumnIndexHandler(tf, colIdx, desc) {","        this.sortByColumnIndex(colIdx, desc);","    }","","    /**","     * Set SortableTable overrides for TableFilter integration","     */","    overrideSortableTable() {","        let adpt = this,","            tf = this.tf;","","        /**","         * Overrides headerOnclick method in order to handle th event","         * @param  {Object} e [description]","         */","        SortableTable.prototype.headerOnclick = function (evt) {","            if (!adpt.initialized) {","                return;","            }","","            // find Header element","            let el = evt.target || evt.srcElement;","","            while (el.tagName !== CELL_TAG && el.tagName !== HEADER_TAG) {","                el = el.parentNode;","            }","","            this.sort(","                SortableTable.msie ?","                    SortableTable.getCellIndex(el) : el.cellIndex","            );","        };","","        /**","         * Overrides getCellIndex IE returns wrong cellIndex when columns are","         * hidden","         * @param  {Object} oTd TD element","         * @return {Number}     Cell index","         */","        SortableTable.getCellIndex = function (oTd) {","            let cells = oTd.parentNode.cells,","                l = cells.length, i;","            for (i = 0; cells[i] !== oTd && i < l; i++) { }","            return i;","        };","","        /**","         * Overrides initHeader in order to handle filters row position","         * @param  {Array} oSortTypes","         */","        SortableTable.prototype.initHeader = function (oSortTypes) {","            let stt = this;","            if (!stt.tHead) {","                if (tf.gridLayout) {","                    stt.tHead = tf.feature('gridLayout').headTbl.tHead;","                } else {","                    return;","                }","            }","","            stt.headersRow = tf.headersRow;","            let cells = stt.tHead.rows[stt.headersRow].cells;","            stt.sortTypes = oSortTypes || [];","            let l = cells.length;","            let img, c;","","            for (let i = 0; i < l; i++) {","                c = cells[i];","                if (stt.sortTypes[i] !== null && stt.sortTypes[i] !== 'None') {","                    c.style.cursor = 'pointer';","                    img = createElm('img',","                        ['src', adpt.imgPath + adpt.imgBlank]);","                    c.appendChild(img);","                    if (stt.sortTypes[i] !== null) {","                        c.setAttribute('_sortType', stt.sortTypes[i]);","                    }","                    addEvt(c, 'click', stt._headerOnclick);","                } else {","                    c.setAttribute('_sortType', oSortTypes[i]);","                    c._sortType = 'None';","                }","            }","            stt.updateHeaderArrows();","        };","","        /**","         * Overrides updateHeaderArrows in order to handle arrows indicators","         */","        SortableTable.prototype.updateHeaderArrows = function () {","            let stt = this;","            let cells, l, img;","","            // external headers","            if (adpt.asyncSort && adpt.triggerIds.length > 0) {","                let triggers = adpt.triggerIds;","                cells = [];","                l = triggers.length;","                for (let j = 0; j < l; j++) {","                    cells.push(elm(triggers[j]));","                }","            } else {","                if (!this.tHead) {","                    return;","                }","                cells = stt.tHead.rows[stt.headersRow].cells;","                l = cells.length;","            }","            for (let i = 0; i < l; i++) {","                let cell = cells[i];","                if (!cell) {","                    continue;","                }","                let cellAttr = cell.getAttribute('_sortType');","                if (cellAttr !== null && cellAttr !== 'None') {","                    img = cell.lastChild || cell;","                    if (img.nodeName.toLowerCase() !== 'img') {","                        img = createElm('img',","                            ['src', adpt.imgPath + adpt.imgBlank]);","                        cell.appendChild(img);","                    }","                    if (i === stt.sortColumn) {","                        img.className = adpt.imgClassName + ' ' +","                            (this.descending ?","                                adpt.imgDescClassName :","                                adpt.imgAscClassName);","                    } else {","                        img.className = adpt.imgClassName;","                    }","                }","            }","        };","","        /**","         * Overrides getRowValue for custom key value feature","         * @param  {Object} oRow    Row element","         * @param  {String} sType","         * @param  {Number} nColumn","         * @return {String}","         */","        SortableTable.prototype.getRowValue = function (oRow, sType, nColumn) {","            let stt = this;","            // if we have defined a custom getRowValue use that","            let sortTypeInfo = stt._sortTypeInfo[sType];","            if (sortTypeInfo && sortTypeInfo.getRowValue) {","                return sortTypeInfo.getRowValue(oRow, nColumn);","            }","            let c = oRow.cells[nColumn];","            let s = SortableTable.getInnerText(c);","            return stt.getValueFromString(s, sType);","        };","","        /**","         * Overrides getInnerText in order to avoid Firefox unexpected sorting","         * behaviour with untrimmed text elements","         * @param  {Object} cell DOM element","         * @return {String}       DOM element inner text","         */","        SortableTable.getInnerText = function (cell) {","            if (!cell) {","                return;","            }","            if (cell.getAttribute(adpt.customKey)) {","                return cell.getAttribute(adpt.customKey);","            } else {","                return tf.getCellValue(cell);","            }","        };","    }","","    /**","     * Adds a sort type","     */","    addSortType(...args) {","        // Extract the arguments","        let [id, caster, sorter, getRowValue] = args;","        SortableTable.prototype.addSortType(id, caster, sorter, getRowValue);","    }","","    /**","     * Sets the sort types on a column basis","     * @private","     */","    setSortTypes() {","        let tf = this.tf,","            sortTypes = this.sortTypes,","            _sortTypes = [];","","        tf.eachCol((i) => {","            let colType;","            if (sortTypes[i]) {","                colType = sortTypes[i];","                if (isObj(colType)) {","                    if (colType.type === DATE) {","                        colType = this._addDateType(i, sortTypes);","                    }","                    else if (colType.type === FORMATTED_NUMBER) {","                        let decimal = colType.decimal || tf.decimalSeparator;","                        colType = this._addNumberType(i, decimal);","                    }","                } else {","                    colType = colType.toLowerCase();","                    if (colType === DATE) {","                        colType = this._addDateType(i, sortTypes);","                    }","                    else if (colType === FORMATTED_NUMBER ||","                        colType === NUMBER) {","                        colType = this._addNumberType(i, tf.decimalSeparator);","                    }","                    else if (colType === NONE) {","                        // TODO: normalise 'none' vs 'None'","                        colType = 'None';","                    }","                }","            } else {","                colType = STRING;","            }","            _sortTypes.push(colType);","        });","","        //Public TF method to add sort type","","        //Custom sort types","        this.addSortType('caseinsensitivestring', SortableTable.toUpperCase);","        this.addSortType(STRING);","        this.addSortType(IP_ADDRESS, ipAddress, sortIP);","","        this.stt = new SortableTable(tf.dom(), _sortTypes);","","        /*** external table headers adapter ***/","        if (this.asyncSort && this.triggerIds.length > 0) {","            let triggers = this.triggerIds;","            for (let j = 0; j < triggers.length; j++) {","                if (triggers[j] === null) {","                    continue;","                }","                let trigger = elm(triggers[j]);","                if (trigger) {","                    trigger.style.cursor = 'pointer';","","                    addEvt(trigger, 'click', (evt) => {","                        let elm = evt.target;","                        if (!this.tf.sort) {","                            return;","                        }","                        this.stt.asyncSort(triggers.indexOf(elm.id));","                    });","                    trigger.setAttribute('_sortType', _sortTypes[j]);","                }","            }","        }","    }","","    _addDateType(colIndex, types) {","        let tf = this.tf;","        let dateType = tf.feature('dateType');","        let locale = dateType.getOptions(colIndex, types).locale || tf.locale;","        let colType = `${DATE}-${locale}`;","","        this.addSortType(colType, (value) => {","            let parsedDate = dateType.parse(value, locale);","            // Invalid date defaults to Wed Feb 04 -768 11:00:00","            return isNaN(+parsedDate) ? new Date(-86400000000000) : parsedDate;","        });","        return colType;","    }","","    _addNumberType(colIndex, decimal) {","        let colType = `${FORMATTED_NUMBER}${decimal === '.' ? '' : '-custom'}`;","","        this.addSortType(colType, (value) => {","            return parseNb(value, decimal);","        });","        return colType;","    }","","    /**","     * Remove extension","     */","    destroy() {","        if (!this.initialized) {","            return;","        }","        let tf = this.tf;","        this.emitter.off(['sort'], bound(this.sortByColumnIndexHandler, this));","        this.sorted = false;","        this.stt.destroy();","","        let ids = tf.getFiltersId();","        for (let idx = 0; idx < ids.length; idx++) {","            let header = tf.getHeaderElement(idx);","            let img = tag(header, 'img');","","            if (img.length === 1) {","                header.removeChild(img[0]);","            }","        }","        this.initialized = false;","    }","","}","","AdapterSortableTable.meta = {altName: 'sort'};","","//Converters","function ipAddress(value) {","    let vals = value.split('.');","    // eslint-disable-next-line no-unused-vars","    for (let x in vals) {","        let val = vals[x];","        while (3 > val.length) {","            val = '0' + val;","        }","        vals[x] = val;","    }","    return vals.join('.');","}","","function sortIP(a, b) {","    let aa = ipAddress(a.value.toLowerCase());","    let bb = ipAddress(b.value.toLowerCase());","    if (aa === bb) {","        return 0;","    } else if (aa < bb) {","        return -1;","    } else {","        return 1;","    }","}",""]};
}
__cov_LyI3jxXOy1lYGCWCsfZRUw = __cov_LyI3jxXOy1lYGCWCsfZRUw['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\sort\\adapterSortabletable.js'];
__cov_LyI3jxXOy1lYGCWCsfZRUw.s['1']++;Object.defineProperty(exports,'__esModule',{value:true});__cov_LyI3jxXOy1lYGCWCsfZRUw.s['2']++;var _feature=__webpack_require__(/*! ../../feature */ "./src/feature.js");__cov_LyI3jxXOy1lYGCWCsfZRUw.s['3']++;var _types=__webpack_require__(/*! ../../types */ "./src/types.js");__cov_LyI3jxXOy1lYGCWCsfZRUw.s['4']++;var _dom=__webpack_require__(/*! ../../dom */ "./src/dom.js");__cov_LyI3jxXOy1lYGCWCsfZRUw.s['5']++;var _event=__webpack_require__(/*! ../../event */ "./src/event.js");__cov_LyI3jxXOy1lYGCWCsfZRUw.s['6']++;var _number=__webpack_require__(/*! ../../number */ "./src/number.js");__cov_LyI3jxXOy1lYGCWCsfZRUw.s['7']++;var _const=__webpack_require__(/*! ../../const */ "./src/const.js");__cov_LyI3jxXOy1lYGCWCsfZRUw.s['8']++;var _settings=__webpack_require__(/*! ../../settings */ "./src/settings.js");function _classCallCheck(instance,Constructor){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['1']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['10']++;if(!(instance instanceof Constructor)){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['1'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['11']++;throw new TypeError('Cannot call a class as a function');}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['1'][1]++;}}function _possibleConstructorReturn(self,call){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['2']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['13']++;if(!self){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['2'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['14']++;throw new ReferenceError('this hasn\'t been initialised - super() hasn\'t been called');}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['2'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['15']++;return(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['4'][0]++,call)&&((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['4'][1]++,typeof call==='object')||(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['4'][2]++,typeof call==='function'))?(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['3'][0]++,call):(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['3'][1]++,self);}function _inherits(subClass,superClass){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['3']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['17']++;if((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['6'][0]++,typeof superClass!=='function')&&(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['6'][1]++,superClass!==null)){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['5'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['18']++;throw new TypeError('Super expression must either be null or a function, not '+typeof superClass);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['5'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['19']++;subClass.prototype=Object.create((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['7'][0]++,superClass)&&(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['7'][1]++,superClass.prototype),{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});__cov_LyI3jxXOy1lYGCWCsfZRUw.s['20']++;if(superClass){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['8'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['21']++;Object.setPrototypeOf?(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['9'][0]++,Object.setPrototypeOf(subClass,superClass)):(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['9'][1]++,subClass.__proto__=superClass);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['8'][1]++;}}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['22']++;var AdapterSortableTable=function(_Feature){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['4']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['23']++;_inherits(AdapterSortableTable,_Feature);function AdapterSortableTable(tf,opts){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['5']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['25']++;_classCallCheck(this,AdapterSortableTable);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['26']++;var _this=_possibleConstructorReturn(this,_Feature.call(this,tf,AdapterSortableTable));__cov_LyI3jxXOy1lYGCWCsfZRUw.s['27']++;_this.name=opts.name;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['28']++;_this.desc=(0,_settings.defaultsStr)(opts.description,'Sortable table');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['29']++;_this.sorted=false;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['30']++;_this.sortTypes=(0,_settings.defaultsArr)(opts.types,tf.colTypes);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['31']++;_this.sortColAtStart=(0,_settings.defaultsArr)(opts.sort_col_at_start,null);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['32']++;_this.asyncSort=Boolean(opts.async_sort);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['33']++;_this.triggerIds=(0,_settings.defaultsArr)(opts.trigger_ids,[]);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['34']++;_this.imgPath=(0,_settings.defaultsStr)(opts.images_path,tf.themesPath);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['35']++;_this.imgBlank=(0,_settings.defaultsStr)(opts.image_blank,'blank.png');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['36']++;_this.imgClassName=(0,_settings.defaultsStr)(opts.image_class_name,'sort-arrow');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['37']++;_this.imgAscClassName=(0,_settings.defaultsStr)(opts.image_asc_class_name,'ascending');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['38']++;_this.imgDescClassName=(0,_settings.defaultsStr)(opts.image_desc_class_name,'descending');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['39']++;_this.customKey=(0,_settings.defaultsStr)(opts.custom_key,'data-tf-sortKey');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['40']++;_this.onSortLoaded=(0,_settings.defaultsFn)(opts.on_sort_loaded,_types.EMPTY_FN);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['41']++;_this.onBeforeSort=(0,_settings.defaultsFn)(opts.on_before_sort,_types.EMPTY_FN);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['42']++;_this.onAfterSort=(0,_settings.defaultsFn)(opts.on_after_sort,_types.EMPTY_FN);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['43']++;_this.stt=null;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['44']++;_this.enable();__cov_LyI3jxXOy1lYGCWCsfZRUw.s['45']++;return _this;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['46']++;AdapterSortableTable.prototype.init=function init(){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['6']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['47']++;if(this.initialized){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['10'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['48']++;return;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['10'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['49']++;var tf=this.tf;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['50']++;var adpt=this;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['51']++;if((0,_types.isUndef)(SortableTable)){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['11'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['52']++;throw new Error('SortableTable class not found.');}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['11'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['53']++;this.emitter.emit('add-date-type-formats',this.tf,this.sortTypes);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['54']++;this.overrideSortableTable();__cov_LyI3jxXOy1lYGCWCsfZRUw.s['55']++;this.setSortTypes();__cov_LyI3jxXOy1lYGCWCsfZRUw.s['56']++;this.onSortLoaded(tf,this);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['57']++;this.stt.onbeforesort=function(){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['7']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['58']++;adpt.onBeforeSort(tf,adpt.stt.sortColumn);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['59']++;if(tf.paging){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['12'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['60']++;tf.feature('paging').disable();}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['12'][1]++;}};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['61']++;this.stt.onsort=function(){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['8']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['62']++;adpt.sorted=true;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['63']++;if(tf.paging){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['13'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['64']++;var paginator=tf.feature('paging');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['65']++;tf.getValidRows(true);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['66']++;paginator.enable();__cov_LyI3jxXOy1lYGCWCsfZRUw.s['67']++;paginator.setPage(paginator.getPage());}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['13'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['68']++;adpt.onAfterSort(tf,adpt.stt.sortColumn,adpt.stt.descending);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['69']++;adpt.emitter.emit('column-sorted',tf,adpt.stt.sortColumn,adpt.stt.descending);};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['70']++;var sortColAtStart=adpt.sortColAtStart;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['71']++;if(sortColAtStart){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['14'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['72']++;this.stt.sort(sortColAtStart[0],sortColAtStart[1]);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['14'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['73']++;this.emitter.on(['sort'],(0,_event.bound)(this.sortByColumnIndexHandler,this));__cov_LyI3jxXOy1lYGCWCsfZRUw.s['74']++;this.initialized=true;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['75']++;this.emitter.emit('sort-initialized',tf,this);};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['76']++;AdapterSortableTable.prototype.sortByColumnIndex=function sortByColumnIndex(colIdx,desc){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['9']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['77']++;this.stt.sort(colIdx,desc);};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['78']++;AdapterSortableTable.prototype.sortByColumnIndexHandler=function sortByColumnIndexHandler(tf,colIdx,desc){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['10']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['79']++;this.sortByColumnIndex(colIdx,desc);};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['80']++;AdapterSortableTable.prototype.overrideSortableTable=function overrideSortableTable(){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['11']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['81']++;var adpt=this,tf=this.tf;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['82']++;SortableTable.prototype.headerOnclick=function(evt){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['12']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['83']++;if(!adpt.initialized){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['15'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['84']++;return;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['15'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['85']++;var el=(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['16'][0]++,evt.target)||(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['16'][1]++,evt.srcElement);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['86']++;while((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['17'][0]++,el.tagName!==_const.CELL_TAG)&&(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['17'][1]++,el.tagName!==_const.HEADER_TAG)){__cov_LyI3jxXOy1lYGCWCsfZRUw.s['87']++;el=el.parentNode;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['88']++;this.sort(SortableTable.msie?(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['18'][0]++,SortableTable.getCellIndex(el)):(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['18'][1]++,el.cellIndex));};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['89']++;SortableTable.getCellIndex=function(oTd){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['13']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['90']++;var cells=oTd.parentNode.cells,l=cells.length,i=void 0;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['91']++;for(i=0;(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['19'][0]++,cells[i]!==oTd)&&(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['19'][1]++,i<l);i++){}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['92']++;return i;};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['93']++;SortableTable.prototype.initHeader=function(oSortTypes){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['14']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['94']++;var stt=this;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['95']++;if(!stt.tHead){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['20'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['96']++;if(tf.gridLayout){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['21'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['97']++;stt.tHead=tf.feature('gridLayout').headTbl.tHead;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['21'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['98']++;return;}}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['20'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['99']++;stt.headersRow=tf.headersRow;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['100']++;var cells=stt.tHead.rows[stt.headersRow].cells;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['101']++;stt.sortTypes=(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['22'][0]++,oSortTypes)||(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['22'][1]++,[]);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['102']++;var l=cells.length;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['103']++;var img=void 0,c=void 0;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['104']++;for(var i=0;i<l;i++){__cov_LyI3jxXOy1lYGCWCsfZRUw.s['105']++;c=cells[i];__cov_LyI3jxXOy1lYGCWCsfZRUw.s['106']++;if((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['24'][0]++,stt.sortTypes[i]!==null)&&(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['24'][1]++,stt.sortTypes[i]!=='None')){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['23'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['107']++;c.style.cursor='pointer';__cov_LyI3jxXOy1lYGCWCsfZRUw.s['108']++;img=(0,_dom.createElm)('img',['src',adpt.imgPath+adpt.imgBlank]);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['109']++;c.appendChild(img);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['110']++;if(stt.sortTypes[i]!==null){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['25'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['111']++;c.setAttribute('_sortType',stt.sortTypes[i]);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['25'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['112']++;(0,_event.addEvt)(c,'click',stt._headerOnclick);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['23'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['113']++;c.setAttribute('_sortType',oSortTypes[i]);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['114']++;c._sortType='None';}}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['115']++;stt.updateHeaderArrows();};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['116']++;SortableTable.prototype.updateHeaderArrows=function(){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['15']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['117']++;var stt=this;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['118']++;var cells=void 0,l=void 0,img=void 0;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['119']++;if((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['27'][0]++,adpt.asyncSort)&&(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['27'][1]++,adpt.triggerIds.length>0)){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['26'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['120']++;var triggers=adpt.triggerIds;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['121']++;cells=[];__cov_LyI3jxXOy1lYGCWCsfZRUw.s['122']++;l=triggers.length;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['123']++;for(var j=0;j<l;j++){__cov_LyI3jxXOy1lYGCWCsfZRUw.s['124']++;cells.push((0,_dom.elm)(triggers[j]));}}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['26'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['125']++;if(!this.tHead){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['28'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['126']++;return;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['28'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['127']++;cells=stt.tHead.rows[stt.headersRow].cells;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['128']++;l=cells.length;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['129']++;for(var i=0;i<l;i++){__cov_LyI3jxXOy1lYGCWCsfZRUw.s['130']++;var cell=cells[i];__cov_LyI3jxXOy1lYGCWCsfZRUw.s['131']++;if(!cell){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['29'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['132']++;continue;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['29'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['133']++;var cellAttr=cell.getAttribute('_sortType');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['134']++;if((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['31'][0]++,cellAttr!==null)&&(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['31'][1]++,cellAttr!=='None')){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['30'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['135']++;img=(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['32'][0]++,cell.lastChild)||(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['32'][1]++,cell);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['136']++;if(img.nodeName.toLowerCase()!=='img'){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['33'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['137']++;img=(0,_dom.createElm)('img',['src',adpt.imgPath+adpt.imgBlank]);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['138']++;cell.appendChild(img);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['33'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['139']++;if(i===stt.sortColumn){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['34'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['140']++;img.className=adpt.imgClassName+' '+(this.descending?(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['35'][0]++,adpt.imgDescClassName):(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['35'][1]++,adpt.imgAscClassName));}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['34'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['141']++;img.className=adpt.imgClassName;}}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['30'][1]++;}}};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['142']++;SortableTable.prototype.getRowValue=function(oRow,sType,nColumn){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['16']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['143']++;var stt=this;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['144']++;var sortTypeInfo=stt._sortTypeInfo[sType];__cov_LyI3jxXOy1lYGCWCsfZRUw.s['145']++;if((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['37'][0]++,sortTypeInfo)&&(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['37'][1]++,sortTypeInfo.getRowValue)){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['36'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['146']++;return sortTypeInfo.getRowValue(oRow,nColumn);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['36'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['147']++;var c=oRow.cells[nColumn];__cov_LyI3jxXOy1lYGCWCsfZRUw.s['148']++;var s=SortableTable.getInnerText(c);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['149']++;return stt.getValueFromString(s,sType);};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['150']++;SortableTable.getInnerText=function(cell){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['17']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['151']++;if(!cell){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['38'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['152']++;return;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['38'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['153']++;if(cell.getAttribute(adpt.customKey)){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['39'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['154']++;return cell.getAttribute(adpt.customKey);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['39'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['155']++;return tf.getCellValue(cell);}};};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['156']++;AdapterSortableTable.prototype.addSortType=function addSortType(){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['18']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['157']++;for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++){__cov_LyI3jxXOy1lYGCWCsfZRUw.s['158']++;args[_key]=arguments[_key];}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['159']++;var id=args[0],caster=args[1],sorter=args[2],getRowValue=args[3];__cov_LyI3jxXOy1lYGCWCsfZRUw.s['160']++;SortableTable.prototype.addSortType(id,caster,sorter,getRowValue);};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['161']++;AdapterSortableTable.prototype.setSortTypes=function setSortTypes(){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['19']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['162']++;var _this2=this;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['163']++;var tf=this.tf,sortTypes=this.sortTypes,_sortTypes=[];__cov_LyI3jxXOy1lYGCWCsfZRUw.s['164']++;tf.eachCol(function(i){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['20']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['165']++;var colType=void 0;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['166']++;if(sortTypes[i]){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['40'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['167']++;colType=sortTypes[i];__cov_LyI3jxXOy1lYGCWCsfZRUw.s['168']++;if((0,_types.isObj)(colType)){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['41'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['169']++;if(colType.type===_const.DATE){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['42'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['170']++;colType=_this2._addDateType(i,sortTypes);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['42'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['171']++;if(colType.type===_const.FORMATTED_NUMBER){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['43'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['172']++;var decimal=(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['44'][0]++,colType.decimal)||(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['44'][1]++,tf.decimalSeparator);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['173']++;colType=_this2._addNumberType(i,decimal);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['43'][1]++;}}}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['41'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['174']++;colType=colType.toLowerCase();__cov_LyI3jxXOy1lYGCWCsfZRUw.s['175']++;if(colType===_const.DATE){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['45'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['176']++;colType=_this2._addDateType(i,sortTypes);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['45'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['177']++;if((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['47'][0]++,colType===_const.FORMATTED_NUMBER)||(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['47'][1]++,colType===_const.NUMBER)){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['46'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['178']++;colType=_this2._addNumberType(i,tf.decimalSeparator);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['46'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['179']++;if(colType===_const.NONE){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['48'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['180']++;colType='None';}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['48'][1]++;}}}}}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['40'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['181']++;colType=_const.STRING;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['182']++;_sortTypes.push(colType);});__cov_LyI3jxXOy1lYGCWCsfZRUw.s['183']++;this.addSortType('caseinsensitivestring',SortableTable.toUpperCase);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['184']++;this.addSortType(_const.STRING);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['185']++;this.addSortType(_const.IP_ADDRESS,ipAddress,sortIP);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['186']++;this.stt=new SortableTable(tf.dom(),_sortTypes);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['187']++;if((__cov_LyI3jxXOy1lYGCWCsfZRUw.b['50'][0]++,this.asyncSort)&&(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['50'][1]++,this.triggerIds.length>0)){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['49'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['188']++;(function(){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['21']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['189']++;var triggers=_this2.triggerIds;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['190']++;for(var j=0;j<triggers.length;j++){__cov_LyI3jxXOy1lYGCWCsfZRUw.s['191']++;if(triggers[j]===null){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['51'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['192']++;continue;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['51'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['193']++;var trigger=(0,_dom.elm)(triggers[j]);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['194']++;if(trigger){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['52'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['195']++;trigger.style.cursor='pointer';__cov_LyI3jxXOy1lYGCWCsfZRUw.s['196']++;(0,_event.addEvt)(trigger,'click',function(evt){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['22']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['197']++;var elm=evt.target;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['198']++;if(!_this2.tf.sort){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['53'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['199']++;return;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['53'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['200']++;_this2.stt.asyncSort(triggers.indexOf(elm.id));});__cov_LyI3jxXOy1lYGCWCsfZRUw.s['201']++;trigger.setAttribute('_sortType',_sortTypes[j]);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['52'][1]++;}}}());}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['49'][1]++;}};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['202']++;AdapterSortableTable.prototype._addDateType=function _addDateType(colIndex,types){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['23']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['203']++;var tf=this.tf;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['204']++;var dateType=tf.feature('dateType');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['205']++;var locale=(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['54'][0]++,dateType.getOptions(colIndex,types).locale)||(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['54'][1]++,tf.locale);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['206']++;var colType=_const.DATE+'-'+locale;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['207']++;this.addSortType(colType,function(value){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['24']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['208']++;var parsedDate=dateType.parse(value,locale);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['209']++;return isNaN(+parsedDate)?(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['55'][0]++,new Date(-86400000000000)):(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['55'][1]++,parsedDate);});__cov_LyI3jxXOy1lYGCWCsfZRUw.s['210']++;return colType;};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['211']++;AdapterSortableTable.prototype._addNumberType=function _addNumberType(colIndex,decimal){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['25']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['212']++;var colType=''+_const.FORMATTED_NUMBER+(decimal==='.'?(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['56'][0]++,''):(__cov_LyI3jxXOy1lYGCWCsfZRUw.b['56'][1]++,'-custom'));__cov_LyI3jxXOy1lYGCWCsfZRUw.s['213']++;this.addSortType(colType,function(value){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['26']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['214']++;return(0,_number.parse)(value,decimal);});__cov_LyI3jxXOy1lYGCWCsfZRUw.s['215']++;return colType;};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['216']++;AdapterSortableTable.prototype.destroy=function destroy(){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['27']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['217']++;if(!this.initialized){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['57'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['218']++;return;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['57'][1]++;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['219']++;var tf=this.tf;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['220']++;this.emitter.off(['sort'],(0,_event.bound)(this.sortByColumnIndexHandler,this));__cov_LyI3jxXOy1lYGCWCsfZRUw.s['221']++;this.sorted=false;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['222']++;this.stt.destroy();__cov_LyI3jxXOy1lYGCWCsfZRUw.s['223']++;var ids=tf.getFiltersId();__cov_LyI3jxXOy1lYGCWCsfZRUw.s['224']++;for(var idx=0;idx<ids.length;idx++){__cov_LyI3jxXOy1lYGCWCsfZRUw.s['225']++;var header=tf.getHeaderElement(idx);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['226']++;var img=(0,_dom.tag)(header,'img');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['227']++;if(img.length===1){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['58'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['228']++;header.removeChild(img[0]);}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['58'][1]++;}}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['229']++;this.initialized=false;};__cov_LyI3jxXOy1lYGCWCsfZRUw.s['230']++;return AdapterSortableTable;}(_feature.Feature);__cov_LyI3jxXOy1lYGCWCsfZRUw.s['231']++;exports.default=AdapterSortableTable;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['232']++;AdapterSortableTable.meta={altName:'sort'};function ipAddress(value){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['28']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['234']++;var vals=value.split('.');__cov_LyI3jxXOy1lYGCWCsfZRUw.s['235']++;for(var x in vals){__cov_LyI3jxXOy1lYGCWCsfZRUw.s['236']++;var val=vals[x];__cov_LyI3jxXOy1lYGCWCsfZRUw.s['237']++;while(3>val.length){__cov_LyI3jxXOy1lYGCWCsfZRUw.s['238']++;val='0'+val;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['239']++;vals[x]=val;}__cov_LyI3jxXOy1lYGCWCsfZRUw.s['240']++;return vals.join('.');}function sortIP(a,b){__cov_LyI3jxXOy1lYGCWCsfZRUw.f['29']++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['242']++;var aa=ipAddress(a.value.toLowerCase());__cov_LyI3jxXOy1lYGCWCsfZRUw.s['243']++;var bb=ipAddress(b.value.toLowerCase());__cov_LyI3jxXOy1lYGCWCsfZRUw.s['244']++;if(aa===bb){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['59'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['245']++;return 0;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['59'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['246']++;if(aa<bb){__cov_LyI3jxXOy1lYGCWCsfZRUw.b['60'][0]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['247']++;return-1;}else{__cov_LyI3jxXOy1lYGCWCsfZRUw.b['60'][1]++;__cov_LyI3jxXOy1lYGCWCsfZRUw.s['248']++;return 1;}}}


/***/ }),

/***/ "./src/extensions/sort/sort.js":
/*!*************************************!*\
  !*** ./src/extensions/sort/sort.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __cov_D7h5JSaDMKp1iDADX_oA4g = (Function('return this'))();
if (!__cov_D7h5JSaDMKp1iDADX_oA4g.__coverage__) { __cov_D7h5JSaDMKp1iDADX_oA4g.__coverage__ = {}; }
__cov_D7h5JSaDMKp1iDADX_oA4g = __cov_D7h5JSaDMKp1iDADX_oA4g.__coverage__;
if (!(__cov_D7h5JSaDMKp1iDADX_oA4g['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\sort\\sort.js'])) {
   __cov_D7h5JSaDMKp1iDADX_oA4g['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\sort\\sort.js'] = {"path":"C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\sort\\sort.js","s":{"1":0,"2":0,"3":0,"4":0,"5":1,"6":0,"7":0,"8":0,"9":0},"b":{"1":[0,0],"2":[0,0],"3":[0,0]},"f":{"1":0},"fnMap":{"1":{"name":"_interopRequireDefault","line":13,"loc":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"skip":true}},"statementMap":{"1":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"2":{"start":{"line":1,"column":0},"end":{"line":1,"column":0}},"3":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"4":{"start":{"line":2,"column":0},"end":{"line":2,"column":0}},"5":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"6":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},"7":{"start":{"line":4,"column":0},"end":{"line":6,"column":1}},"8":{"start":{"line":5,"column":4},"end":{"line":5,"column":4}},"9":{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}},"branchMap":{"1":{"line":13,"type":"cond-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"2":{"line":13,"type":"binary-expr","locations":[{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true},{"start":{"line":0,"column":0},"end":{"line":0,"column":0},"skip":true}]},"3":{"line":15,"type":"if","locations":[{"start":{"line":4,"column":0},"end":{"line":4,"column":0}},{"start":{"line":4,"column":0},"end":{"line":4,"column":0}}]}},"code":["import AdapterSortableTable from './adapterSortabletable';","import {root} from '../../root';","","if (!root.SortableTable) {","    require('script-loader!sortabletable');","}","","export default AdapterSortableTable;",""]};
}
__cov_D7h5JSaDMKp1iDADX_oA4g = __cov_D7h5JSaDMKp1iDADX_oA4g['C:\\projects\\dev\\github\\TableFilter\\src\\extensions\\sort\\sort.js'];
__cov_D7h5JSaDMKp1iDADX_oA4g.s['1']++;Object.defineProperty(exports,'__esModule',{value:true});__cov_D7h5JSaDMKp1iDADX_oA4g.s['2']++;var _adapterSortabletable=__webpack_require__(/*! ./adapterSortabletable */ "./src/extensions/sort/adapterSortabletable.js");__cov_D7h5JSaDMKp1iDADX_oA4g.s['3']++;var _adapterSortabletable2=_interopRequireDefault(_adapterSortabletable);__cov_D7h5JSaDMKp1iDADX_oA4g.s['4']++;var _root=__webpack_require__(/*! ../../root */ "./src/root.js");function _interopRequireDefault(obj){__cov_D7h5JSaDMKp1iDADX_oA4g.f['1']++;__cov_D7h5JSaDMKp1iDADX_oA4g.s['6']++;return(__cov_D7h5JSaDMKp1iDADX_oA4g.b['2'][0]++,obj)&&(__cov_D7h5JSaDMKp1iDADX_oA4g.b['2'][1]++,obj.__esModule)?(__cov_D7h5JSaDMKp1iDADX_oA4g.b['1'][0]++,obj):(__cov_D7h5JSaDMKp1iDADX_oA4g.b['1'][1]++,{default:obj});}__cov_D7h5JSaDMKp1iDADX_oA4g.s['7']++;if(!_root.root.SortableTable){__cov_D7h5JSaDMKp1iDADX_oA4g.b['3'][0]++;__cov_D7h5JSaDMKp1iDADX_oA4g.s['8']++;__webpack_require__(/*! script-loader!sortabletable */ "./node_modules/script-loader/index.js!./libs/sortabletable.js");}else{__cov_D7h5JSaDMKp1iDADX_oA4g.b['3'][1]++;}__cov_D7h5JSaDMKp1iDADX_oA4g.s['9']++;exports.default=_adapterSortabletable2.default;


/***/ })

}]);
//# sourceMappingURL=tf-0-9d0f2f7840b2a1cccbd0.js.map